README={}
README['str'] = 
"# Getting Codepages\n\nThe fields of the `pages.csv` manifest are `codepage,url,bytes` (SBCS=1, DBCS=2)\n\nNote that the Windows rendering is used for the Mac code pages.  The primary\ndifference is the use of the private `0xF8FF` code (which renders as an Apple\nlogo on macs but as garbage on other operating systems).  It may be desirable\nto fall back to the behavior, in which case the files are under APPLE and not\nMICSFT.  This affects codepages 10000, 10006, 10007, 10029, 10079, 10081\n\nThe numbering scheme for the `ISO-8859-X` series is `28590 + X`:\n\n## Generated Codepages\n\nThe following codepages are available in .NET on Windows:\n\n- 708   Arabic (ASMO 708)\n- 720   Arabic (Transparent ASMO); Arabic (DOS)\n- 858   OEM Multilingual Latin 1 + Euro symbol\n- 870   IBM EBCDIC Multilingual/ROECE (Latin 2); IBM EBCDIC Multilingual Latin 2\n- 1047  IBM EBCDIC Latin 1/Open System\n- 1140  IBM EBCDIC US-Canada (037 + Euro symbol); IBM EBCDIC (US-Canada-Euro)\n- 1141  IBM EBCDIC Germany (20273 + Euro symbol); IBM EBCDIC (Germany-Euro)\n- 1142  IBM EBCDIC Denmark-Norway (20277 + Euro symbol); IBM EBCDIC (Denmark-Norway-Euro)\n- 1143  IBM EBCDIC Finland-Sweden (20278 + Euro symbol); IBM EBCDIC (Finland-Sweden-Euro)\n- 1144  IBM EBCDIC Italy (20280 + Euro symbol); IBM EBCDIC (Italy-Euro)\n- 1145  IBM EBCDIC Latin America-Spain (20284 + Euro symbol); IBM EBCDIC (Spain-Euro)\n- 1146  IBM EBCDIC United Kingdom (20285 + Euro symbol); IBM EBCDIC (UK-Euro)\n- 1147  IBM EBCDIC France (20297 + Euro symbol); IBM EBCDIC (France-Euro)\n- 1148  IBM EBCDIC International (500 + Euro symbol); IBM EBCDIC (International-Euro)\n- 1149  IBM EBCDIC Icelandic (20871 + Euro symbol); IBM EBCDIC (Icelandic-Euro)\n- 1361  Korean (Johab)\n- 10001 Japanese (Mac)\n- 10002 MAC Traditional Chinese (Big5); Chinese Traditional (Mac)\n- 10003 Korean (Mac)\n- 10004 Arabic (Mac)\n- 10005 Hebrew (Mac)\n- 10008 MAC Simplified Chinese (GB 2312); Chinese Simplified (Mac)\n- 10010 Romanian (Mac)\n- 10017 Ukrainian (Mac)\n- 10021 Thai (Mac)\n- 10082 Croatian (Mac)\n- 20000 CNS Taiwan; Chinese Traditional (CNS)\n- 20001 TCA Taiwan\n- 20002 ETEN Taiwan; Chinese Traditional (ETEN)\n- 20003 IBM5550 Taiwan\n- 20004 TeleText Taiwan\n- 20005 Wang Taiwan\n- 20105 IA5 (IRV International Alphabet No. 5, 7-bit); Western European (IA5)\n- 20106 IA5 German (7-bit)\n- 20107 IA5 Swedish (7-bit)\n- 20108 IA5 Norwegian (7-bit)\n- 20261 T.61\n- 20269 ISO 6937 Non-Spacing Accent\n- 20273 IBM EBCDIC Germany\n- 20277 IBM EBCDIC Denmark-Norway\n- 20278 IBM EBCDIC Finland-Sweden\n- 20280 IBM EBCDIC Italy\n- 20284 IBM EBCDIC Latin America-Spain\n- 20285 IBM EBCDIC United Kingdom\n- 20290 IBM EBCDIC Japanese Katakana Extended\n- 20297 IBM EBCDIC France\n- 20420 IBM EBCDIC Arabic\n- 20423 IBM EBCDIC Greek\n- 20424 IBM EBCDIC Hebrew\n- 20833 IBM EBCDIC Korean Extended\n- 20838 IBM EBCDIC Thai\n- 20866 Russian (KOI8-R); Cyrillic (KOI8-R)\n- 20871 IBM EBCDIC Icelandic\n- 20880 IBM EBCDIC Cyrillic Russian\n- 20905 IBM EBCDIC Turkish\n- 20924 IBM EBCDIC Latin 1/Open System (1047 + Euro symbol)\n- 20932 Japanese (JIS 0208-1990 and 0212-1990)\n- 20936 Simplified Chinese (GB2312); Chinese Simplified (GB2312-80)\n- 20949 Korean Wansung\n- 21025 IBM EBCDIC Cyrillic Serbian-Bulgarian\n- 21027 Extended/Ext Alpha Lowercase\n- 21866 Ukrainian (KOI8-U); Cyrillic (KOI8-U)\n- 29001 Europa 3\n- 38598 ISO 8859-8 Hebrew; Hebrew (ISO-Logical)\n- 51932 EUC Japanese\n- 51936 EUC Simplified Chinese; Chinese Simplified (EUC)\n- 51949 EUC Korean\n- 52936 HZ-GB2312 Simplified Chinese; Chinese Simplified (HZ)\n- 54936 Windows XP and later: GB18030 Simplified Chinese (4 byte); Chinese Simplified (GB18030)\n- 57002 ISCII Devanagari\n- 57003 ISCII Bengali\n- 57004 ISCII Tamil\n- 57005 ISCII Telugu\n- 57006 ISCII Assamese\n- 57007 ISCII Oriya\n- 57008 ISCII Kannada\n- 57009 ISCII Malayalam\n- 57010 ISCII Gujarati\n- 57011 ISCII Punjabi\n\nThe following codepages are dependencies for Visual FoxPro:\n\n- 620 Mazovia (Polish) MS-DOS\n- 895 Kamenický (Czech) MS-DOS\n\n## Building Notes\n\nThe script `make.sh` (described later) will get these files and massage the data\n(printing code-Unicode pairs).  The eventual tables are dropped in the paths\n`./codepages/<CODEPAGE>.TBL`.  For example, the last 10 lines of `10000.TBL` are\n\n```>\n0xF6\t0x02C6\n0xF7\t0x02DC\n0xF8\t0x00AF\n0xF9\t0x02D8\n0xFA\t0x02D9\n0xFB\t0x02DA\n0xFC\t0x00B8\n0xFD\t0x02DD\n0xFE\t0x02DB\n0xFF\t0x02C7\n```\n\nwhich implies that code `0xF6` is `String.fromCharCode(0x02C6)` and vice versa.\n\n## Windows-dependent build step\n\nTo build the sources on windows, consult `dotnet/MakeEncoding.cs`.\n\nAfter saving standard output to `out`, the `dotnet.sh` script processes results. \n\n# Building the script\n\n`make.njs` takes a codepage argument, reads the corresponding table file and\ngenerates JS code for encoding and decoding:\n\n## Raw Codepages\n\nThe DBCS and SBCS code generation strategies are different.  The maximum code is\nused to distinguish (max `0xFF` for SBCS).\n\nThe Unicode character `0xFFFD` (REPLACEMENT CHARACTER) is used as a placeholder\nfor characters that are not specified in the map (for example, `0xF0` is not in\ncode page 10000).\n\nFor SBCS, the idea is to embed a raw string with the contents of the 256 codes.\nThe `dec` field is merely a split of the string, and `enc` is an eversion:\n\nDBCS is similar, except that the space is sliced in chunks of 256 bytes (strings\nare only generated for those high-bytes represented in the codepage).\n\nThe strategy is to construct an array-of-arrays so that `dd[high][low]` is the\ncharacter associated with the code.  This array is combined at runtime to yield\nthe complete decoding object (and the encoding object is an eversion):\n\n`make.sh` generates the tables used by `make.njs`.  The raw Unicode TXT files\nare columnar: `code unicode #comments`.  For example, the last 10 lines of the\ntext file `ROMAN.TXT` (for CP 10000) are:\n\n```>\n0xF6\t0x02C6\t#MODIFIER LETTER CIRCUMFLEX ACCENT\n0xF7\t0x02DC\t#SMALL TILDE\n0xF8\t0x00AF\t#MACRON\n0xF9\t0x02D8\t#BREVE\n0xFA\t0x02D9\t#DOT ABOVE\n0xFB\t0x02DA\t#RING ABOVE\n0xFC\t0x00B8\t#CEDILLA\n0xFD\t0x02DD\t#DOUBLE ACUTE ACCENT\n0xFE\t0x02DB\t#OGONEK\n0xFF\t0x02C7\t#CARON\n```\n\nIn processing the data, the comments (after the `#`) are stripped and undefined\nelements (like `0x7F` for CP 10000) are removed.\n\n## Utilities\n\nThe encode and decode functions are kept in a separate script (`cputils.js`).\n\nBoth encode and decode deal with data represented as:\n\n- String (encode expects JS string, decode interprets UCS2 chars as codes)\n- Array (encode expects array of JS String characters, decode expects numbers)\n- Buffer (encode expects UTF-8 string, decode expects codepoints/bytes).\n\nThe `ofmt` variable controls `encode` output (`str`, `arr` respectively)\nwhile the input format is automatically determined.\n\n# Nitty Gritty\n\n```>.vocrc\n{ \"post\": \"make js\" }\n```\n"
;
README['ascii'] = 
{"type":"Buffer","data":[35,32,71,101,116,116,105,110,103,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,102,105,101,108,100,115,32,111,102,32,116,104,101,32,96,112,97,103,101,115,46,99,115,118,96,32,109,97,110,105,102,101,115,116,32,97,114,101,32,96,99,111,100,101,112,97,103,101,44,117,114,108,44,98,121,116,101,115,96,32,40,83,66,67,83,61,49,44,32,68,66,67,83,61,50,41,10,10,78,111,116,101,32,116,104,97,116,32,116,104,101,32,87,105,110,100,111,119,115,32,114,101,110,100,101,114,105,110,103,32,105,115,32,117,115,101,100,32,102,111,114,32,116,104,101,32,77,97,99,32,99,111,100,101,32,112,97,103,101,115,46,32,32,84,104,101,32,112,114,105,109,97,114,121,10,100,105,102,102,101,114,101,110,99,101,32,105,115,32,116,104,101,32,117,115,101,32,111,102,32,116,104,101,32,112,114,105,118,97,116,101,32,96,48,120,70,56,70,70,96,32,99,111,100,101,32,40,119,104,105,99,104,32,114,101,110,100,101,114,115,32,97,115,32,97,110,32,65,112,112,108,101,10,108,111,103,111,32,111,110,32,109,97,99,115,32,98,117,116,32,97,115,32,103,97,114,98,97,103,101,32,111,110,32,111,116,104,101,114,32,111,112,101,114,97,116,105,110,103,32,115,121,115,116,101,109,115,41,46,32,32,73,116,32,109,97,121,32,98,101,32,100,101,115,105,114,97,98,108,101,10,116,111,32,102,97,108,108,32,98,97,99,107,32,116,111,32,116,104,101,32,98,101,104,97,118,105,111,114,44,32,105,110,32,119,104,105,99,104,32,99,97,115,101,32,116,104,101,32,102,105,108,101,115,32,97,114,101,32,117,110,100,101,114,32,65,80,80,76,69,32,97,110,100,32,110,111,116,10,77,73,67,83,70,84,46,32,32,84,104,105,115,32,97,102,102,101,99,116,115,32,99,111,100,101,112,97,103,101,115,32,49,48,48,48,48,44,32,49,48,48,48,54,44,32,49,48,48,48,55,44,32,49,48,48,50,57,44,32,49,48,48,55,57,44,32,49,48,48,56,49,10,10,84,104,101,32,110,117,109,98,101,114,105,110,103,32,115,99,104,101,109,101,32,102,111,114,32,116,104,101,32,96,73,83,79,45,56,56,53,57,45,88,96,32,115,101,114,105,101,115,32,105,115,32,96,50,56,53,57,48,32,43,32,88,96,58,10,10,35,35,32,71,101,110,101,114,97,116,101,100,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,102,111,108,108,111,119,105,110,103,32,99,111,100,101,112,97,103,101,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,32,105,110,32,46,78,69,84,32,111,110,32,87,105,110,100,111,119,115,58,10,10,45,32,55,48,56,32,32,32,65,114,97,98,105,99,32,40,65,83,77,79,32,55,48,56,41,10,45,32,55,50,48,32,32,32,65,114,97,98,105,99,32,40,84,114,97,110,115,112,97,114,101,110,116,32,65,83,77,79,41,59,32,65,114,97,98,105,99,32,40,68,79,83,41,10,45,32,56,53,56,32,32,32,79,69,77,32,77,117,108,116,105,108,105,110,103,117,97,108,32,76,97,116,105,110,32,49,32,43,32,69,117,114,111,32,115,121,109,98,111,108,10,45,32,56,55,48,32,32,32,73,66,77,32,69,66,67,68,73,67,32,77,117,108,116,105,108,105,110,103,117,97,108,47,82,79,69,67,69,32,40,76,97,116,105,110,32,50,41,59,32,73,66,77,32,69,66,67,68,73,67,32,77,117,108,116,105,108,105,110,103,117,97,108,32,76,97,116,105,110,32,50,10,45,32,49,48,52,55,32,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,49,47,79,112,101,110,32,83,121,115,116,101,109,10,45,32,49,49,52,48,32,32,73,66,77,32,69,66,67,68,73,67,32,85,83,45,67,97,110,97,100,97,32,40,48,51,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,85,83,45,67,97,110,97,100,97,45,69,117,114,111,41,10,45,32,49,49,52,49,32,32,73,66,77,32,69,66,67,68,73,67,32,71,101,114,109,97,110,121,32,40,50,48,50,55,51,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,71,101,114,109,97,110,121,45,69,117,114,111,41,10,45,32,49,49,52,50,32,32,73,66,77,32,69,66,67,68,73,67,32,68,101,110,109,97,114,107,45,78,111,114,119,97,121,32,40,50,48,50,55,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,68,101,110,109,97,114,107,45,78,111,114,119,97,121,45,69,117,114,111,41,10,45,32,49,49,52,51,32,32,73,66,77,32,69,66,67,68,73,67,32,70,105,110,108,97,110,100,45,83,119,101,100,101,110,32,40,50,48,50,55,56,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,70,105,110,108,97,110,100,45,83,119,101,100,101,110,45,69,117,114,111,41,10,45,32,49,49,52,52,32,32,73,66,77,32,69,66,67,68,73,67,32,73,116,97,108,121,32,40,50,48,50,56,48,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,73,116,97,108,121,45,69,117,114,111,41,10,45,32,49,49,52,53,32,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,65,109,101,114,105,99,97,45,83,112,97,105,110,32,40,50,48,50,56,52,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,83,112,97,105,110,45,69,117,114,111,41,10,45,32,49,49,52,54,32,32,73,66,77,32,69,66,67,68,73,67,32,85,110,105,116,101,100,32,75,105,110,103,100,111,109,32,40,50,48,50,56,53,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,85,75,45,69,117,114,111,41,10,45,32,49,49,52,55,32,32,73,66,77,32,69,66,67,68,73,67,32,70,114,97,110,99,101,32,40,50,48,50,57,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,70,114,97,110,99,101,45,69,117,114,111,41,10,45,32,49,49,52,56,32,32,73,66,77,32,69,66,67,68,73,67,32,73,110,116,101,114,110,97,116,105,111,110,97,108,32,40,53,48,48,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,73,110,116,101,114,110,97,116,105,111,110,97,108,45,69,117,114,111,41,10,45,32,49,49,52,57,32,32,73,66,77,32,69,66,67,68,73,67,32,73,99,101,108,97,110,100,105,99,32,40,50,48,56,55,49,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,73,99,101,108,97,110,100,105,99,45,69,117,114,111,41,10,45,32,49,51,54,49,32,32,75,111,114,101,97,110,32,40,74,111,104,97,98,41,10,45,32,49,48,48,48,49,32,74,97,112,97,110,101,115,101,32,40,77,97,99,41,10,45,32,49,48,48,48,50,32,77,65,67,32,84,114,97,100,105,116,105,111,110,97,108,32,67,104,105,110,101,115,101,32,40,66,105,103,53,41,59,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,77,97,99,41,10,45,32,49,48,48,48,51,32,75,111,114,101,97,110,32,40,77,97,99,41,10,45,32,49,48,48,48,52,32,65,114,97,98,105,99,32,40,77,97,99,41,10,45,32,49,48,48,48,53,32,72,101,98,114,101,119,32,40,77,97,99,41,10,45,32,49,48,48,48,56,32,77,65,67,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,71,66,32,50,51,49,50,41,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,77,97,99,41,10,45,32,49,48,48,49,48,32,82,111,109,97,110,105,97,110,32,40,77,97,99,41,10,45,32,49,48,48,49,55,32,85,107,114,97,105,110,105,97,110,32,40,77,97,99,41,10,45,32,49,48,48,50,49,32,84,104,97,105,32,40,77,97,99,41,10,45,32,49,48,48,56,50,32,67,114,111,97,116,105,97,110,32,40,77,97,99,41,10,45,32,50,48,48,48,48,32,67,78,83,32,84,97,105,119,97,110,59,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,67,78,83,41,10,45,32,50,48,48,48,49,32,84,67,65,32,84,97,105,119,97,110,10,45,32,50,48,48,48,50,32,69,84,69,78,32,84,97,105,119,97,110,59,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,69,84,69,78,41,10,45,32,50,48,48,48,51,32,73,66,77,53,53,53,48,32,84,97,105,119,97,110,10,45,32,50,48,48,48,52,32,84,101,108,101,84,101,120,116,32,84,97,105,119,97,110,10,45,32,50,48,48,48,53,32,87,97,110,103,32,84,97,105,119,97,110,10,45,32,50,48,49,48,53,32,73,65,53,32,40,73,82,86,32,73,110,116,101,114,110,97,116,105,111,110,97,108,32,65,108,112,104,97,98,101,116,32,78,111,46,32,53,44,32,55,45,98,105,116,41,59,32,87,101,115,116,101,114,110,32,69,117,114,111,112,101,97,110,32,40,73,65,53,41,10,45,32,50,48,49,48,54,32,73,65,53,32,71,101,114,109,97,110,32,40,55,45,98,105,116,41,10,45,32,50,48,49,48,55,32,73,65,53,32,83,119,101,100,105,115,104,32,40,55,45,98,105,116,41,10,45,32,50,48,49,48,56,32,73,65,53,32,78,111,114,119,101,103,105,97,110,32,40,55,45,98,105,116,41,10,45,32,50,48,50,54,49,32,84,46,54,49,10,45,32,50,48,50,54,57,32,73,83,79,32,54,57,51,55,32,78,111,110,45,83,112,97,99,105,110,103,32,65,99,99,101,110,116,10,45,32,50,48,50,55,51,32,73,66,77,32,69,66,67,68,73,67,32,71,101,114,109,97,110,121,10,45,32,50,48,50,55,55,32,73,66,77,32,69,66,67,68,73,67,32,68,101,110,109,97,114,107,45,78,111,114,119,97,121,10,45,32,50,48,50,55,56,32,73,66,77,32,69,66,67,68,73,67,32,70,105,110,108,97,110,100,45,83,119,101,100,101,110,10,45,32,50,48,50,56,48,32,73,66,77,32,69,66,67,68,73,67,32,73,116,97,108,121,10,45,32,50,48,50,56,52,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,65,109,101,114,105,99,97,45,83,112,97,105,110,10,45,32,50,48,50,56,53,32,73,66,77,32,69,66,67,68,73,67,32,85,110,105,116,101,100,32,75,105,110,103,100,111,109,10,45,32,50,48,50,57,48,32,73,66,77,32,69,66,67,68,73,67,32,74,97,112,97,110,101,115,101,32,75,97,116,97,107,97,110,97,32,69,120,116,101,110,100,101,100,10,45,32,50,48,50,57,55,32,73,66,77,32,69,66,67,68,73,67,32,70,114,97,110,99,101,10,45,32,50,48,52,50,48,32,73,66,77,32,69,66,67,68,73,67,32,65,114,97,98,105,99,10,45,32,50,48,52,50,51,32,73,66,77,32,69,66,67,68,73,67,32,71,114,101,101,107,10,45,32,50,48,52,50,52,32,73,66,77,32,69,66,67,68,73,67,32,72,101,98,114,101,119,10,45,32,50,48,56,51,51,32,73,66,77,32,69,66,67,68,73,67,32,75,111,114,101,97,110,32,69,120,116,101,110,100,101,100,10,45,32,50,48,56,51,56,32,73,66,77,32,69,66,67,68,73,67,32,84,104,97,105,10,45,32,50,48,56,54,54,32,82,117,115,115,105,97,110,32,40,75,79,73,56,45,82,41,59,32,67,121,114,105,108,108,105,99,32,40,75,79,73,56,45,82,41,10,45,32,50,48,56,55,49,32,73,66,77,32,69,66,67,68,73,67,32,73,99,101,108,97,110,100,105,99,10,45,32,50,48,56,56,48,32,73,66,77,32,69,66,67,68,73,67,32,67,121,114,105,108,108,105,99,32,82,117,115,115,105,97,110,10,45,32,50,48,57,48,53,32,73,66,77,32,69,66,67,68,73,67,32,84,117,114,107,105,115,104,10,45,32,50,48,57,50,52,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,49,47,79,112,101,110,32,83,121,115,116,101,109,32,40,49,48,52,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,10,45,32,50,48,57,51,50,32,74,97,112,97,110,101,115,101,32,40,74,73,83,32,48,50,48,56,45,49,57,57,48,32,97,110,100,32,48,50,49,50,45,49,57,57,48,41,10,45,32,50,48,57,51,54,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,71,66,50,51,49,50,41,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,71,66,50,51,49,50,45,56,48,41,10,45,32,50,48,57,52,57,32,75,111,114,101,97,110,32,87,97,110,115,117,110,103,10,45,32,50,49,48,50,53,32,73,66,77,32,69,66,67,68,73,67,32,67,121,114,105,108,108,105,99,32,83,101,114,98,105,97,110,45,66,117,108,103,97,114,105,97,110,10,45,32,50,49,48,50,55,32,69,120,116,101,110,100,101,100,47,69,120,116,32,65,108,112,104,97,32,76,111,119,101,114,99,97,115,101,10,45,32,50,49,56,54,54,32,85,107,114,97,105,110,105,97,110,32,40,75,79,73,56,45,85,41,59,32,67,121,114,105,108,108,105,99,32,40,75,79,73,56,45,85,41,10,45,32,50,57,48,48,49,32,69,117,114,111,112,97,32,51,10,45,32,51,56,53,57,56,32,73,83,79,32,56,56,53,57,45,56,32,72,101,98,114,101,119,59,32,72,101,98,114,101,119,32,40,73,83,79,45,76,111,103,105,99,97,108,41,10,45,32,53,49,57,51,50,32,69,85,67,32,74,97,112,97,110,101,115,101,10,45,32,53,49,57,51,54,32,69,85,67,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,69,85,67,41,10,45,32,53,49,57,52,57,32,69,85,67,32,75,111,114,101,97,110,10,45,32,53,50,57,51,54,32,72,90,45,71,66,50,51,49,50,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,72,90,41,10,45,32,53,52,57,51,54,32,87,105,110,100,111,119,115,32,88,80,32,97,110,100,32,108,97,116,101,114,58,32,71,66,49,56,48,51,48,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,52,32,98,121,116,101,41,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,71,66,49,56,48,51,48,41,10,45,32,53,55,48,48,50,32,73,83,67,73,73,32,68,101,118,97,110,97,103,97,114,105,10,45,32,53,55,48,48,51,32,73,83,67,73,73,32,66,101,110,103,97,108,105,10,45,32,53,55,48,48,52,32,73,83,67,73,73,32,84,97,109,105,108,10,45,32,53,55,48,48,53,32,73,83,67,73,73,32,84,101,108,117,103,117,10,45,32,53,55,48,48,54,32,73,83,67,73,73,32,65,115,115,97,109,101,115,101,10,45,32,53,55,48,48,55,32,73,83,67,73,73,32,79,114,105,121,97,10,45,32,53,55,48,48,56,32,73,83,67,73,73,32,75,97,110,110,97,100,97,10,45,32,53,55,48,48,57,32,73,83,67,73,73,32,77,97,108,97,121,97,108,97,109,10,45,32,53,55,48,49,48,32,73,83,67,73,73,32,71,117,106,97,114,97,116,105,10,45,32,53,55,48,49,49,32,73,83,67,73,73,32,80,117,110,106,97,98,105,10,10,84,104,101,32,102,111,108,108,111,119,105,110,103,32,99,111,100,101,112,97,103,101,115,32,97,114,101,32,100,101,112,101,110,100,101,110,99,105,101,115,32,102,111,114,32,86,105,115,117,97,108,32,70,111,120,80,114,111,58,10,10,45,32,54,50,48,32,77,97,122,111,118,105,97,32,40,80,111,108,105,115,104,41,32,77,83,45,68,79,83,10,45,32,56,57,53,32,75,97,109,101,110,105,99,107,32,40,67,122,101,99,104,41,32,77,83,45,68,79,83,10,10,35,35,32,66,117,105,108,100,105,110,103,32,78,111,116,101,115,10,10,84,104,101,32,115,99,114,105,112,116,32,96,109,97,107,101,46,115,104,96,32,40,100,101,115,99,114,105,98,101,100,32,108,97,116,101,114,41,32,119,105,108,108,32,103,101,116,32,116,104,101,115,101,32,102,105,108,101,115,32,97,110,100,32,109,97,115,115,97,103,101,32,116,104,101,32,100,97,116,97,10,40,112,114,105,110,116,105,110,103,32,99,111,100,101,45,85,110,105,99,111,100,101,32,112,97,105,114,115,41,46,32,32,84,104,101,32,101,118,101,110,116,117,97,108,32,116,97,98,108,101,115,32,97,114,101,32,100,114,111,112,112,101,100,32,105,110,32,116,104,101,32,112,97,116,104,115,10,96,46,47,99,111,100,101,112,97,103,101,115,47,60,67,79,68,69,80,65,71,69,62,46,84,66,76,96,46,32,32,70,111,114,32,101,120,97,109,112,108,101,44,32,116,104,101,32,108,97,115,116,32,49,48,32,108,105,110,101,115,32,111,102,32,96,49,48,48,48,48,46,84,66,76,96,32,97,114,101,10,10,96,96,96,62,10,48,120,70,54,9,48,120,48,50,67,54,10,48,120,70,55,9,48,120,48,50,68,67,10,48,120,70,56,9,48,120,48,48,65,70,10,48,120,70,57,9,48,120,48,50,68,56,10,48,120,70,65,9,48,120,48,50,68,57,10,48,120,70,66,9,48,120,48,50,68,65,10,48,120,70,67,9,48,120,48,48,66,56,10,48,120,70,68,9,48,120,48,50,68,68,10,48,120,70,69,9,48,120,48,50,68,66,10,48,120,70,70,9,48,120,48,50,67,55,10,96,96,96,10,10,119,104,105,99,104,32,105,109,112,108,105,101,115,32,116,104,97,116,32,99,111,100,101,32,96,48,120,70,54,96,32,105,115,32,96,83,116,114,105,110,103,46,102,114,111,109,67,104,97,114,67,111,100,101,40,48,120,48,50,67,54,41,96,32,97,110,100,32,118,105,99,101,32,118,101,114,115,97,46,10,10,35,35,32,87,105,110,100,111,119,115,45,100,101,112,101,110,100,101,110,116,32,98,117,105,108,100,32,115,116,101,112,10,10,84,111,32,98,117,105,108,100,32,116,104,101,32,115,111,117,114,99,101,115,32,111,110,32,119,105,110,100,111,119,115,44,32,99,111,110,115,117,108,116,32,96,100,111,116,110,101,116,47,77,97,107,101,69,110,99,111,100,105,110,103,46,99,115,96,46,10,10,65,102,116,101,114,32,115,97,118,105,110,103,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,32,116,111,32,96,111,117,116,96,44,32,116,104,101,32,96,100,111,116,110,101,116,46,115,104,96,32,115,99,114,105,112,116,32,112,114,111,99,101,115,115,101,115,32,114,101,115,117,108,116,115,46,32,10,10,35,32,66,117,105,108,100,105,110,103,32,116,104,101,32,115,99,114,105,112,116,10,10,96,109,97,107,101,46,110,106,115,96,32,116,97,107,101,115,32,97,32,99,111,100,101,112,97,103,101,32,97,114,103,117,109,101,110,116,44,32,114,101,97,100,115,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,116,97,98,108,101,32,102,105,108,101,32,97,110,100,10,103,101,110,101,114,97,116,101,115,32,74,83,32,99,111,100,101,32,102,111,114,32,101,110,99,111,100,105,110,103,32,97,110,100,32,100,101,99,111,100,105,110,103,58,10,10,35,35,32,82,97,119,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,68,66,67,83,32,97,110,100,32,83,66,67,83,32,99,111,100,101,32,103,101,110,101,114,97,116,105,111,110,32,115,116,114,97,116,101,103,105,101,115,32,97,114,101,32,100,105,102,102,101,114,101,110,116,46,32,32,84,104,101,32,109,97,120,105,109,117,109,32,99,111,100,101,32,105,115,10,117,115,101,100,32,116,111,32,100,105,115,116,105,110,103,117,105,115,104,32,40,109,97,120,32,96,48,120,70,70,96,32,102,111,114,32,83,66,67,83,41,46,10,10,84,104,101,32,85,110,105,99,111,100,101,32,99,104,97,114,97,99,116,101,114,32,96,48,120,70,70,70,68,96,32,40,82,69,80,76,65,67,69,77,69,78,84,32,67,72,65,82,65,67,84,69,82,41,32,105,115,32,117,115,101,100,32,97,115,32,97,32,112,108,97,99,101,104,111,108,100,101,114,10,102,111,114,32,99,104,97,114,97,99,116,101,114,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,109,97,112,32,40,102,111,114,32,101,120,97,109,112,108,101,44,32,96,48,120,70,48,96,32,105,115,32,110,111,116,32,105,110,10,99,111,100,101,32,112,97,103,101,32,49,48,48,48,48,41,46,10,10,70,111,114,32,83,66,67,83,44,32,116,104,101,32,105,100,101,97,32,105,115,32,116,111,32,101,109,98,101,100,32,97,32,114,97,119,32,115,116,114,105,110,103,32,119,105,116,104,32,116,104,101,32,99,111,110,116,101,110,116,115,32,111,102,32,116,104,101,32,50,53,54,32,99,111,100,101,115,46,10,84,104,101,32,96,100,101,99,96,32,102,105,101,108,100,32,105,115,32,109,101,114,101,108,121,32,97,32,115,112,108,105,116,32,111,102,32,116,104,101,32,115,116,114,105,110,103,44,32,97,110,100,32,96,101,110,99,96,32,105,115,32,97,110,32,101,118,101,114,115,105,111,110,58,10,10,68,66,67,83,32,105,115,32,115,105,109,105,108,97,114,44,32,101,120,99,101,112,116,32,116,104,97,116,32,116,104,101,32,115,112,97,99,101,32,105,115,32,115,108,105,99,101,100,32,105,110,32,99,104,117,110,107,115,32,111,102,32,50,53,54,32,98,121,116,101,115,32,40,115,116,114,105,110,103,115,10,97,114,101,32,111,110,108,121,32,103,101,110,101,114,97,116,101,100,32,102,111,114,32,116,104,111,115,101,32,104,105,103,104,45,98,121,116,101,115,32,114,101,112,114,101,115,101,110,116,101,100,32,105,110,32,116,104,101,32,99,111,100,101,112,97,103,101,41,46,10,10,84,104,101,32,115,116,114,97,116,101,103,121,32,105,115,32,116,111,32,99,111,110,115,116,114,117,99,116,32,97,110,32,97,114,114,97,121,45,111,102,45,97,114,114,97,121,115,32,115,111,32,116,104,97,116,32,96,100,100,91,104,105,103,104,93,91,108,111,119,93,96,32,105,115,32,116,104,101,10,99,104,97,114,97,99,116,101,114,32,97,115,115,111,99,105,97,116,101,100,32,119,105,116,104,32,116,104,101,32,99,111,100,101,46,32,32,84,104,105,115,32,97,114,114,97,121,32,105,115,32,99,111,109,98,105,110,101,100,32,97,116,32,114,117,110,116,105,109,101,32,116,111,32,121,105,101,108,100,10,116,104,101,32,99,111,109,112,108,101,116,101,32,100,101,99,111,100,105,110,103,32,111,98,106,101,99,116,32,40,97,110,100,32,116,104,101,32,101,110,99,111,100,105,110,103,32,111,98,106,101,99,116,32,105,115,32,97,110,32,101,118,101,114,115,105,111,110,41,58,10,10,96,109,97,107,101,46,115,104,96,32,103,101,110,101,114,97,116,101,115,32,116,104,101,32,116,97,98,108,101,115,32,117,115,101,100,32,98,121,32,96,109,97,107,101,46,110,106,115,96,46,32,32,84,104,101,32,114,97,119,32,85,110,105,99,111,100,101,32,84,88,84,32,102,105,108,101,115,10,97,114,101,32,99,111,108,117,109,110,97,114,58,32,96,99,111,100,101,32,117,110,105,99,111,100,101,32,35,99,111,109,109,101,110,116,115,96,46,32,32,70,111,114,32,101,120,97,109,112,108,101,44,32,116,104,101,32,108,97,115,116,32,49,48,32,108,105,110,101,115,32,111,102,32,116,104,101,10,116,101,120,116,32,102,105,108,101,32,96,82,79,77,65,78,46,84,88,84,96,32,40,102,111,114,32,67,80,32,49,48,48,48,48,41,32,97,114,101,58,10,10,96,96,96,62,10,48,120,70,54,9,48,120,48,50,67,54,9,35,77,79,68,73,70,73,69,82,32,76,69,84,84,69,82,32,67,73,82,67,85,77,70,76,69,88,32,65,67,67,69,78,84,10,48,120,70,55,9,48,120,48,50,68,67,9,35,83,77,65,76,76,32,84,73,76,68,69,10,48,120,70,56,9,48,120,48,48,65,70,9,35,77,65,67,82,79,78,10,48,120,70,57,9,48,120,48,50,68,56,9,35,66,82,69,86,69,10,48,120,70,65,9,48,120,48,50,68,57,9,35,68,79,84,32,65,66,79,86,69,10,48,120,70,66,9,48,120,48,50,68,65,9,35,82,73,78,71,32,65,66,79,86,69,10,48,120,70,67,9,48,120,48,48,66,56,9,35,67,69,68,73,76,76,65,10,48,120,70,68,9,48,120,48,50,68,68,9,35,68,79,85,66,76,69,32,65,67,85,84,69,32,65,67,67,69,78,84,10,48,120,70,69,9,48,120,48,50,68,66,9,35,79,71,79,78,69,75,10,48,120,70,70,9,48,120,48,50,67,55,9,35,67,65,82,79,78,10,96,96,96,10,10,73,110,32,112,114,111,99,101,115,115,105,110,103,32,116,104,101,32,100,97,116,97,44,32,116,104,101,32,99,111,109,109,101,110,116,115,32,40,97,102,116,101,114,32,116,104,101,32,96,35,96,41,32,97,114,101,32,115,116,114,105,112,112,101,100,32,97,110,100,32,117,110,100,101,102,105,110,101,100,10,101,108,101,109,101,110,116,115,32,40,108,105,107,101,32,96,48,120,55,70,96,32,102,111,114,32,67,80,32,49,48,48,48,48,41,32,97,114,101,32,114,101,109,111,118,101,100,46,10,10,35,35,32,85,116,105,108,105,116,105,101,115,10,10,84,104,101,32,101,110,99,111,100,101,32,97,110,100,32,100,101,99,111,100,101,32,102,117,110,99,116,105,111,110,115,32,97,114,101,32,107,101,112,116,32,105,110,32,97,32,115,101,112,97,114,97,116,101,32,115,99,114,105,112,116,32,40,96,99,112,117,116,105,108,115,46,106,115,96,41,46,10,10,66,111,116,104,32,101,110,99,111,100,101,32,97,110,100,32,100,101,99,111,100,101,32,100,101,97,108,32,119,105,116,104,32,100,97,116,97,32,114,101,112,114,101,115,101,110,116,101,100,32,97,115,58,10,10,45,32,83,116,114,105,110,103,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,74,83,32,115,116,114,105,110,103,44,32,100,101,99,111,100,101,32,105,110,116,101,114,112,114,101,116,115,32,85,67,83,50,32,99,104,97,114,115,32,97,115,32,99,111,100,101,115,41,10,45,32,65,114,114,97,121,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,97,114,114,97,121,32,111,102,32,74,83,32,83,116,114,105,110,103,32,99,104,97,114,97,99,116,101,114,115,44,32,100,101,99,111,100,101,32,101,120,112,101,99,116,115,32,110,117,109,98,101,114,115,41,10,45,32,66,117,102,102,101,114,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,85,84,70,45,56,32,115,116,114,105,110,103,44,32,100,101,99,111,100,101,32,101,120,112,101,99,116,115,32,99,111,100,101,112,111,105,110,116,115,47,98,121,116,101,115,41,46,10,10,84,104,101,32,96,111,102,109,116,96,32,118,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,115,32,96,101,110,99,111,100,101,96,32,111,117,116,112,117,116,32,40,96,115,116,114,96,44,32,96,97,114,114,96,32,114,101,115,112,101,99,116,105,118,101,108,121,41,10,119,104,105,108,101,32,116,104,101,32,105,110,112,117,116,32,102,111,114,109,97,116,32,105,115,32,97,117,116,111,109,97,116,105,99,97,108,108,121,32,100,101,116,101,114,109,105,110,101,100,46,10,10,35,32,78,105,116,116,121,32,71,114,105,116,116,121,10,10,96,96,96,62,46,118,111,99,114,99,10,123,32,34,112,111,115,116,34,58,32,34,109,97,107,101,32,106,115,34,32,125,10,96,96,96,10]}
;
README['utf7'] = 
{"type":"Buffer","data":[43,65,67,77,32,71,101,116,116,105,110,103,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,102,105,101,108,100,115,32,111,102,32,116,104,101,32,43,65,71,65,45,112,97,103,101,115,46,99,115,118,43,65,71,65,32,109,97,110,105,102,101,115,116,32,97,114,101,32,43,65,71,65,45,99,111,100,101,112,97,103,101,44,117,114,108,44,98,121,116,101,115,43,65,71,65,32,40,83,66,67,83,43,65,68,48,45,49,44,32,68,66,67,83,43,65,68,48,45,50,41,10,10,78,111,116,101,32,116,104,97,116,32,116,104,101,32,87,105,110,100,111,119,115,32,114,101,110,100,101,114,105,110,103,32,105,115,32,117,115,101,100,32,102,111,114,32,116,104,101,32,77,97,99,32,99,111,100,101,32,112,97,103,101,115,46,32,32,84,104,101,32,112,114,105,109,97,114,121,10,100,105,102,102,101,114,101,110,99,101,32,105,115,32,116,104,101,32,117,115,101,32,111,102,32,116,104,101,32,112,114,105,118,97,116,101,32,43,65,71,65,45,48,120,70,56,70,70,43,65,71,65,32,99,111,100,101,32,40,119,104,105,99,104,32,114,101,110,100,101,114,115,32,97,115,32,97,110,32,65,112,112,108,101,10,108,111,103,111,32,111,110,32,109,97,99,115,32,98,117,116,32,97,115,32,103,97,114,98,97,103,101,32,111,110,32,111,116,104,101,114,32,111,112,101,114,97,116,105,110,103,32,115,121,115,116,101,109,115,41,46,32,32,73,116,32,109,97,121,32,98,101,32,100,101,115,105,114,97,98,108,101,10,116,111,32,102,97,108,108,32,98,97,99,107,32,116,111,32,116,104,101,32,98,101,104,97,118,105,111,114,44,32,105,110,32,119,104,105,99,104,32,99,97,115,101,32,116,104,101,32,102,105,108,101,115,32,97,114,101,32,117,110,100,101,114,32,65,80,80,76,69,32,97,110,100,32,110,111,116,10,77,73,67,83,70,84,46,32,32,84,104,105,115,32,97,102,102,101,99,116,115,32,99,111,100,101,112,97,103,101,115,32,49,48,48,48,48,44,32,49,48,48,48,54,44,32,49,48,48,48,55,44,32,49,48,48,50,57,44,32,49,48,48,55,57,44,32,49,48,48,56,49,10,10,84,104,101,32,110,117,109,98,101,114,105,110,103,32,115,99,104,101,109,101,32,102,111,114,32,116,104,101,32,43,65,71,65,45,73,83,79,45,56,56,53,57,45,88,43,65,71,65,32,115,101,114,105,101,115,32,105,115,32,43,65,71,65,45,50,56,53,57,48,32,43,45,32,88,43,65,71,65,58,10,10,43,65,67,77,65,73,119,32,71,101,110,101,114,97,116,101,100,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,102,111,108,108,111,119,105,110,103,32,99,111,100,101,112,97,103,101,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,32,105,110,32,46,78,69,84,32,111,110,32,87,105,110,100,111,119,115,58,10,10,45,32,55,48,56,32,32,32,65,114,97,98,105,99,32,40,65,83,77,79,32,55,48,56,41,10,45,32,55,50,48,32,32,32,65,114,97,98,105,99,32,40,84,114,97,110,115,112,97,114,101,110,116,32,65,83,77,79,41,43,65,68,115,32,65,114,97,98,105,99,32,40,68,79,83,41,10,45,32,56,53,56,32,32,32,79,69,77,32,77,117,108,116,105,108,105,110,103,117,97,108,32,76,97,116,105,110,32,49,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,10,45,32,56,55,48,32,32,32,73,66,77,32,69,66,67,68,73,67,32,77,117,108,116,105,108,105,110,103,117,97,108,47,82,79,69,67,69,32,40,76,97,116,105,110,32,50,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,77,117,108,116,105,108,105,110,103,117,97,108,32,76,97,116,105,110,32,50,10,45,32,49,48,52,55,32,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,49,47,79,112,101,110,32,83,121,115,116,101,109,10,45,32,49,49,52,48,32,32,73,66,77,32,69,66,67,68,73,67,32,85,83,45,67,97,110,97,100,97,32,40,48,51,55,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,85,83,45,67,97,110,97,100,97,45,69,117,114,111,41,10,45,32,49,49,52,49,32,32,73,66,77,32,69,66,67,68,73,67,32,71,101,114,109,97,110,121,32,40,50,48,50,55,51,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,71,101,114,109,97,110,121,45,69,117,114,111,41,10,45,32,49,49,52,50,32,32,73,66,77,32,69,66,67,68,73,67,32,68,101,110,109,97,114,107,45,78,111,114,119,97,121,32,40,50,48,50,55,55,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,68,101,110,109,97,114,107,45,78,111,114,119,97,121,45,69,117,114,111,41,10,45,32,49,49,52,51,32,32,73,66,77,32,69,66,67,68,73,67,32,70,105,110,108,97,110,100,45,83,119,101,100,101,110,32,40,50,48,50,55,56,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,70,105,110,108,97,110,100,45,83,119,101,100,101,110,45,69,117,114,111,41,10,45,32,49,49,52,52,32,32,73,66,77,32,69,66,67,68,73,67,32,73,116,97,108,121,32,40,50,48,50,56,48,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,73,116,97,108,121,45,69,117,114,111,41,10,45,32,49,49,52,53,32,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,65,109,101,114,105,99,97,45,83,112,97,105,110,32,40,50,48,50,56,52,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,83,112,97,105,110,45,69,117,114,111,41,10,45,32,49,49,52,54,32,32,73,66,77,32,69,66,67,68,73,67,32,85,110,105,116,101,100,32,75,105,110,103,100,111,109,32,40,50,48,50,56,53,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,85,75,45,69,117,114,111,41,10,45,32,49,49,52,55,32,32,73,66,77,32,69,66,67,68,73,67,32,70,114,97,110,99,101,32,40,50,48,50,57,55,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,70,114,97,110,99,101,45,69,117,114,111,41,10,45,32,49,49,52,56,32,32,73,66,77,32,69,66,67,68,73,67,32,73,110,116,101,114,110,97,116,105,111,110,97,108,32,40,53,48,48,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,73,110,116,101,114,110,97,116,105,111,110,97,108,45,69,117,114,111,41,10,45,32,49,49,52,57,32,32,73,66,77,32,69,66,67,68,73,67,32,73,99,101,108,97,110,100,105,99,32,40,50,48,56,55,49,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,43,65,68,115,32,73,66,77,32,69,66,67,68,73,67,32,40,73,99,101,108,97,110,100,105,99,45,69,117,114,111,41,10,45,32,49,51,54,49,32,32,75,111,114,101,97,110,32,40,74,111,104,97,98,41,10,45,32,49,48,48,48,49,32,74,97,112,97,110,101,115,101,32,40,77,97,99,41,10,45,32,49,48,48,48,50,32,77,65,67,32,84,114,97,100,105,116,105,111,110,97,108,32,67,104,105,110,101,115,101,32,40,66,105,103,53,41,43,65,68,115,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,77,97,99,41,10,45,32,49,48,48,48,51,32,75,111,114,101,97,110,32,40,77,97,99,41,10,45,32,49,48,48,48,52,32,65,114,97,98,105,99,32,40,77,97,99,41,10,45,32,49,48,48,48,53,32,72,101,98,114,101,119,32,40,77,97,99,41,10,45,32,49,48,48,48,56,32,77,65,67,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,71,66,32,50,51,49,50,41,43,65,68,115,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,77,97,99,41,10,45,32,49,48,48,49,48,32,82,111,109,97,110,105,97,110,32,40,77,97,99,41,10,45,32,49,48,48,49,55,32,85,107,114,97,105,110,105,97,110,32,40,77,97,99,41,10,45,32,49,48,48,50,49,32,84,104,97,105,32,40,77,97,99,41,10,45,32,49,48,48,56,50,32,67,114,111,97,116,105,97,110,32,40,77,97,99,41,10,45,32,50,48,48,48,48,32,67,78,83,32,84,97,105,119,97,110,43,65,68,115,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,67,78,83,41,10,45,32,50,48,48,48,49,32,84,67,65,32,84,97,105,119,97,110,10,45,32,50,48,48,48,50,32,69,84,69,78,32,84,97,105,119,97,110,43,65,68,115,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,69,84,69,78,41,10,45,32,50,48,48,48,51,32,73,66,77,53,53,53,48,32,84,97,105,119,97,110,10,45,32,50,48,48,48,52,32,84,101,108,101,84,101,120,116,32,84,97,105,119,97,110,10,45,32,50,48,48,48,53,32,87,97,110,103,32,84,97,105,119,97,110,10,45,32,50,48,49,48,53,32,73,65,53,32,40,73,82,86,32,73,110,116,101,114,110,97,116,105,111,110,97,108,32,65,108,112,104,97,98,101,116,32,78,111,46,32,53,44,32,55,45,98,105,116,41,43,65,68,115,32,87,101,115,116,101,114,110,32,69,117,114,111,112,101,97,110,32,40,73,65,53,41,10,45,32,50,48,49,48,54,32,73,65,53,32,71,101,114,109,97,110,32,40,55,45,98,105,116,41,10,45,32,50,48,49,48,55,32,73,65,53,32,83,119,101,100,105,115,104,32,40,55,45,98,105,116,41,10,45,32,50,48,49,48,56,32,73,65,53,32,78,111,114,119,101,103,105,97,110,32,40,55,45,98,105,116,41,10,45,32,50,48,50,54,49,32,84,46,54,49,10,45,32,50,48,50,54,57,32,73,83,79,32,54,57,51,55,32,78,111,110,45,83,112,97,99,105,110,103,32,65,99,99,101,110,116,10,45,32,50,48,50,55,51,32,73,66,77,32,69,66,67,68,73,67,32,71,101,114,109,97,110,121,10,45,32,50,48,50,55,55,32,73,66,77,32,69,66,67,68,73,67,32,68,101,110,109,97,114,107,45,78,111,114,119,97,121,10,45,32,50,48,50,55,56,32,73,66,77,32,69,66,67,68,73,67,32,70,105,110,108,97,110,100,45,83,119,101,100,101,110,10,45,32,50,48,50,56,48,32,73,66,77,32,69,66,67,68,73,67,32,73,116,97,108,121,10,45,32,50,48,50,56,52,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,65,109,101,114,105,99,97,45,83,112,97,105,110,10,45,32,50,48,50,56,53,32,73,66,77,32,69,66,67,68,73,67,32,85,110,105,116,101,100,32,75,105,110,103,100,111,109,10,45,32,50,48,50,57,48,32,73,66,77,32,69,66,67,68,73,67,32,74,97,112,97,110,101,115,101,32,75,97,116,97,107,97,110,97,32,69,120,116,101,110,100,101,100,10,45,32,50,48,50,57,55,32,73,66,77,32,69,66,67,68,73,67,32,70,114,97,110,99,101,10,45,32,50,48,52,50,48,32,73,66,77,32,69,66,67,68,73,67,32,65,114,97,98,105,99,10,45,32,50,48,52,50,51,32,73,66,77,32,69,66,67,68,73,67,32,71,114,101,101,107,10,45,32,50,48,52,50,52,32,73,66,77,32,69,66,67,68,73,67,32,72,101,98,114,101,119,10,45,32,50,48,56,51,51,32,73,66,77,32,69,66,67,68,73,67,32,75,111,114,101,97,110,32,69,120,116,101,110,100,101,100,10,45,32,50,48,56,51,56,32,73,66,77,32,69,66,67,68,73,67,32,84,104,97,105,10,45,32,50,48,56,54,54,32,82,117,115,115,105,97,110,32,40,75,79,73,56,45,82,41,43,65,68,115,32,67,121,114,105,108,108,105,99,32,40,75,79,73,56,45,82,41,10,45,32,50,48,56,55,49,32,73,66,77,32,69,66,67,68,73,67,32,73,99,101,108,97,110,100,105,99,10,45,32,50,48,56,56,48,32,73,66,77,32,69,66,67,68,73,67,32,67,121,114,105,108,108,105,99,32,82,117,115,115,105,97,110,10,45,32,50,48,57,48,53,32,73,66,77,32,69,66,67,68,73,67,32,84,117,114,107,105,115,104,10,45,32,50,48,57,50,52,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,49,47,79,112,101,110,32,83,121,115,116,101,109,32,40,49,48,52,55,32,43,45,32,69,117,114,111,32,115,121,109,98,111,108,41,10,45,32,50,48,57,51,50,32,74,97,112,97,110,101,115,101,32,40,74,73,83,32,48,50,48,56,45,49,57,57,48,32,97,110,100,32,48,50,49,50,45,49,57,57,48,41,10,45,32,50,48,57,51,54,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,71,66,50,51,49,50,41,43,65,68,115,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,71,66,50,51,49,50,45,56,48,41,10,45,32,50,48,57,52,57,32,75,111,114,101,97,110,32,87,97,110,115,117,110,103,10,45,32,50,49,48,50,53,32,73,66,77,32,69,66,67,68,73,67,32,67,121,114,105,108,108,105,99,32,83,101,114,98,105,97,110,45,66,117,108,103,97,114,105,97,110,10,45,32,50,49,48,50,55,32,69,120,116,101,110,100,101,100,47,69,120,116,32,65,108,112,104,97,32,76,111,119,101,114,99,97,115,101,10,45,32,50,49,56,54,54,32,85,107,114,97,105,110,105,97,110,32,40,75,79,73,56,45,85,41,43,65,68,115,32,67,121,114,105,108,108,105,99,32,40,75,79,73,56,45,85,41,10,45,32,50,57,48,48,49,32,69,117,114,111,112,97,32,51,10,45,32,51,56,53,57,56,32,73,83,79,32,56,56,53,57,45,56,32,72,101,98,114,101,119,43,65,68,115,32,72,101,98,114,101,119,32,40,73,83,79,45,76,111,103,105,99,97,108,41,10,45,32,53,49,57,51,50,32,69,85,67,32,74,97,112,97,110,101,115,101,10,45,32,53,49,57,51,54,32,69,85,67,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,43,65,68,115,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,69,85,67,41,10,45,32,53,49,57,52,57,32,69,85,67,32,75,111,114,101,97,110,10,45,32,53,50,57,51,54,32,72,90,45,71,66,50,51,49,50,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,43,65,68,115,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,72,90,41,10,45,32,53,52,57,51,54,32,87,105,110,100,111,119,115,32,88,80,32,97,110,100,32,108,97,116,101,114,58,32,71,66,49,56,48,51,48,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,52,32,98,121,116,101,41,43,65,68,115,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,71,66,49,56,48,51,48,41,10,45,32,53,55,48,48,50,32,73,83,67,73,73,32,68,101,118,97,110,97,103,97,114,105,10,45,32,53,55,48,48,51,32,73,83,67,73,73,32,66,101,110,103,97,108,105,10,45,32,53,55,48,48,52,32,73,83,67,73,73,32,84,97,109,105,108,10,45,32,53,55,48,48,53,32,73,83,67,73,73,32,84,101,108,117,103,117,10,45,32,53,55,48,48,54,32,73,83,67,73,73,32,65,115,115,97,109,101,115,101,10,45,32,53,55,48,48,55,32,73,83,67,73,73,32,79,114,105,121,97,10,45,32,53,55,48,48,56,32,73,83,67,73,73,32,75,97,110,110,97,100,97,10,45,32,53,55,48,48,57,32,73,83,67,73,73,32,77,97,108,97,121,97,108,97,109,10,45,32,53,55,48,49,48,32,73,83,67,73,73,32,71,117,106,97,114,97,116,105,10,45,32,53,55,48,49,49,32,73,83,67,73,73,32,80,117,110,106,97,98,105,10,10,84,104,101,32,102,111,108,108,111,119,105,110,103,32,99,111,100,101,112,97,103,101,115,32,97,114,101,32,100,101,112,101,110,100,101,110,99,105,101,115,32,102,111,114,32,86,105,115,117,97,108,32,70,111,120,80,114,111,58,10,10,45,32,54,50,48,32,77,97,122,111,118,105,97,32,40,80,111,108,105,115,104,41,32,77,83,45,68,79,83,10,45,32,56,57,53,32,75,97,109,101,110,105,99,107,43,65,80,48,32,40,67,122,101,99,104,41,32,77,83,45,68,79,83,10,10,43,65,67,77,65,73,119,32,66,117,105,108,100,105,110,103,32,78,111,116,101,115,10,10,84,104,101,32,115,99,114,105,112,116,32,43,65,71,65,45,109,97,107,101,46,115,104,43,65,71,65,32,40,100,101,115,99,114,105,98,101,100,32,108,97,116,101,114,41,32,119,105,108,108,32,103,101,116,32,116,104,101,115,101,32,102,105,108,101,115,32,97,110,100,32,109,97,115,115,97,103,101,32,116,104,101,32,100,97,116,97,10,40,112,114,105,110,116,105,110,103,32,99,111,100,101,45,85,110,105,99,111,100,101,32,112,97,105,114,115,41,46,32,32,84,104,101,32,101,118,101,110,116,117,97,108,32,116,97,98,108,101,115,32,97,114,101,32,100,114,111,112,112,101,100,32,105,110,32,116,104,101,32,112,97,116,104,115,10,43,65,71,65,46,47,99,111,100,101,112,97,103,101,115,47,43,65,68,119,45,67,79,68,69,80,65,71,69,43,65,68,52,46,84,66,76,43,65,71,65,46,32,32,70,111,114,32,101,120,97,109,112,108,101,44,32,116,104,101,32,108,97,115,116,32,49,48,32,108,105,110,101,115,32,111,102,32,43,65,71,65,45,49,48,48,48,48,46,84,66,76,43,65,71,65,32,97,114,101,10,10,43,65,71,65,65,89,65,66,103,65,68,52,10,48,120,70,54,9,48,120,48,50,67,54,10,48,120,70,55,9,48,120,48,50,68,67,10,48,120,70,56,9,48,120,48,48,65,70,10,48,120,70,57,9,48,120,48,50,68,56,10,48,120,70,65,9,48,120,48,50,68,57,10,48,120,70,66,9,48,120,48,50,68,65,10,48,120,70,67,9,48,120,48,48,66,56,10,48,120,70,68,9,48,120,48,50,68,68,10,48,120,70,69,9,48,120,48,50,68,66,10,48,120,70,70,9,48,120,48,50,67,55,10,43,65,71,65,65,89,65,66,103,10,10,119,104,105,99,104,32,105,109,112,108,105,101,115,32,116,104,97,116,32,99,111,100,101,32,43,65,71,65,45,48,120,70,54,43,65,71,65,32,105,115,32,43,65,71,65,45,83,116,114,105,110,103,46,102,114,111,109,67,104,97,114,67,111,100,101,40,48,120,48,50,67,54,41,43,65,71,65,32,97,110,100,32,118,105,99,101,32,118,101,114,115,97,46,10,10,43,65,67,77,65,73,119,32,87,105,110,100,111,119,115,45,100,101,112,101,110,100,101,110,116,32,98,117,105,108,100,32,115,116,101,112,10,10,84,111,32,98,117,105,108,100,32,116,104,101,32,115,111,117,114,99,101,115,32,111,110,32,119,105,110,100,111,119,115,44,32,99,111,110,115,117,108,116,32,43,65,71,65,45,100,111,116,110,101,116,47,77,97,107,101,69,110,99,111,100,105,110,103,46,99,115,43,65,71,65,46,10,10,65,102,116,101,114,32,115,97,118,105,110,103,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,32,116,111,32,43,65,71,65,45,111,117,116,43,65,71,65,44,32,116,104,101,32,43,65,71,65,45,100,111,116,110,101,116,46,115,104,43,65,71,65,32,115,99,114,105,112,116,32,112,114,111,99,101,115,115,101,115,32,114,101,115,117,108,116,115,46,32,10,10,43,65,67,77,32,66,117,105,108,100,105,110,103,32,116,104,101,32,115,99,114,105,112,116,10,10,43,65,71,65,45,109,97,107,101,46,110,106,115,43,65,71,65,32,116,97,107,101,115,32,97,32,99,111,100,101,112,97,103,101,32,97,114,103,117,109,101,110,116,44,32,114,101,97,100,115,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,116,97,98,108,101,32,102,105,108,101,32,97,110,100,10,103,101,110,101,114,97,116,101,115,32,74,83,32,99,111,100,101,32,102,111,114,32,101,110,99,111,100,105,110,103,32,97,110,100,32,100,101,99,111,100,105,110,103,58,10,10,43,65,67,77,65,73,119,32,82,97,119,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,68,66,67,83,32,97,110,100,32,83,66,67,83,32,99,111,100,101,32,103,101,110,101,114,97,116,105,111,110,32,115,116,114,97,116,101,103,105,101,115,32,97,114,101,32,100,105,102,102,101,114,101,110,116,46,32,32,84,104,101,32,109,97,120,105,109,117,109,32,99,111,100,101,32,105,115,10,117,115,101,100,32,116,111,32,100,105,115,116,105,110,103,117,105,115,104,32,40,109,97,120,32,43,65,71,65,45,48,120,70,70,43,65,71,65,32,102,111,114,32,83,66,67,83,41,46,10,10,84,104,101,32,85,110,105,99,111,100,101,32,99,104,97,114,97,99,116,101,114,32,43,65,71,65,45,48,120,70,70,70,68,43,65,71,65,32,40,82,69,80,76,65,67,69,77,69,78,84,32,67,72,65,82,65,67,84,69,82,41,32,105,115,32,117,115,101,100,32,97,115,32,97,32,112,108,97,99,101,104,111,108,100,101,114,10,102,111,114,32,99,104,97,114,97,99,116,101,114,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,109,97,112,32,40,102,111,114,32,101,120,97,109,112,108,101,44,32,43,65,71,65,45,48,120,70,48,43,65,71,65,32,105,115,32,110,111,116,32,105,110,10,99,111,100,101,32,112,97,103,101,32,49,48,48,48,48,41,46,10,10,70,111,114,32,83,66,67,83,44,32,116,104,101,32,105,100,101,97,32,105,115,32,116,111,32,101,109,98,101,100,32,97,32,114,97,119,32,115,116,114,105,110,103,32,119,105,116,104,32,116,104,101,32,99,111,110,116,101,110,116,115,32,111,102,32,116,104,101,32,50,53,54,32,99,111,100,101,115,46,10,84,104,101,32,43,65,71,65,45,100,101,99,43,65,71,65,32,102,105,101,108,100,32,105,115,32,109,101,114,101,108,121,32,97,32,115,112,108,105,116,32,111,102,32,116,104,101,32,115,116,114,105,110,103,44,32,97,110,100,32,43,65,71,65,45,101,110,99,43,65,71,65,32,105,115,32,97,110,32,101,118,101,114,115,105,111,110,58,10,10,68,66,67,83,32,105,115,32,115,105,109,105,108,97,114,44,32,101,120,99,101,112,116,32,116,104,97,116,32,116,104,101,32,115,112,97,99,101,32,105,115,32,115,108,105,99,101,100,32,105,110,32,99,104,117,110,107,115,32,111,102,32,50,53,54,32,98,121,116,101,115,32,40,115,116,114,105,110,103,115,10,97,114,101,32,111,110,108,121,32,103,101,110,101,114,97,116,101,100,32,102,111,114,32,116,104,111,115,101,32,104,105,103,104,45,98,121,116,101,115,32,114,101,112,114,101,115,101,110,116,101,100,32,105,110,32,116,104,101,32,99,111,100,101,112,97,103,101,41,46,10,10,84,104,101,32,115,116,114,97,116,101,103,121,32,105,115,32,116,111,32,99,111,110,115,116,114,117,99,116,32,97,110,32,97,114,114,97,121,45,111,102,45,97,114,114,97,121,115,32,115,111,32,116,104,97,116,32,43,65,71,65,45,100,100,43,65,70,115,45,104,105,103,104,43,65,70,48,65,87,119,45,108,111,119,43,65,70,48,65,89,65,32,105,115,32,116,104,101,10,99,104,97,114,97,99,116,101,114,32,97,115,115,111,99,105,97,116,101,100,32,119,105,116,104,32,116,104,101,32,99,111,100,101,46,32,32,84,104,105,115,32,97,114,114,97,121,32,105,115,32,99,111,109,98,105,110,101,100,32,97,116,32,114,117,110,116,105,109,101,32,116,111,32,121,105,101,108,100,10,116,104,101,32,99,111,109,112,108,101,116,101,32,100,101,99,111,100,105,110,103,32,111,98,106,101,99,116,32,40,97,110,100,32,116,104,101,32,101,110,99,111,100,105,110,103,32,111,98,106,101,99,116,32,105,115,32,97,110,32,101,118,101,114,115,105,111,110,41,58,10,10,43,65,71,65,45,109,97,107,101,46,115,104,43,65,71,65,32,103,101,110,101,114,97,116,101,115,32,116,104,101,32,116,97,98,108,101,115,32,117,115,101,100,32,98,121,32,43,65,71,65,45,109,97,107,101,46,110,106,115,43,65,71,65,46,32,32,84,104,101,32,114,97,119,32,85,110,105,99,111,100,101,32,84,88,84,32,102,105,108,101,115,10,97,114,101,32,99,111,108,117,109,110,97,114,58,32,43,65,71,65,45,99,111,100,101,32,117,110,105,99,111,100,101,32,43,65,67,77,45,99,111,109,109,101,110,116,115,43,65,71,65,46,32,32,70,111,114,32,101,120,97,109,112,108,101,44,32,116,104,101,32,108,97,115,116,32,49,48,32,108,105,110,101,115,32,111,102,32,116,104,101,10,116,101,120,116,32,102,105,108,101,32,43,65,71,65,45,82,79,77,65,78,46,84,88,84,43,65,71,65,32,40,102,111,114,32,67,80,32,49,48,48,48,48,41,32,97,114,101,58,10,10,43,65,71,65,65,89,65,66,103,65,68,52,10,48,120,70,54,9,48,120,48,50,67,54,9,43,65,67,77,45,77,79,68,73,70,73,69,82,32,76,69,84,84,69,82,32,67,73,82,67,85,77,70,76,69,88,32,65,67,67,69,78,84,10,48,120,70,55,9,48,120,48,50,68,67,9,43,65,67,77,45,83,77,65,76,76,32,84,73,76,68,69,10,48,120,70,56,9,48,120,48,48,65,70,9,43,65,67,77,45,77,65,67,82,79,78,10,48,120,70,57,9,48,120,48,50,68,56,9,43,65,67,77,45,66,82,69,86,69,10,48,120,70,65,9,48,120,48,50,68,57,9,43,65,67,77,45,68,79,84,32,65,66,79,86,69,10,48,120,70,66,9,48,120,48,50,68,65,9,43,65,67,77,45,82,73,78,71,32,65,66,79,86,69,10,48,120,70,67,9,48,120,48,48,66,56,9,43,65,67,77,45,67,69,68,73,76,76,65,10,48,120,70,68,9,48,120,48,50,68,68,9,43,65,67,77,45,68,79,85,66,76,69,32,65,67,85,84,69,32,65,67,67,69,78,84,10,48,120,70,69,9,48,120,48,50,68,66,9,43,65,67,77,45,79,71,79,78,69,75,10,48,120,70,70,9,48,120,48,50,67,55,9,43,65,67,77,45,67,65,82,79,78,10,43,65,71,65,65,89,65,66,103,10,10,73,110,32,112,114,111,99,101,115,115,105,110,103,32,116,104,101,32,100,97,116,97,44,32,116,104,101,32,99,111,109,109,101,110,116,115,32,40,97,102,116,101,114,32,116,104,101,32,43,65,71,65,65,73,119,66,103,41,32,97,114,101,32,115,116,114,105,112,112,101,100,32,97,110,100,32,117,110,100,101,102,105,110,101,100,10,101,108,101,109,101,110,116,115,32,40,108,105,107,101,32,43,65,71,65,45,48,120,55,70,43,65,71,65,32,102,111,114,32,67,80,32,49,48,48,48,48,41,32,97,114,101,32,114,101,109,111,118,101,100,46,10,10,43,65,67,77,65,73,119,32,85,116,105,108,105,116,105,101,115,10,10,84,104,101,32,101,110,99,111,100,101,32,97,110,100,32,100,101,99,111,100,101,32,102,117,110,99,116,105,111,110,115,32,97,114,101,32,107,101,112,116,32,105,110,32,97,32,115,101,112,97,114,97,116,101,32,115,99,114,105,112,116,32,40,43,65,71,65,45,99,112,117,116,105,108,115,46,106,115,43,65,71,65,41,46,10,10,66,111,116,104,32,101,110,99,111,100,101,32,97,110,100,32,100,101,99,111,100,101,32,100,101,97,108,32,119,105,116,104,32,100,97,116,97,32,114,101,112,114,101,115,101,110,116,101,100,32,97,115,58,10,10,45,32,83,116,114,105,110,103,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,74,83,32,115,116,114,105,110,103,44,32,100,101,99,111,100,101,32,105,110,116,101,114,112,114,101,116,115,32,85,67,83,50,32,99,104,97,114,115,32,97,115,32,99,111,100,101,115,41,10,45,32,65,114,114,97,121,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,97,114,114,97,121,32,111,102,32,74,83,32,83,116,114,105,110,103,32,99,104,97,114,97,99,116,101,114,115,44,32,100,101,99,111,100,101,32,101,120,112,101,99,116,115,32,110,117,109,98,101,114,115,41,10,45,32,66,117,102,102,101,114,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,85,84,70,45,56,32,115,116,114,105,110,103,44,32,100,101,99,111,100,101,32,101,120,112,101,99,116,115,32,99,111,100,101,112,111,105,110,116,115,47,98,121,116,101,115,41,46,10,10,84,104,101,32,43,65,71,65,45,111,102,109,116,43,65,71,65,32,118,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,115,32,43,65,71,65,45,101,110,99,111,100,101,43,65,71,65,32,111,117,116,112,117,116,32,40,43,65,71,65,45,115,116,114,43,65,71,65,44,32,43,65,71,65,45,97,114,114,43,65,71,65,32,114,101,115,112,101,99,116,105,118,101,108,121,41,10,119,104,105,108,101,32,116,104,101,32,105,110,112,117,116,32,102,111,114,109,97,116,32,105,115,32,97,117,116,111,109,97,116,105,99,97,108,108,121,32,100,101,116,101,114,109,105,110,101,100,46,10,10,43,65,67,77,32,78,105,116,116,121,32,71,114,105,116,116,121,10,10,43,65,71,65,65,89,65,66,103,65,68,52,46,118,111,99,114,99,10,43,65,72,115,32,43,65,67,73,45,112,111,115,116,43,65,67,73,58,32,43,65,67,73,45,109,97,107,101,32,106,115,43,65,67,73,32,43,65,72,48,10,43,65,71,65,65,89,65,66,103,10]}
;
README['utf8'] = 
{"type":"Buffer","data":[35,32,71,101,116,116,105,110,103,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,102,105,101,108,100,115,32,111,102,32,116,104,101,32,96,112,97,103,101,115,46,99,115,118,96,32,109,97,110,105,102,101,115,116,32,97,114,101,32,96,99,111,100,101,112,97,103,101,44,117,114,108,44,98,121,116,101,115,96,32,40,83,66,67,83,61,49,44,32,68,66,67,83,61,50,41,10,10,78,111,116,101,32,116,104,97,116,32,116,104,101,32,87,105,110,100,111,119,115,32,114,101,110,100,101,114,105,110,103,32,105,115,32,117,115,101,100,32,102,111,114,32,116,104,101,32,77,97,99,32,99,111,100,101,32,112,97,103,101,115,46,32,32,84,104,101,32,112,114,105,109,97,114,121,10,100,105,102,102,101,114,101,110,99,101,32,105,115,32,116,104,101,32,117,115,101,32,111,102,32,116,104,101,32,112,114,105,118,97,116,101,32,96,48,120,70,56,70,70,96,32,99,111,100,101,32,40,119,104,105,99,104,32,114,101,110,100,101,114,115,32,97,115,32,97,110,32,65,112,112,108,101,10,108,111,103,111,32,111,110,32,109,97,99,115,32,98,117,116,32,97,115,32,103,97,114,98,97,103,101,32,111,110,32,111,116,104,101,114,32,111,112,101,114,97,116,105,110,103,32,115,121,115,116,101,109,115,41,46,32,32,73,116,32,109,97,121,32,98,101,32,100,101,115,105,114,97,98,108,101,10,116,111,32,102,97,108,108,32,98,97,99,107,32,116,111,32,116,104,101,32,98,101,104,97,118,105,111,114,44,32,105,110,32,119,104,105,99,104,32,99,97,115,101,32,116,104,101,32,102,105,108,101,115,32,97,114,101,32,117,110,100,101,114,32,65,80,80,76,69,32,97,110,100,32,110,111,116,10,77,73,67,83,70,84,46,32,32,84,104,105,115,32,97,102,102,101,99,116,115,32,99,111,100,101,112,97,103,101,115,32,49,48,48,48,48,44,32,49,48,48,48,54,44,32,49,48,48,48,55,44,32,49,48,48,50,57,44,32,49,48,48,55,57,44,32,49,48,48,56,49,10,10,84,104,101,32,110,117,109,98,101,114,105,110,103,32,115,99,104,101,109,101,32,102,111,114,32,116,104,101,32,96,73,83,79,45,56,56,53,57,45,88,96,32,115,101,114,105,101,115,32,105,115,32,96,50,56,53,57,48,32,43,32,88,96,58,10,10,35,35,32,71,101,110,101,114,97,116,101,100,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,102,111,108,108,111,119,105,110,103,32,99,111,100,101,112,97,103,101,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,32,105,110,32,46,78,69,84,32,111,110,32,87,105,110,100,111,119,115,58,10,10,45,32,55,48,56,32,32,32,65,114,97,98,105,99,32,40,65,83,77,79,32,55,48,56,41,10,45,32,55,50,48,32,32,32,65,114,97,98,105,99,32,40,84,114,97,110,115,112,97,114,101,110,116,32,65,83,77,79,41,59,32,65,114,97,98,105,99,32,40,68,79,83,41,10,45,32,56,53,56,32,32,32,79,69,77,32,77,117,108,116,105,108,105,110,103,117,97,108,32,76,97,116,105,110,32,49,32,43,32,69,117,114,111,32,115,121,109,98,111,108,10,45,32,56,55,48,32,32,32,73,66,77,32,69,66,67,68,73,67,32,77,117,108,116,105,108,105,110,103,117,97,108,47,82,79,69,67,69,32,40,76,97,116,105,110,32,50,41,59,32,73,66,77,32,69,66,67,68,73,67,32,77,117,108,116,105,108,105,110,103,117,97,108,32,76,97,116,105,110,32,50,10,45,32,49,48,52,55,32,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,49,47,79,112,101,110,32,83,121,115,116,101,109,10,45,32,49,49,52,48,32,32,73,66,77,32,69,66,67,68,73,67,32,85,83,45,67,97,110,97,100,97,32,40,48,51,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,85,83,45,67,97,110,97,100,97,45,69,117,114,111,41,10,45,32,49,49,52,49,32,32,73,66,77,32,69,66,67,68,73,67,32,71,101,114,109,97,110,121,32,40,50,48,50,55,51,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,71,101,114,109,97,110,121,45,69,117,114,111,41,10,45,32,49,49,52,50,32,32,73,66,77,32,69,66,67,68,73,67,32,68,101,110,109,97,114,107,45,78,111,114,119,97,121,32,40,50,48,50,55,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,68,101,110,109,97,114,107,45,78,111,114,119,97,121,45,69,117,114,111,41,10,45,32,49,49,52,51,32,32,73,66,77,32,69,66,67,68,73,67,32,70,105,110,108,97,110,100,45,83,119,101,100,101,110,32,40,50,48,50,55,56,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,70,105,110,108,97,110,100,45,83,119,101,100,101,110,45,69,117,114,111,41,10,45,32,49,49,52,52,32,32,73,66,77,32,69,66,67,68,73,67,32,73,116,97,108,121,32,40,50,48,50,56,48,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,73,116,97,108,121,45,69,117,114,111,41,10,45,32,49,49,52,53,32,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,65,109,101,114,105,99,97,45,83,112,97,105,110,32,40,50,48,50,56,52,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,83,112,97,105,110,45,69,117,114,111,41,10,45,32,49,49,52,54,32,32,73,66,77,32,69,66,67,68,73,67,32,85,110,105,116,101,100,32,75,105,110,103,100,111,109,32,40,50,48,50,56,53,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,85,75,45,69,117,114,111,41,10,45,32,49,49,52,55,32,32,73,66,77,32,69,66,67,68,73,67,32,70,114,97,110,99,101,32,40,50,48,50,57,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,70,114,97,110,99,101,45,69,117,114,111,41,10,45,32,49,49,52,56,32,32,73,66,77,32,69,66,67,68,73,67,32,73,110,116,101,114,110,97,116,105,111,110,97,108,32,40,53,48,48,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,73,110,116,101,114,110,97,116,105,111,110,97,108,45,69,117,114,111,41,10,45,32,49,49,52,57,32,32,73,66,77,32,69,66,67,68,73,67,32,73,99,101,108,97,110,100,105,99,32,40,50,48,56,55,49,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,59,32,73,66,77,32,69,66,67,68,73,67,32,40,73,99,101,108,97,110,100,105,99,45,69,117,114,111,41,10,45,32,49,51,54,49,32,32,75,111,114,101,97,110,32,40,74,111,104,97,98,41,10,45,32,49,48,48,48,49,32,74,97,112,97,110,101,115,101,32,40,77,97,99,41,10,45,32,49,48,48,48,50,32,77,65,67,32,84,114,97,100,105,116,105,111,110,97,108,32,67,104,105,110,101,115,101,32,40,66,105,103,53,41,59,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,77,97,99,41,10,45,32,49,48,48,48,51,32,75,111,114,101,97,110,32,40,77,97,99,41,10,45,32,49,48,48,48,52,32,65,114,97,98,105,99,32,40,77,97,99,41,10,45,32,49,48,48,48,53,32,72,101,98,114,101,119,32,40,77,97,99,41,10,45,32,49,48,48,48,56,32,77,65,67,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,71,66,32,50,51,49,50,41,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,77,97,99,41,10,45,32,49,48,48,49,48,32,82,111,109,97,110,105,97,110,32,40,77,97,99,41,10,45,32,49,48,48,49,55,32,85,107,114,97,105,110,105,97,110,32,40,77,97,99,41,10,45,32,49,48,48,50,49,32,84,104,97,105,32,40,77,97,99,41,10,45,32,49,48,48,56,50,32,67,114,111,97,116,105,97,110,32,40,77,97,99,41,10,45,32,50,48,48,48,48,32,67,78,83,32,84,97,105,119,97,110,59,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,67,78,83,41,10,45,32,50,48,48,48,49,32,84,67,65,32,84,97,105,119,97,110,10,45,32,50,48,48,48,50,32,69,84,69,78,32,84,97,105,119,97,110,59,32,67,104,105,110,101,115,101,32,84,114,97,100,105,116,105,111,110,97,108,32,40,69,84,69,78,41,10,45,32,50,48,48,48,51,32,73,66,77,53,53,53,48,32,84,97,105,119,97,110,10,45,32,50,48,48,48,52,32,84,101,108,101,84,101,120,116,32,84,97,105,119,97,110,10,45,32,50,48,48,48,53,32,87,97,110,103,32,84,97,105,119,97,110,10,45,32,50,48,49,48,53,32,73,65,53,32,40,73,82,86,32,73,110,116,101,114,110,97,116,105,111,110,97,108,32,65,108,112,104,97,98,101,116,32,78,111,46,32,53,44,32,55,45,98,105,116,41,59,32,87,101,115,116,101,114,110,32,69,117,114,111,112,101,97,110,32,40,73,65,53,41,10,45,32,50,48,49,48,54,32,73,65,53,32,71,101,114,109,97,110,32,40,55,45,98,105,116,41,10,45,32,50,48,49,48,55,32,73,65,53,32,83,119,101,100,105,115,104,32,40,55,45,98,105,116,41,10,45,32,50,48,49,48,56,32,73,65,53,32,78,111,114,119,101,103,105,97,110,32,40,55,45,98,105,116,41,10,45,32,50,48,50,54,49,32,84,46,54,49,10,45,32,50,48,50,54,57,32,73,83,79,32,54,57,51,55,32,78,111,110,45,83,112,97,99,105,110,103,32,65,99,99,101,110,116,10,45,32,50,48,50,55,51,32,73,66,77,32,69,66,67,68,73,67,32,71,101,114,109,97,110,121,10,45,32,50,48,50,55,55,32,73,66,77,32,69,66,67,68,73,67,32,68,101,110,109,97,114,107,45,78,111,114,119,97,121,10,45,32,50,48,50,55,56,32,73,66,77,32,69,66,67,68,73,67,32,70,105,110,108,97,110,100,45,83,119,101,100,101,110,10,45,32,50,48,50,56,48,32,73,66,77,32,69,66,67,68,73,67,32,73,116,97,108,121,10,45,32,50,48,50,56,52,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,65,109,101,114,105,99,97,45,83,112,97,105,110,10,45,32,50,48,50,56,53,32,73,66,77,32,69,66,67,68,73,67,32,85,110,105,116,101,100,32,75,105,110,103,100,111,109,10,45,32,50,48,50,57,48,32,73,66,77,32,69,66,67,68,73,67,32,74,97,112,97,110,101,115,101,32,75,97,116,97,107,97,110,97,32,69,120,116,101,110,100,101,100,10,45,32,50,48,50,57,55,32,73,66,77,32,69,66,67,68,73,67,32,70,114,97,110,99,101,10,45,32,50,48,52,50,48,32,73,66,77,32,69,66,67,68,73,67,32,65,114,97,98,105,99,10,45,32,50,48,52,50,51,32,73,66,77,32,69,66,67,68,73,67,32,71,114,101,101,107,10,45,32,50,48,52,50,52,32,73,66,77,32,69,66,67,68,73,67,32,72,101,98,114,101,119,10,45,32,50,48,56,51,51,32,73,66,77,32,69,66,67,68,73,67,32,75,111,114,101,97,110,32,69,120,116,101,110,100,101,100,10,45,32,50,48,56,51,56,32,73,66,77,32,69,66,67,68,73,67,32,84,104,97,105,10,45,32,50,48,56,54,54,32,82,117,115,115,105,97,110,32,40,75,79,73,56,45,82,41,59,32,67,121,114,105,108,108,105,99,32,40,75,79,73,56,45,82,41,10,45,32,50,48,56,55,49,32,73,66,77,32,69,66,67,68,73,67,32,73,99,101,108,97,110,100,105,99,10,45,32,50,48,56,56,48,32,73,66,77,32,69,66,67,68,73,67,32,67,121,114,105,108,108,105,99,32,82,117,115,115,105,97,110,10,45,32,50,48,57,48,53,32,73,66,77,32,69,66,67,68,73,67,32,84,117,114,107,105,115,104,10,45,32,50,48,57,50,52,32,73,66,77,32,69,66,67,68,73,67,32,76,97,116,105,110,32,49,47,79,112,101,110,32,83,121,115,116,101,109,32,40,49,48,52,55,32,43,32,69,117,114,111,32,115,121,109,98,111,108,41,10,45,32,50,48,57,51,50,32,74,97,112,97,110,101,115,101,32,40,74,73,83,32,48,50,48,56,45,49,57,57,48,32,97,110,100,32,48,50,49,50,45,49,57,57,48,41,10,45,32,50,48,57,51,54,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,71,66,50,51,49,50,41,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,71,66,50,51,49,50,45,56,48,41,10,45,32,50,48,57,52,57,32,75,111,114,101,97,110,32,87,97,110,115,117,110,103,10,45,32,50,49,48,50,53,32,73,66,77,32,69,66,67,68,73,67,32,67,121,114,105,108,108,105,99,32,83,101,114,98,105,97,110,45,66,117,108,103,97,114,105,97,110,10,45,32,50,49,48,50,55,32,69,120,116,101,110,100,101,100,47,69,120,116,32,65,108,112,104,97,32,76,111,119,101,114,99,97,115,101,10,45,32,50,49,56,54,54,32,85,107,114,97,105,110,105,97,110,32,40,75,79,73,56,45,85,41,59,32,67,121,114,105,108,108,105,99,32,40,75,79,73,56,45,85,41,10,45,32,50,57,48,48,49,32,69,117,114,111,112,97,32,51,10,45,32,51,56,53,57,56,32,73,83,79,32,56,56,53,57,45,56,32,72,101,98,114,101,119,59,32,72,101,98,114,101,119,32,40,73,83,79,45,76,111,103,105,99,97,108,41,10,45,32,53,49,57,51,50,32,69,85,67,32,74,97,112,97,110,101,115,101,10,45,32,53,49,57,51,54,32,69,85,67,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,69,85,67,41,10,45,32,53,49,57,52,57,32,69,85,67,32,75,111,114,101,97,110,10,45,32,53,50,57,51,54,32,72,90,45,71,66,50,51,49,50,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,72,90,41,10,45,32,53,52,57,51,54,32,87,105,110,100,111,119,115,32,88,80,32,97,110,100,32,108,97,116,101,114,58,32,71,66,49,56,48,51,48,32,83,105,109,112,108,105,102,105,101,100,32,67,104,105,110,101,115,101,32,40,52,32,98,121,116,101,41,59,32,67,104,105,110,101,115,101,32,83,105,109,112,108,105,102,105,101,100,32,40,71,66,49,56,48,51,48,41,10,45,32,53,55,48,48,50,32,73,83,67,73,73,32,68,101,118,97,110,97,103,97,114,105,10,45,32,53,55,48,48,51,32,73,83,67,73,73,32,66,101,110,103,97,108,105,10,45,32,53,55,48,48,52,32,73,83,67,73,73,32,84,97,109,105,108,10,45,32,53,55,48,48,53,32,73,83,67,73,73,32,84,101,108,117,103,117,10,45,32,53,55,48,48,54,32,73,83,67,73,73,32,65,115,115,97,109,101,115,101,10,45,32,53,55,48,48,55,32,73,83,67,73,73,32,79,114,105,121,97,10,45,32,53,55,48,48,56,32,73,83,67,73,73,32,75,97,110,110,97,100,97,10,45,32,53,55,48,48,57,32,73,83,67,73,73,32,77,97,108,97,121,97,108,97,109,10,45,32,53,55,48,49,48,32,73,83,67,73,73,32,71,117,106,97,114,97,116,105,10,45,32,53,55,48,49,49,32,73,83,67,73,73,32,80,117,110,106,97,98,105,10,10,84,104,101,32,102,111,108,108,111,119,105,110,103,32,99,111,100,101,112,97,103,101,115,32,97,114,101,32,100,101,112,101,110,100,101,110,99,105,101,115,32,102,111,114,32,86,105,115,117,97,108,32,70,111,120,80,114,111,58,10,10,45,32,54,50,48,32,77,97,122,111,118,105,97,32,40,80,111,108,105,115,104,41,32,77,83,45,68,79,83,10,45,32,56,57,53,32,75,97,109,101,110,105,99,107,195,189,32,40,67,122,101,99,104,41,32,77,83,45,68,79,83,10,10,35,35,32,66,117,105,108,100,105,110,103,32,78,111,116,101,115,10,10,84,104,101,32,115,99,114,105,112,116,32,96,109,97,107,101,46,115,104,96,32,40,100,101,115,99,114,105,98,101,100,32,108,97,116,101,114,41,32,119,105,108,108,32,103,101,116,32,116,104,101,115,101,32,102,105,108,101,115,32,97,110,100,32,109,97,115,115,97,103,101,32,116,104,101,32,100,97,116,97,10,40,112,114,105,110,116,105,110,103,32,99,111,100,101,45,85,110,105,99,111,100,101,32,112,97,105,114,115,41,46,32,32,84,104,101,32,101,118,101,110,116,117,97,108,32,116,97,98,108,101,115,32,97,114,101,32,100,114,111,112,112,101,100,32,105,110,32,116,104,101,32,112,97,116,104,115,10,96,46,47,99,111,100,101,112,97,103,101,115,47,60,67,79,68,69,80,65,71,69,62,46,84,66,76,96,46,32,32,70,111,114,32,101,120,97,109,112,108,101,44,32,116,104,101,32,108,97,115,116,32,49,48,32,108,105,110,101,115,32,111,102,32,96,49,48,48,48,48,46,84,66,76,96,32,97,114,101,10,10,96,96,96,62,10,48,120,70,54,9,48,120,48,50,67,54,10,48,120,70,55,9,48,120,48,50,68,67,10,48,120,70,56,9,48,120,48,48,65,70,10,48,120,70,57,9,48,120,48,50,68,56,10,48,120,70,65,9,48,120,48,50,68,57,10,48,120,70,66,9,48,120,48,50,68,65,10,48,120,70,67,9,48,120,48,48,66,56,10,48,120,70,68,9,48,120,48,50,68,68,10,48,120,70,69,9,48,120,48,50,68,66,10,48,120,70,70,9,48,120,48,50,67,55,10,96,96,96,10,10,119,104,105,99,104,32,105,109,112,108,105,101,115,32,116,104,97,116,32,99,111,100,101,32,96,48,120,70,54,96,32,105,115,32,96,83,116,114,105,110,103,46,102,114,111,109,67,104,97,114,67,111,100,101,40,48,120,48,50,67,54,41,96,32,97,110,100,32,118,105,99,101,32,118,101,114,115,97,46,10,10,35,35,32,87,105,110,100,111,119,115,45,100,101,112,101,110,100,101,110,116,32,98,117,105,108,100,32,115,116,101,112,10,10,84,111,32,98,117,105,108,100,32,116,104,101,32,115,111,117,114,99,101,115,32,111,110,32,119,105,110,100,111,119,115,44,32,99,111,110,115,117,108,116,32,96,100,111,116,110,101,116,47,77,97,107,101,69,110,99,111,100,105,110,103,46,99,115,96,46,10,10,65,102,116,101,114,32,115,97,118,105,110,103,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,32,116,111,32,96,111,117,116,96,44,32,116,104,101,32,96,100,111,116,110,101,116,46,115,104,96,32,115,99,114,105,112,116,32,112,114,111,99,101,115,115,101,115,32,114,101,115,117,108,116,115,46,32,10,10,35,32,66,117,105,108,100,105,110,103,32,116,104,101,32,115,99,114,105,112,116,10,10,96,109,97,107,101,46,110,106,115,96,32,116,97,107,101,115,32,97,32,99,111,100,101,112,97,103,101,32,97,114,103,117,109,101,110,116,44,32,114,101,97,100,115,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,116,97,98,108,101,32,102,105,108,101,32,97,110,100,10,103,101,110,101,114,97,116,101,115,32,74,83,32,99,111,100,101,32,102,111,114,32,101,110,99,111,100,105,110,103,32,97,110,100,32,100,101,99,111,100,105,110,103,58,10,10,35,35,32,82,97,119,32,67,111,100,101,112,97,103,101,115,10,10,84,104,101,32,68,66,67,83,32,97,110,100,32,83,66,67,83,32,99,111,100,101,32,103,101,110,101,114,97,116,105,111,110,32,115,116,114,97,116,101,103,105,101,115,32,97,114,101,32,100,105,102,102,101,114,101,110,116,46,32,32,84,104,101,32,109,97,120,105,109,117,109,32,99,111,100,101,32,105,115,10,117,115,101,100,32,116,111,32,100,105,115,116,105,110,103,117,105,115,104,32,40,109,97,120,32,96,48,120,70,70,96,32,102,111,114,32,83,66,67,83,41,46,10,10,84,104,101,32,85,110,105,99,111,100,101,32,99,104,97,114,97,99,116,101,114,32,96,48,120,70,70,70,68,96,32,40,82,69,80,76,65,67,69,77,69,78,84,32,67,72,65,82,65,67,84,69,82,41,32,105,115,32,117,115,101,100,32,97,115,32,97,32,112,108,97,99,101,104,111,108,100,101,114,10,102,111,114,32,99,104,97,114,97,99,116,101,114,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,109,97,112,32,40,102,111,114,32,101,120,97,109,112,108,101,44,32,96,48,120,70,48,96,32,105,115,32,110,111,116,32,105,110,10,99,111,100,101,32,112,97,103,101,32,49,48,48,48,48,41,46,10,10,70,111,114,32,83,66,67,83,44,32,116,104,101,32,105,100,101,97,32,105,115,32,116,111,32,101,109,98,101,100,32,97,32,114,97,119,32,115,116,114,105,110,103,32,119,105,116,104,32,116,104,101,32,99,111,110,116,101,110,116,115,32,111,102,32,116,104,101,32,50,53,54,32,99,111,100,101,115,46,10,84,104,101,32,96,100,101,99,96,32,102,105,101,108,100,32,105,115,32,109,101,114,101,108,121,32,97,32,115,112,108,105,116,32,111,102,32,116,104,101,32,115,116,114,105,110,103,44,32,97,110,100,32,96,101,110,99,96,32,105,115,32,97,110,32,101,118,101,114,115,105,111,110,58,10,10,68,66,67,83,32,105,115,32,115,105,109,105,108,97,114,44,32,101,120,99,101,112,116,32,116,104,97,116,32,116,104,101,32,115,112,97,99,101,32,105,115,32,115,108,105,99,101,100,32,105,110,32,99,104,117,110,107,115,32,111,102,32,50,53,54,32,98,121,116,101,115,32,40,115,116,114,105,110,103,115,10,97,114,101,32,111,110,108,121,32,103,101,110,101,114,97,116,101,100,32,102,111,114,32,116,104,111,115,101,32,104,105,103,104,45,98,121,116,101,115,32,114,101,112,114,101,115,101,110,116,101,100,32,105,110,32,116,104,101,32,99,111,100,101,112,97,103,101,41,46,10,10,84,104,101,32,115,116,114,97,116,101,103,121,32,105,115,32,116,111,32,99,111,110,115,116,114,117,99,116,32,97,110,32,97,114,114,97,121,45,111,102,45,97,114,114,97,121,115,32,115,111,32,116,104,97,116,32,96,100,100,91,104,105,103,104,93,91,108,111,119,93,96,32,105,115,32,116,104,101,10,99,104,97,114,97,99,116,101,114,32,97,115,115,111,99,105,97,116,101,100,32,119,105,116,104,32,116,104,101,32,99,111,100,101,46,32,32,84,104,105,115,32,97,114,114,97,121,32,105,115,32,99,111,109,98,105,110,101,100,32,97,116,32,114,117,110,116,105,109,101,32,116,111,32,121,105,101,108,100,10,116,104,101,32,99,111,109,112,108,101,116,101,32,100,101,99,111,100,105,110,103,32,111,98,106,101,99,116,32,40,97,110,100,32,116,104,101,32,101,110,99,111,100,105,110,103,32,111,98,106,101,99,116,32,105,115,32,97,110,32,101,118,101,114,115,105,111,110,41,58,10,10,96,109,97,107,101,46,115,104,96,32,103,101,110,101,114,97,116,101,115,32,116,104,101,32,116,97,98,108,101,115,32,117,115,101,100,32,98,121,32,96,109,97,107,101,46,110,106,115,96,46,32,32,84,104,101,32,114,97,119,32,85,110,105,99,111,100,101,32,84,88,84,32,102,105,108,101,115,10,97,114,101,32,99,111,108,117,109,110,97,114,58,32,96,99,111,100,101,32,117,110,105,99,111,100,101,32,35,99,111,109,109,101,110,116,115,96,46,32,32,70,111,114,32,101,120,97,109,112,108,101,44,32,116,104,101,32,108,97,115,116,32,49,48,32,108,105,110,101,115,32,111,102,32,116,104,101,10,116,101,120,116,32,102,105,108,101,32,96,82,79,77,65,78,46,84,88,84,96,32,40,102,111,114,32,67,80,32,49,48,48,48,48,41,32,97,114,101,58,10,10,96,96,96,62,10,48,120,70,54,9,48,120,48,50,67,54,9,35,77,79,68,73,70,73,69,82,32,76,69,84,84,69,82,32,67,73,82,67,85,77,70,76,69,88,32,65,67,67,69,78,84,10,48,120,70,55,9,48,120,48,50,68,67,9,35,83,77,65,76,76,32,84,73,76,68,69,10,48,120,70,56,9,48,120,48,48,65,70,9,35,77,65,67,82,79,78,10,48,120,70,57,9,48,120,48,50,68,56,9,35,66,82,69,86,69,10,48,120,70,65,9,48,120,48,50,68,57,9,35,68,79,84,32,65,66,79,86,69,10,48,120,70,66,9,48,120,48,50,68,65,9,35,82,73,78,71,32,65,66,79,86,69,10,48,120,70,67,9,48,120,48,48,66,56,9,35,67,69,68,73,76,76,65,10,48,120,70,68,9,48,120,48,50,68,68,9,35,68,79,85,66,76,69,32,65,67,85,84,69,32,65,67,67,69,78,84,10,48,120,70,69,9,48,120,48,50,68,66,9,35,79,71,79,78,69,75,10,48,120,70,70,9,48,120,48,50,67,55,9,35,67,65,82,79,78,10,96,96,96,10,10,73,110,32,112,114,111,99,101,115,115,105,110,103,32,116,104,101,32,100,97,116,97,44,32,116,104,101,32,99,111,109,109,101,110,116,115,32,40,97,102,116,101,114,32,116,104,101,32,96,35,96,41,32,97,114,101,32,115,116,114,105,112,112,101,100,32,97,110,100,32,117,110,100,101,102,105,110,101,100,10,101,108,101,109,101,110,116,115,32,40,108,105,107,101,32,96,48,120,55,70,96,32,102,111,114,32,67,80,32,49,48,48,48,48,41,32,97,114,101,32,114,101,109,111,118,101,100,46,10,10,35,35,32,85,116,105,108,105,116,105,101,115,10,10,84,104,101,32,101,110,99,111,100,101,32,97,110,100,32,100,101,99,111,100,101,32,102,117,110,99,116,105,111,110,115,32,97,114,101,32,107,101,112,116,32,105,110,32,97,32,115,101,112,97,114,97,116,101,32,115,99,114,105,112,116,32,40,96,99,112,117,116,105,108,115,46,106,115,96,41,46,10,10,66,111,116,104,32,101,110,99,111,100,101,32,97,110,100,32,100,101,99,111,100,101,32,100,101,97,108,32,119,105,116,104,32,100,97,116,97,32,114,101,112,114,101,115,101,110,116,101,100,32,97,115,58,10,10,45,32,83,116,114,105,110,103,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,74,83,32,115,116,114,105,110,103,44,32,100,101,99,111,100,101,32,105,110,116,101,114,112,114,101,116,115,32,85,67,83,50,32,99,104,97,114,115,32,97,115,32,99,111,100,101,115,41,10,45,32,65,114,114,97,121,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,97,114,114,97,121,32,111,102,32,74,83,32,83,116,114,105,110,103,32,99,104,97,114,97,99,116,101,114,115,44,32,100,101,99,111,100,101,32,101,120,112,101,99,116,115,32,110,117,109,98,101,114,115,41,10,45,32,66,117,102,102,101,114,32,40,101,110,99,111,100,101,32,101,120,112,101,99,116,115,32,85,84,70,45,56,32,115,116,114,105,110,103,44,32,100,101,99,111,100,101,32,101,120,112,101,99,116,115,32,99,111,100,101,112,111,105,110,116,115,47,98,121,116,101,115,41,46,10,10,84,104,101,32,96,111,102,109,116,96,32,118,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,115,32,96,101,110,99,111,100,101,96,32,111,117,116,112,117,116,32,40,96,115,116,114,96,44,32,96,97,114,114,96,32,114,101,115,112,101,99,116,105,118,101,108,121,41,10,119,104,105,108,101,32,116,104,101,32,105,110,112,117,116,32,102,111,114,109,97,116,32,105,115,32,97,117,116,111,109,97,116,105,99,97,108,108,121,32,100,101,116,101,114,109,105,110,101,100,46,10,10,35,32,78,105,116,116,121,32,71,114,105,116,116,121,10,10,96,96,96,62,46,118,111,99,114,99,10,123,32,34,112,111,115,116,34,58,32,34,109,97,107,101,32,106,115,34,32,125,10,96,96,96,10]}
;
README['utf16le'] = 
{"type":"Buffer","data":[35,0,32,0,71,0,101,0,116,0,116,0,105,0,110,0,103,0,32,0,67,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,102,0,105,0,101,0,108,0,100,0,115,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,96,0,112,0,97,0,103,0,101,0,115,0,46,0,99,0,115,0,118,0,96,0,32,0,109,0,97,0,110,0,105,0,102,0,101,0,115,0,116,0,32,0,97,0,114,0,101,0,32,0,96,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,44,0,117,0,114,0,108,0,44,0,98,0,121,0,116,0,101,0,115,0,96,0,32,0,40,0,83,0,66,0,67,0,83,0,61,0,49,0,44,0,32,0,68,0,66,0,67,0,83,0,61,0,50,0,41,0,10,0,10,0,78,0,111,0,116,0,101,0,32,0,116,0,104,0,97,0,116,0,32,0,116,0,104,0,101,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,32,0,114,0,101,0,110,0,100,0,101,0,114,0,105,0,110,0,103,0,32,0,105,0,115,0,32,0,117,0,115,0,101,0,100,0,32,0,102,0,111,0,114,0,32,0,116,0,104,0,101,0,32,0,77,0,97,0,99,0,32,0,99,0,111,0,100,0,101,0,32,0,112,0,97,0,103,0,101,0,115,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,112,0,114,0,105,0,109,0,97,0,114,0,121,0,10,0,100,0,105,0,102,0,102,0,101,0,114,0,101,0,110,0,99,0,101,0,32,0,105,0,115,0,32,0,116,0,104,0,101,0,32,0,117,0,115,0,101,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,112,0,114,0,105,0,118,0,97,0,116,0,101,0,32,0,96,0,48,0,120,0,70,0,56,0,70,0,70,0,96,0,32,0,99,0,111,0,100,0,101,0,32,0,40,0,119,0,104,0,105,0,99,0,104,0,32,0,114,0,101,0,110,0,100,0,101,0,114,0,115,0,32,0,97,0,115,0,32,0,97,0,110,0,32,0,65,0,112,0,112,0,108,0,101,0,10,0,108,0,111,0,103,0,111,0,32,0,111,0,110,0,32,0,109,0,97,0,99,0,115,0,32,0,98,0,117,0,116,0,32,0,97,0,115,0,32,0,103,0,97,0,114,0,98,0,97,0,103,0,101,0,32,0,111,0,110,0,32,0,111,0,116,0,104,0,101,0,114,0,32,0,111,0,112,0,101,0,114,0,97,0,116,0,105,0,110,0,103,0,32,0,115,0,121,0,115,0,116,0,101,0,109,0,115,0,41,0,46,0,32,0,32,0,73,0,116,0,32,0,109,0,97,0,121,0,32,0,98,0,101,0,32,0,100,0,101,0,115,0,105,0,114,0,97,0,98,0,108,0,101,0,10,0,116,0,111,0,32,0,102,0,97,0,108,0,108,0,32,0,98,0,97,0,99,0,107,0,32,0,116,0,111,0,32,0,116,0,104,0,101,0,32,0,98,0,101,0,104,0,97,0,118,0,105,0,111,0,114,0,44,0,32,0,105,0,110,0,32,0,119,0,104,0,105,0,99,0,104,0,32,0,99,0,97,0,115,0,101,0,32,0,116,0,104,0,101,0,32,0,102,0,105,0,108,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,117,0,110,0,100,0,101,0,114,0,32,0,65,0,80,0,80,0,76,0,69,0,32,0,97,0,110,0,100,0,32,0,110,0,111,0,116,0,10,0,77,0,73,0,67,0,83,0,70,0,84,0,46,0,32,0,32,0,84,0,104,0,105,0,115,0,32,0,97,0,102,0,102,0,101,0,99,0,116,0,115,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,32,0,49,0,48,0,48,0,48,0,48,0,44,0,32,0,49,0,48,0,48,0,48,0,54,0,44,0,32,0,49,0,48,0,48,0,48,0,55,0,44,0,32,0,49,0,48,0,48,0,50,0,57,0,44,0,32,0,49,0,48,0,48,0,55,0,57,0,44,0,32,0,49,0,48,0,48,0,56,0,49,0,10,0,10,0,84,0,104,0,101,0,32,0,110,0,117,0,109,0,98,0,101,0,114,0,105,0,110,0,103,0,32,0,115,0,99,0,104,0,101,0,109,0,101,0,32,0,102,0,111,0,114,0,32,0,116,0,104,0,101,0,32,0,96,0,73,0,83,0,79,0,45,0,56,0,56,0,53,0,57,0,45,0,88,0,96,0,32,0,115,0,101,0,114,0,105,0,101,0,115,0,32,0,105,0,115,0,32,0,96,0,50,0,56,0,53,0,57,0,48,0,32,0,43,0,32,0,88,0,96,0,58,0,10,0,10,0,35,0,35,0,32,0,71,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,100,0,32,0,67,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,102,0,111,0,108,0,108,0,111,0,119,0,105,0,110,0,103,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,97,0,118,0,97,0,105,0,108,0,97,0,98,0,108,0,101,0,32,0,105,0,110,0,32,0,46,0,78,0,69,0,84,0,32,0,111,0,110,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,58,0,10,0,10,0,45,0,32,0,55,0,48,0,56,0,32,0,32,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,65,0,83,0,77,0,79,0,32,0,55,0,48,0,56,0,41,0,10,0,45,0,32,0,55,0,50,0,48,0,32,0,32,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,84,0,114,0,97,0,110,0,115,0,112,0,97,0,114,0,101,0,110,0,116,0,32,0,65,0,83,0,77,0,79,0,41,0,59,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,68,0,79,0,83,0,41,0,10,0,45,0,32,0,56,0,53,0,56,0,32,0,32,0,32,0,79,0,69,0,77,0,32,0,77,0,117,0,108,0,116,0,105,0,108,0,105,0,110,0,103,0,117,0,97,0,108,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,49,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,10,0,45,0,32,0,56,0,55,0,48,0,32,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,77,0,117,0,108,0,116,0,105,0,108,0,105,0,110,0,103,0,117,0,97,0,108,0,47,0,82,0,79,0,69,0,67,0,69,0,32,0,40,0,76,0,97,0,116,0,105,0,110,0,32,0,50,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,77,0,117,0,108,0,116,0,105,0,108,0,105,0,110,0,103,0,117,0,97,0,108,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,50,0,10,0,45,0,32,0,49,0,48,0,52,0,55,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,49,0,47,0,79,0,112,0,101,0,110,0,32,0,83,0,121,0,115,0,116,0,101,0,109,0,10,0,45,0,32,0,49,0,49,0,52,0,48,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,85,0,83,0,45,0,67,0,97,0,110,0,97,0,100,0,97,0,32,0,40,0,48,0,51,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,85,0,83,0,45,0,67,0,97,0,110,0,97,0,100,0,97,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,49,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,71,0,101,0,114,0,109,0,97,0,110,0,121,0,32,0,40,0,50,0,48,0,50,0,55,0,51,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,71,0,101,0,114,0,109,0,97,0,110,0,121,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,50,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,68,0,101,0,110,0,109,0,97,0,114,0,107,0,45,0,78,0,111,0,114,0,119,0,97,0,121,0,32,0,40,0,50,0,48,0,50,0,55,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,68,0,101,0,110,0,109,0,97,0,114,0,107,0,45,0,78,0,111,0,114,0,119,0,97,0,121,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,51,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,105,0,110,0,108,0,97,0,110,0,100,0,45,0,83,0,119,0,101,0,100,0,101,0,110,0,32,0,40,0,50,0,48,0,50,0,55,0,56,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,70,0,105,0,110,0,108,0,97,0,110,0,100,0,45,0,83,0,119,0,101,0,100,0,101,0,110,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,52,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,116,0,97,0,108,0,121,0,32,0,40,0,50,0,48,0,50,0,56,0,48,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,73,0,116,0,97,0,108,0,121,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,53,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,65,0,109,0,101,0,114,0,105,0,99,0,97,0,45,0,83,0,112,0,97,0,105,0,110,0,32,0,40,0,50,0,48,0,50,0,56,0,52,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,83,0,112,0,97,0,105,0,110,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,54,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,85,0,110,0,105,0,116,0,101,0,100,0,32,0,75,0,105,0,110,0,103,0,100,0,111,0,109,0,32,0,40,0,50,0,48,0,50,0,56,0,53,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,85,0,75,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,55,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,114,0,97,0,110,0,99,0,101,0,32,0,40,0,50,0,48,0,50,0,57,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,70,0,114,0,97,0,110,0,99,0,101,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,56,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,110,0,116,0,101,0,114,0,110,0,97,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,53,0,48,0,48,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,73,0,110,0,116,0,101,0,114,0,110,0,97,0,116,0,105,0,111,0,110,0,97,0,108,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,57,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,99,0,101,0,108,0,97,0,110,0,100,0,105,0,99,0,32,0,40,0,50,0,48,0,56,0,55,0,49,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,73,0,99,0,101,0,108,0,97,0,110,0,100,0,105,0,99,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,51,0,54,0,49,0,32,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,40,0,74,0,111,0,104,0,97,0,98,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,49,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,50,0,32,0,77,0,65,0,67,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,66,0,105,0,103,0,53,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,51,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,52,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,53,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,56,0,32,0,77,0,65,0,67,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,71,0,66,0,32,0,50,0,51,0,49,0,50,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,49,0,48,0,32,0,82,0,111,0,109,0,97,0,110,0,105,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,49,0,55,0,32,0,85,0,107,0,114,0,97,0,105,0,110,0,105,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,50,0,49,0,32,0,84,0,104,0,97,0,105,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,56,0,50,0,32,0,67,0,114,0,111,0,97,0,116,0,105,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,48,0,32,0,67,0,78,0,83,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,67,0,78,0,83,0,41,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,49,0,32,0,84,0,67,0,65,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,50,0,32,0,69,0,84,0,69,0,78,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,69,0,84,0,69,0,78,0,41,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,51,0,32,0,73,0,66,0,77,0,53,0,53,0,53,0,48,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,52,0,32,0,84,0,101,0,108,0,101,0,84,0,101,0,120,0,116,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,53,0,32,0,87,0,97,0,110,0,103,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,53,0,32,0,73,0,65,0,53,0,32,0,40,0,73,0,82,0,86,0,32,0,73,0,110,0,116,0,101,0,114,0,110,0,97,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,65,0,108,0,112,0,104,0,97,0,98,0,101,0,116,0,32,0,78,0,111,0,46,0,32,0,53,0,44,0,32,0,55,0,45,0,98,0,105,0,116,0,41,0,59,0,32,0,87,0,101,0,115,0,116,0,101,0,114,0,110,0,32,0,69,0,117,0,114,0,111,0,112,0,101,0,97,0,110,0,32,0,40,0,73,0,65,0,53,0,41,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,54,0,32,0,73,0,65,0,53,0,32,0,71,0,101,0,114,0,109,0,97,0,110,0,32,0,40,0,55,0,45,0,98,0,105,0,116,0,41,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,55,0,32,0,73,0,65,0,53,0,32,0,83,0,119,0,101,0,100,0,105,0,115,0,104,0,32,0,40,0,55,0,45,0,98,0,105,0,116,0,41,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,56,0,32,0,73,0,65,0,53,0,32,0,78,0,111,0,114,0,119,0,101,0,103,0,105,0,97,0,110,0,32,0,40,0,55,0,45,0,98,0,105,0,116,0,41,0,10,0,45,0,32,0,50,0,48,0,50,0,54,0,49,0,32,0,84,0,46,0,54,0,49,0,10,0,45,0,32,0,50,0,48,0,50,0,54,0,57,0,32,0,73,0,83,0,79,0,32,0,54,0,57,0,51,0,55,0,32,0,78,0,111,0,110,0,45,0,83,0,112,0,97,0,99,0,105,0,110,0,103,0,32,0,65,0,99,0,99,0,101,0,110,0,116,0,10,0,45,0,32,0,50,0,48,0,50,0,55,0,51,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,71,0,101,0,114,0,109,0,97,0,110,0,121,0,10,0,45,0,32,0,50,0,48,0,50,0,55,0,55,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,68,0,101,0,110,0,109,0,97,0,114,0,107,0,45,0,78,0,111,0,114,0,119,0,97,0,121,0,10,0,45,0,32,0,50,0,48,0,50,0,55,0,56,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,105,0,110,0,108,0,97,0,110,0,100,0,45,0,83,0,119,0,101,0,100,0,101,0,110,0,10,0,45,0,32,0,50,0,48,0,50,0,56,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,116,0,97,0,108,0,121,0,10,0,45,0,32,0,50,0,48,0,50,0,56,0,52,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,65,0,109,0,101,0,114,0,105,0,99,0,97,0,45,0,83,0,112,0,97,0,105,0,110,0,10,0,45,0,32,0,50,0,48,0,50,0,56,0,53,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,85,0,110,0,105,0,116,0,101,0,100,0,32,0,75,0,105,0,110,0,103,0,100,0,111,0,109,0,10,0,45,0,32,0,50,0,48,0,50,0,57,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,32,0,75,0,97,0,116,0,97,0,107,0,97,0,110,0,97,0,32,0,69,0,120,0,116,0,101,0,110,0,100,0,101,0,100,0,10,0,45,0,32,0,50,0,48,0,50,0,57,0,55,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,114,0,97,0,110,0,99,0,101,0,10,0,45,0,32,0,50,0,48,0,52,0,50,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,10,0,45,0,32,0,50,0,48,0,52,0,50,0,51,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,71,0,114,0,101,0,101,0,107,0,10,0,45,0,32,0,50,0,48,0,52,0,50,0,52,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,10,0,45,0,32,0,50,0,48,0,56,0,51,0,51,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,69,0,120,0,116,0,101,0,110,0,100,0,101,0,100,0,10,0,45,0,32,0,50,0,48,0,56,0,51,0,56,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,84,0,104,0,97,0,105,0,10,0,45,0,32,0,50,0,48,0,56,0,54,0,54,0,32,0,82,0,117,0,115,0,115,0,105,0,97,0,110,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,82,0,41,0,59,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,82,0,41,0,10,0,45,0,32,0,50,0,48,0,56,0,55,0,49,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,99,0,101,0,108,0,97,0,110,0,100,0,105,0,99,0,10,0,45,0,32,0,50,0,48,0,56,0,56,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,82,0,117,0,115,0,115,0,105,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,57,0,48,0,53,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,84,0,117,0,114,0,107,0,105,0,115,0,104,0,10,0,45,0,32,0,50,0,48,0,57,0,50,0,52,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,49,0,47,0,79,0,112,0,101,0,110,0,32,0,83,0,121,0,115,0,116,0,101,0,109,0,32,0,40,0,49,0,48,0,52,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,10,0,45,0,32,0,50,0,48,0,57,0,51,0,50,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,32,0,40,0,74,0,73,0,83,0,32,0,48,0,50,0,48,0,56,0,45,0,49,0,57,0,57,0,48,0,32,0,97,0,110,0,100,0,32,0,48,0,50,0,49,0,50,0,45,0,49,0,57,0,57,0,48,0,41,0,10,0,45,0,32,0,50,0,48,0,57,0,51,0,54,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,71,0,66,0,50,0,51,0,49,0,50,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,71,0,66,0,50,0,51,0,49,0,50,0,45,0,56,0,48,0,41,0,10,0,45,0,32,0,50,0,48,0,57,0,52,0,57,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,87,0,97,0,110,0,115,0,117,0,110,0,103,0,10,0,45,0,32,0,50,0,49,0,48,0,50,0,53,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,83,0,101,0,114,0,98,0,105,0,97,0,110,0,45,0,66,0,117,0,108,0,103,0,97,0,114,0,105,0,97,0,110,0,10,0,45,0,32,0,50,0,49,0,48,0,50,0,55,0,32,0,69,0,120,0,116,0,101,0,110,0,100,0,101,0,100,0,47,0,69,0,120,0,116,0,32,0,65,0,108,0,112,0,104,0,97,0,32,0,76,0,111,0,119,0,101,0,114,0,99,0,97,0,115,0,101,0,10,0,45,0,32,0,50,0,49,0,56,0,54,0,54,0,32,0,85,0,107,0,114,0,97,0,105,0,110,0,105,0,97,0,110,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,85,0,41,0,59,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,85,0,41,0,10,0,45,0,32,0,50,0,57,0,48,0,48,0,49,0,32,0,69,0,117,0,114,0,111,0,112,0,97,0,32,0,51,0,10,0,45,0,32,0,51,0,56,0,53,0,57,0,56,0,32,0,73,0,83,0,79,0,32,0,56,0,56,0,53,0,57,0,45,0,56,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,59,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,32,0,40,0,73,0,83,0,79,0,45,0,76,0,111,0,103,0,105,0,99,0,97,0,108,0,41,0,10,0,45,0,32,0,53,0,49,0,57,0,51,0,50,0,32,0,69,0,85,0,67,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,10,0,45,0,32,0,53,0,49,0,57,0,51,0,54,0,32,0,69,0,85,0,67,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,69,0,85,0,67,0,41,0,10,0,45,0,32,0,53,0,49,0,57,0,52,0,57,0,32,0,69,0,85,0,67,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,10,0,45,0,32,0,53,0,50,0,57,0,51,0,54,0,32,0,72,0,90,0,45,0,71,0,66,0,50,0,51,0,49,0,50,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,72,0,90,0,41,0,10,0,45,0,32,0,53,0,52,0,57,0,51,0,54,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,32,0,88,0,80,0,32,0,97,0,110,0,100,0,32,0,108,0,97,0,116,0,101,0,114,0,58,0,32,0,71,0,66,0,49,0,56,0,48,0,51,0,48,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,52,0,32,0,98,0,121,0,116,0,101,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,71,0,66,0,49,0,56,0,48,0,51,0,48,0,41,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,50,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,68,0,101,0,118,0,97,0,110,0,97,0,103,0,97,0,114,0,105,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,51,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,66,0,101,0,110,0,103,0,97,0,108,0,105,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,52,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,84,0,97,0,109,0,105,0,108,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,53,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,84,0,101,0,108,0,117,0,103,0,117,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,54,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,65,0,115,0,115,0,97,0,109,0,101,0,115,0,101,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,55,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,79,0,114,0,105,0,121,0,97,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,56,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,75,0,97,0,110,0,110,0,97,0,100,0,97,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,57,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,77,0,97,0,108,0,97,0,121,0,97,0,108,0,97,0,109,0,10,0,45,0,32,0,53,0,55,0,48,0,49,0,48,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,71,0,117,0,106,0,97,0,114,0,97,0,116,0,105,0,10,0,45,0,32,0,53,0,55,0,48,0,49,0,49,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,80,0,117,0,110,0,106,0,97,0,98,0,105,0,10,0,10,0,84,0,104,0,101,0,32,0,102,0,111,0,108,0,108,0,111,0,119,0,105,0,110,0,103,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,100,0,101,0,112,0,101,0,110,0,100,0,101,0,110,0,99,0,105,0,101,0,115,0,32,0,102,0,111,0,114,0,32,0,86,0,105,0,115,0,117,0,97,0,108,0,32,0,70,0,111,0,120,0,80,0,114,0,111,0,58,0,10,0,10,0,45,0,32,0,54,0,50,0,48,0,32,0,77,0,97,0,122,0,111,0,118,0,105,0,97,0,32,0,40,0,80,0,111,0,108,0,105,0,115,0,104,0,41,0,32,0,77,0,83,0,45,0,68,0,79,0,83,0,10,0,45,0,32,0,56,0,57,0,53,0,32,0,75,0,97,0,109,0,101,0,110,0,105,0,99,0,107,0,253,0,32,0,40,0,67,0,122,0,101,0,99,0,104,0,41,0,32,0,77,0,83,0,45,0,68,0,79,0,83,0,10,0,10,0,35,0,35,0,32,0,66,0,117,0,105,0,108,0,100,0,105,0,110,0,103,0,32,0,78,0,111,0,116,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,32,0,96,0,109,0,97,0,107,0,101,0,46,0,115,0,104,0,96,0,32,0,40,0,100,0,101,0,115,0,99,0,114,0,105,0,98,0,101,0,100,0,32,0,108,0,97,0,116,0,101,0,114,0,41,0,32,0,119,0,105,0,108,0,108,0,32,0,103,0,101,0,116,0,32,0,116,0,104,0,101,0,115,0,101,0,32,0,102,0,105,0,108,0,101,0,115,0,32,0,97,0,110,0,100,0,32,0,109,0,97,0,115,0,115,0,97,0,103,0,101,0,32,0,116,0,104,0,101,0,32,0,100,0,97,0,116,0,97,0,10,0,40,0,112,0,114,0,105,0,110,0,116,0,105,0,110,0,103,0,32,0,99,0,111,0,100,0,101,0,45,0,85,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,112,0,97,0,105,0,114,0,115,0,41,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,101,0,118,0,101,0,110,0,116,0,117,0,97,0,108,0,32,0,116,0,97,0,98,0,108,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,100,0,114,0,111,0,112,0,112,0,101,0,100,0,32,0,105,0,110,0,32,0,116,0,104,0,101,0,32,0,112,0,97,0,116,0,104,0,115,0,10,0,96,0,46,0,47,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,47,0,60,0,67,0,79,0,68,0,69,0,80,0,65,0,71,0,69,0,62,0,46,0,84,0,66,0,76,0,96,0,46,0,32,0,32,0,70,0,111,0,114,0,32,0,101,0,120,0,97,0,109,0,112,0,108,0,101,0,44,0,32,0,116,0,104,0,101,0,32,0,108,0,97,0,115,0,116,0,32,0,49,0,48,0,32,0,108,0,105,0,110,0,101,0,115,0,32,0,111,0,102,0,32,0,96,0,49,0,48,0,48,0,48,0,48,0,46,0,84,0,66,0,76,0,96,0,32,0,97,0,114,0,101,0,10,0,10,0,96,0,96,0,96,0,62,0,10,0,48,0,120,0,70,0,54,0,9,0,48,0,120,0,48,0,50,0,67,0,54,0,10,0,48,0,120,0,70,0,55,0,9,0,48,0,120,0,48,0,50,0,68,0,67,0,10,0,48,0,120,0,70,0,56,0,9,0,48,0,120,0,48,0,48,0,65,0,70,0,10,0,48,0,120,0,70,0,57,0,9,0,48,0,120,0,48,0,50,0,68,0,56,0,10,0,48,0,120,0,70,0,65,0,9,0,48,0,120,0,48,0,50,0,68,0,57,0,10,0,48,0,120,0,70,0,66,0,9,0,48,0,120,0,48,0,50,0,68,0,65,0,10,0,48,0,120,0,70,0,67,0,9,0,48,0,120,0,48,0,48,0,66,0,56,0,10,0,48,0,120,0,70,0,68,0,9,0,48,0,120,0,48,0,50,0,68,0,68,0,10,0,48,0,120,0,70,0,69,0,9,0,48,0,120,0,48,0,50,0,68,0,66,0,10,0,48,0,120,0,70,0,70,0,9,0,48,0,120,0,48,0,50,0,67,0,55,0,10,0,96,0,96,0,96,0,10,0,10,0,119,0,104,0,105,0,99,0,104,0,32,0,105,0,109,0,112,0,108,0,105,0,101,0,115,0,32,0,116,0,104,0,97,0,116,0,32,0,99,0,111,0,100,0,101,0,32,0,96,0,48,0,120,0,70,0,54,0,96,0,32,0,105,0,115,0,32,0,96,0,83,0,116,0,114,0,105,0,110,0,103,0,46,0,102,0,114,0,111,0,109,0,67,0,104,0,97,0,114,0,67,0,111,0,100,0,101,0,40,0,48,0,120,0,48,0,50,0,67,0,54,0,41,0,96,0,32,0,97,0,110,0,100,0,32,0,118,0,105,0,99,0,101,0,32,0,118,0,101,0,114,0,115,0,97,0,46,0,10,0,10,0,35,0,35,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,45,0,100,0,101,0,112,0,101,0,110,0,100,0,101,0,110,0,116,0,32,0,98,0,117,0,105,0,108,0,100,0,32,0,115,0,116,0,101,0,112,0,10,0,10,0,84,0,111,0,32,0,98,0,117,0,105,0,108,0,100,0,32,0,116,0,104,0,101,0,32,0,115,0,111,0,117,0,114,0,99,0,101,0,115,0,32,0,111,0,110,0,32,0,119,0,105,0,110,0,100,0,111,0,119,0,115,0,44,0,32,0,99,0,111,0,110,0,115,0,117,0,108,0,116,0,32,0,96,0,100,0,111,0,116,0,110,0,101,0,116,0,47,0,77,0,97,0,107,0,101,0,69,0,110,0,99,0,111,0,100,0,105,0,110,0,103,0,46,0,99,0,115,0,96,0,46,0,10,0,10,0,65,0,102,0,116,0,101,0,114,0,32,0,115,0,97,0,118,0,105,0,110,0,103,0,32,0,115,0,116,0,97,0,110,0,100,0,97,0,114,0,100,0,32,0,111,0,117,0,116,0,112,0,117,0,116,0,32,0,116,0,111,0,32,0,96,0,111,0,117,0,116,0,96,0,44,0,32,0,116,0,104,0,101,0,32,0,96,0,100,0,111,0,116,0,110,0,101,0,116,0,46,0,115,0,104,0,96,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,32,0,112,0,114,0,111,0,99,0,101,0,115,0,115,0,101,0,115,0,32,0,114,0,101,0,115,0,117,0,108,0,116,0,115,0,46,0,32,0,10,0,10,0,35,0,32,0,66,0,117,0,105,0,108,0,100,0,105,0,110,0,103,0,32,0,116,0,104,0,101,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,10,0,10,0,96,0,109,0,97,0,107,0,101,0,46,0,110,0,106,0,115,0,96,0,32,0,116,0,97,0,107,0,101,0,115,0,32,0,97,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,32,0,97,0,114,0,103,0,117,0,109,0,101,0,110,0,116,0,44,0,32,0,114,0,101,0,97,0,100,0,115,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,114,0,114,0,101,0,115,0,112,0,111,0,110,0,100,0,105,0,110,0,103,0,32,0,116,0,97,0,98,0,108,0,101,0,32,0,102,0,105,0,108,0,101,0,32,0,97,0,110,0,100,0,10,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,115,0,32,0,74,0,83,0,32,0,99,0,111,0,100,0,101,0,32,0,102,0,111,0,114,0,32,0,101,0,110,0,99,0,111,0,100,0,105,0,110,0,103,0,32,0,97,0,110,0,100,0,32,0,100,0,101,0,99,0,111,0,100,0,105,0,110,0,103,0,58,0,10,0,10,0,35,0,35,0,32,0,82,0,97,0,119,0,32,0,67,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,68,0,66,0,67,0,83,0,32,0,97,0,110,0,100,0,32,0,83,0,66,0,67,0,83,0,32,0,99,0,111,0,100,0,101,0,32,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,0,115,0,116,0,114,0,97,0,116,0,101,0,103,0,105,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,100,0,105,0,102,0,102,0,101,0,114,0,101,0,110,0,116,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,109,0,97,0,120,0,105,0,109,0,117,0,109,0,32,0,99,0,111,0,100,0,101,0,32,0,105,0,115,0,10,0,117,0,115,0,101,0,100,0,32,0,116,0,111,0,32,0,100,0,105,0,115,0,116,0,105,0,110,0,103,0,117,0,105,0,115,0,104,0,32,0,40,0,109,0,97,0,120,0,32,0,96,0,48,0,120,0,70,0,70,0,96,0,32,0,102,0,111,0,114,0,32,0,83,0,66,0,67,0,83,0,41,0,46,0,10,0,10,0,84,0,104,0,101,0,32,0,85,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,32,0,96,0,48,0,120,0,70,0,70,0,70,0,68,0,96,0,32,0,40,0,82,0,69,0,80,0,76,0,65,0,67,0,69,0,77,0,69,0,78,0,84,0,32,0,67,0,72,0,65,0,82,0,65,0,67,0,84,0,69,0,82,0,41,0,32,0,105,0,115,0,32,0,117,0,115,0,101,0,100,0,32,0,97,0,115,0,32,0,97,0,32,0,112,0,108,0,97,0,99,0,101,0,104,0,111,0,108,0,100,0,101,0,114,0,10,0,102,0,111,0,114,0,32,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,115,0,32,0,116,0,104,0,97,0,116,0,32,0,97,0,114,0,101,0,32,0,110,0,111,0,116,0,32,0,115,0,112,0,101,0,99,0,105,0,102,0,105,0,101,0,100,0,32,0,105,0,110,0,32,0,116,0,104,0,101,0,32,0,109,0,97,0,112,0,32,0,40,0,102,0,111,0,114,0,32,0,101,0,120,0,97,0,109,0,112,0,108,0,101,0,44,0,32,0,96,0,48,0,120,0,70,0,48,0,96,0,32,0,105,0,115,0,32,0,110,0,111,0,116,0,32,0,105,0,110,0,10,0,99,0,111,0,100,0,101,0,32,0,112,0,97,0,103,0,101,0,32,0,49,0,48,0,48,0,48,0,48,0,41,0,46,0,10,0,10,0,70,0,111,0,114,0,32,0,83,0,66,0,67,0,83,0,44,0,32,0,116,0,104,0,101,0,32,0,105,0,100,0,101,0,97,0,32,0,105,0,115,0,32,0,116,0,111,0,32,0,101,0,109,0,98,0,101,0,100,0,32,0,97,0,32,0,114,0,97,0,119,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,32,0,119,0,105,0,116,0,104,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,110,0,116,0,101,0,110,0,116,0,115,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,50,0,53,0,54,0,32,0,99,0,111,0,100,0,101,0,115,0,46,0,10,0,84,0,104,0,101,0,32,0,96,0,100,0,101,0,99,0,96,0,32,0,102,0,105,0,101,0,108,0,100,0,32,0,105,0,115,0,32,0,109,0,101,0,114,0,101,0,108,0,121,0,32,0,97,0,32,0,115,0,112,0,108,0,105,0,116,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,44,0,32,0,97,0,110,0,100,0,32,0,96,0,101,0,110,0,99,0,96,0,32,0,105,0,115,0,32,0,97,0,110,0,32,0,101,0,118,0,101,0,114,0,115,0,105,0,111,0,110,0,58,0,10,0,10,0,68,0,66,0,67,0,83,0,32,0,105,0,115,0,32,0,115,0,105,0,109,0,105,0,108,0,97,0,114,0,44,0,32,0,101,0,120,0,99,0,101,0,112,0,116,0,32,0,116,0,104,0,97,0,116,0,32,0,116,0,104,0,101,0,32,0,115,0,112,0,97,0,99,0,101,0,32,0,105,0,115,0,32,0,115,0,108,0,105,0,99,0,101,0,100,0,32,0,105,0,110,0,32,0,99,0,104,0,117,0,110,0,107,0,115,0,32,0,111,0,102,0,32,0,50,0,53,0,54,0,32,0,98,0,121,0,116,0,101,0,115,0,32,0,40,0,115,0,116,0,114,0,105,0,110,0,103,0,115,0,10,0,97,0,114,0,101,0,32,0,111,0,110,0,108,0,121,0,32,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,100,0,32,0,102,0,111,0,114,0,32,0,116,0,104,0,111,0,115,0,101,0,32,0,104,0,105,0,103,0,104,0,45,0,98,0,121,0,116,0,101,0,115,0,32,0,114,0,101,0,112,0,114,0,101,0,115,0,101,0,110,0,116,0,101,0,100,0,32,0,105,0,110,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,41,0,46,0,10,0,10,0,84,0,104,0,101,0,32,0,115,0,116,0,114,0,97,0,116,0,101,0,103,0,121,0,32,0,105,0,115,0,32,0,116,0,111,0,32,0,99,0,111,0,110,0,115,0,116,0,114,0,117,0,99,0,116,0,32,0,97,0,110,0,32,0,97,0,114,0,114,0,97,0,121,0,45,0,111,0,102,0,45,0,97,0,114,0,114,0,97,0,121,0,115,0,32,0,115,0,111,0,32,0,116,0,104,0,97,0,116,0,32,0,96,0,100,0,100,0,91,0,104,0,105,0,103,0,104,0,93,0,91,0,108,0,111,0,119,0,93,0,96,0,32,0,105,0,115,0,32,0,116,0,104,0,101,0,10,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,32,0,97,0,115,0,115,0,111,0,99,0,105,0,97,0,116,0,101,0,100,0,32,0,119,0,105,0,116,0,104,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,100,0,101,0,46,0,32,0,32,0,84,0,104,0,105,0,115,0,32,0,97,0,114,0,114,0,97,0,121,0,32,0,105,0,115,0,32,0,99,0,111,0,109,0,98,0,105,0,110,0,101,0,100,0,32,0,97,0,116,0,32,0,114,0,117,0,110,0,116,0,105,0,109,0,101,0,32,0,116,0,111,0,32,0,121,0,105,0,101,0,108,0,100,0,10,0,116,0,104,0,101,0,32,0,99,0,111,0,109,0,112,0,108,0,101,0,116,0,101,0,32,0,100,0,101,0,99,0,111,0,100,0,105,0,110,0,103,0,32,0,111,0,98,0,106,0,101,0,99,0,116,0,32,0,40,0,97,0,110,0,100,0,32,0,116,0,104,0,101,0,32,0,101,0,110,0,99,0,111,0,100,0,105,0,110,0,103,0,32,0,111,0,98,0,106,0,101,0,99,0,116,0,32,0,105,0,115,0,32,0,97,0,110,0,32,0,101,0,118,0,101,0,114,0,115,0,105,0,111,0,110,0,41,0,58,0,10,0,10,0,96,0,109,0,97,0,107,0,101,0,46,0,115,0,104,0,96,0,32,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,115,0,32,0,116,0,104,0,101,0,32,0,116,0,97,0,98,0,108,0,101,0,115,0,32,0,117,0,115,0,101,0,100,0,32,0,98,0,121,0,32,0,96,0,109,0,97,0,107,0,101,0,46,0,110,0,106,0,115,0,96,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,114,0,97,0,119,0,32,0,85,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,84,0,88,0,84,0,32,0,102,0,105,0,108,0,101,0,115,0,10,0,97,0,114,0,101,0,32,0,99,0,111,0,108,0,117,0,109,0,110,0,97,0,114,0,58,0,32,0,96,0,99,0,111,0,100,0,101,0,32,0,117,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,35,0,99,0,111,0,109,0,109,0,101,0,110,0,116,0,115,0,96,0,46,0,32,0,32,0,70,0,111,0,114,0,32,0,101,0,120,0,97,0,109,0,112,0,108,0,101,0,44,0,32,0,116,0,104,0,101,0,32,0,108,0,97,0,115,0,116,0,32,0,49,0,48,0,32,0,108,0,105,0,110,0,101,0,115,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,10,0,116,0,101,0,120,0,116,0,32,0,102,0,105,0,108,0,101,0,32,0,96,0,82,0,79,0,77,0,65,0,78,0,46,0,84,0,88,0,84,0,96,0,32,0,40,0,102,0,111,0,114,0,32,0,67,0,80,0,32,0,49,0,48,0,48,0,48,0,48,0,41,0,32,0,97,0,114,0,101,0,58,0,10,0,10,0,96,0,96,0,96,0,62,0,10,0,48,0,120,0,70,0,54,0,9,0,48,0,120,0,48,0,50,0,67,0,54,0,9,0,35,0,77,0,79,0,68,0,73,0,70,0,73,0,69,0,82,0,32,0,76,0,69,0,84,0,84,0,69,0,82,0,32,0,67,0,73,0,82,0,67,0,85,0,77,0,70,0,76,0,69,0,88,0,32,0,65,0,67,0,67,0,69,0,78,0,84,0,10,0,48,0,120,0,70,0,55,0,9,0,48,0,120,0,48,0,50,0,68,0,67,0,9,0,35,0,83,0,77,0,65,0,76,0,76,0,32,0,84,0,73,0,76,0,68,0,69,0,10,0,48,0,120,0,70,0,56,0,9,0,48,0,120,0,48,0,48,0,65,0,70,0,9,0,35,0,77,0,65,0,67,0,82,0,79,0,78,0,10,0,48,0,120,0,70,0,57,0,9,0,48,0,120,0,48,0,50,0,68,0,56,0,9,0,35,0,66,0,82,0,69,0,86,0,69,0,10,0,48,0,120,0,70,0,65,0,9,0,48,0,120,0,48,0,50,0,68,0,57,0,9,0,35,0,68,0,79,0,84,0,32,0,65,0,66,0,79,0,86,0,69,0,10,0,48,0,120,0,70,0,66,0,9,0,48,0,120,0,48,0,50,0,68,0,65,0,9,0,35,0,82,0,73,0,78,0,71,0,32,0,65,0,66,0,79,0,86,0,69,0,10,0,48,0,120,0,70,0,67,0,9,0,48,0,120,0,48,0,48,0,66,0,56,0,9,0,35,0,67,0,69,0,68,0,73,0,76,0,76,0,65,0,10,0,48,0,120,0,70,0,68,0,9,0,48,0,120,0,48,0,50,0,68,0,68,0,9,0,35,0,68,0,79,0,85,0,66,0,76,0,69,0,32,0,65,0,67,0,85,0,84,0,69,0,32,0,65,0,67,0,67,0,69,0,78,0,84,0,10,0,48,0,120,0,70,0,69,0,9,0,48,0,120,0,48,0,50,0,68,0,66,0,9,0,35,0,79,0,71,0,79,0,78,0,69,0,75,0,10,0,48,0,120,0,70,0,70,0,9,0,48,0,120,0,48,0,50,0,67,0,55,0,9,0,35,0,67,0,65,0,82,0,79,0,78,0,10,0,96,0,96,0,96,0,10,0,10,0,73,0,110,0,32,0,112,0,114,0,111,0,99,0,101,0,115,0,115,0,105,0,110,0,103,0,32,0,116,0,104,0,101,0,32,0,100,0,97,0,116,0,97,0,44,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,109,0,109,0,101,0,110,0,116,0,115,0,32,0,40,0,97,0,102,0,116,0,101,0,114,0,32,0,116,0,104,0,101,0,32,0,96,0,35,0,96,0,41,0,32,0,97,0,114,0,101,0,32,0,115,0,116,0,114,0,105,0,112,0,112,0,101,0,100,0,32,0,97,0,110,0,100,0,32,0,117,0,110,0,100,0,101,0,102,0,105,0,110,0,101,0,100,0,10,0,101,0,108,0,101,0,109,0,101,0,110,0,116,0,115,0,32,0,40,0,108,0,105,0,107,0,101,0,32,0,96,0,48,0,120,0,55,0,70,0,96,0,32,0,102,0,111,0,114,0,32,0,67,0,80,0,32,0,49,0,48,0,48,0,48,0,48,0,41,0,32,0,97,0,114,0,101,0,32,0,114,0,101,0,109,0,111,0,118,0,101,0,100,0,46,0,10,0,10,0,35,0,35,0,32,0,85,0,116,0,105,0,108,0,105,0,116,0,105,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,97,0,110,0,100,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,102,0,117,0,110,0,99,0,116,0,105,0,111,0,110,0,115,0,32,0,97,0,114,0,101,0,32,0,107,0,101,0,112,0,116,0,32,0,105,0,110,0,32,0,97,0,32,0,115,0,101,0,112,0,97,0,114,0,97,0,116,0,101,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,32,0,40,0,96,0,99,0,112,0,117,0,116,0,105,0,108,0,115,0,46,0,106,0,115,0,96,0,41,0,46,0,10,0,10,0,66,0,111,0,116,0,104,0,32,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,97,0,110,0,100,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,100,0,101,0,97,0,108,0,32,0,119,0,105,0,116,0,104,0,32,0,100,0,97,0,116,0,97,0,32,0,114,0,101,0,112,0,114,0,101,0,115,0,101,0,110,0,116,0,101,0,100,0,32,0,97,0,115,0,58,0,10,0,10,0,45,0,32,0,83,0,116,0,114,0,105,0,110,0,103,0,32,0,40,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,74,0,83,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,44,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,105,0,110,0,116,0,101,0,114,0,112,0,114,0,101,0,116,0,115,0,32,0,85,0,67,0,83,0,50,0,32,0,99,0,104,0,97,0,114,0,115,0,32,0,97,0,115,0,32,0,99,0,111,0,100,0,101,0,115,0,41,0,10,0,45,0,32,0,65,0,114,0,114,0,97,0,121,0,32,0,40,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,97,0,114,0,114,0,97,0,121,0,32,0,111,0,102,0,32,0,74,0,83,0,32,0,83,0,116,0,114,0,105,0,110,0,103,0,32,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,115,0,44,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,110,0,117,0,109,0,98,0,101,0,114,0,115,0,41,0,10,0,45,0,32,0,66,0,117,0,102,0,102,0,101,0,114,0,32,0,40,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,85,0,84,0,70,0,45,0,56,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,44,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,99,0,111,0,100,0,101,0,112,0,111,0,105,0,110,0,116,0,115,0,47,0,98,0,121,0,116,0,101,0,115,0,41,0,46,0,10,0,10,0,84,0,104,0,101,0,32,0,96,0,111,0,102,0,109,0,116,0,96,0,32,0,118,0,97,0,114,0,105,0,97,0,98,0,108,0,101,0,32,0,99,0,111,0,110,0,116,0,114,0,111,0,108,0,115,0,32,0,96,0,101,0,110,0,99,0,111,0,100,0,101,0,96,0,32,0,111,0,117,0,116,0,112,0,117,0,116,0,32,0,40,0,96,0,115,0,116,0,114,0,96,0,44,0,32,0,96,0,97,0,114,0,114,0,96,0,32,0,114,0,101,0,115,0,112,0,101,0,99,0,116,0,105,0,118,0,101,0,108,0,121,0,41,0,10,0,119,0,104,0,105,0,108,0,101,0,32,0,116,0,104,0,101,0,32,0,105,0,110,0,112,0,117,0,116,0,32,0,102,0,111,0,114,0,109,0,97,0,116,0,32,0,105,0,115,0,32,0,97,0,117,0,116,0,111,0,109,0,97,0,116,0,105,0,99,0,97,0,108,0,108,0,121,0,32,0,100,0,101,0,116,0,101,0,114,0,109,0,105,0,110,0,101,0,100,0,46,0,10,0,10,0,35,0,32,0,78,0,105,0,116,0,116,0,121,0,32,0,71,0,114,0,105,0,116,0,116,0,121,0,10,0,10,0,96,0,96,0,96,0,62,0,46,0,118,0,111,0,99,0,114,0,99,0,10,0,123,0,32,0,34,0,112,0,111,0,115,0,116,0,34,0,58,0,32,0,34,0,109,0,97,0,107,0,101,0,32,0,106,0,115,0,34,0,32,0,125,0,10,0,96,0,96,0,96,0,10,0]}
;
README['utf16be'] = 
{"type":"Buffer","data":[0,35,0,32,0,71,0,101,0,116,0,116,0,105,0,110,0,103,0,32,0,67,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,102,0,105,0,101,0,108,0,100,0,115,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,96,0,112,0,97,0,103,0,101,0,115,0,46,0,99,0,115,0,118,0,96,0,32,0,109,0,97,0,110,0,105,0,102,0,101,0,115,0,116,0,32,0,97,0,114,0,101,0,32,0,96,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,44,0,117,0,114,0,108,0,44,0,98,0,121,0,116,0,101,0,115,0,96,0,32,0,40,0,83,0,66,0,67,0,83,0,61,0,49,0,44,0,32,0,68,0,66,0,67,0,83,0,61,0,50,0,41,0,10,0,10,0,78,0,111,0,116,0,101,0,32,0,116,0,104,0,97,0,116,0,32,0,116,0,104,0,101,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,32,0,114,0,101,0,110,0,100,0,101,0,114,0,105,0,110,0,103,0,32,0,105,0,115,0,32,0,117,0,115,0,101,0,100,0,32,0,102,0,111,0,114,0,32,0,116,0,104,0,101,0,32,0,77,0,97,0,99,0,32,0,99,0,111,0,100,0,101,0,32,0,112,0,97,0,103,0,101,0,115,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,112,0,114,0,105,0,109,0,97,0,114,0,121,0,10,0,100,0,105,0,102,0,102,0,101,0,114,0,101,0,110,0,99,0,101,0,32,0,105,0,115,0,32,0,116,0,104,0,101,0,32,0,117,0,115,0,101,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,112,0,114,0,105,0,118,0,97,0,116,0,101,0,32,0,96,0,48,0,120,0,70,0,56,0,70,0,70,0,96,0,32,0,99,0,111,0,100,0,101,0,32,0,40,0,119,0,104,0,105,0,99,0,104,0,32,0,114,0,101,0,110,0,100,0,101,0,114,0,115,0,32,0,97,0,115,0,32,0,97,0,110,0,32,0,65,0,112,0,112,0,108,0,101,0,10,0,108,0,111,0,103,0,111,0,32,0,111,0,110,0,32,0,109,0,97,0,99,0,115,0,32,0,98,0,117,0,116,0,32,0,97,0,115,0,32,0,103,0,97,0,114,0,98,0,97,0,103,0,101,0,32,0,111,0,110,0,32,0,111,0,116,0,104,0,101,0,114,0,32,0,111,0,112,0,101,0,114,0,97,0,116,0,105,0,110,0,103,0,32,0,115,0,121,0,115,0,116,0,101,0,109,0,115,0,41,0,46,0,32,0,32,0,73,0,116,0,32,0,109,0,97,0,121,0,32,0,98,0,101,0,32,0,100,0,101,0,115,0,105,0,114,0,97,0,98,0,108,0,101,0,10,0,116,0,111,0,32,0,102,0,97,0,108,0,108,0,32,0,98,0,97,0,99,0,107,0,32,0,116,0,111,0,32,0,116,0,104,0,101,0,32,0,98,0,101,0,104,0,97,0,118,0,105,0,111,0,114,0,44,0,32,0,105,0,110,0,32,0,119,0,104,0,105,0,99,0,104,0,32,0,99,0,97,0,115,0,101,0,32,0,116,0,104,0,101,0,32,0,102,0,105,0,108,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,117,0,110,0,100,0,101,0,114,0,32,0,65,0,80,0,80,0,76,0,69,0,32,0,97,0,110,0,100,0,32,0,110,0,111,0,116,0,10,0,77,0,73,0,67,0,83,0,70,0,84,0,46,0,32,0,32,0,84,0,104,0,105,0,115,0,32,0,97,0,102,0,102,0,101,0,99,0,116,0,115,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,32,0,49,0,48,0,48,0,48,0,48,0,44,0,32,0,49,0,48,0,48,0,48,0,54,0,44,0,32,0,49,0,48,0,48,0,48,0,55,0,44,0,32,0,49,0,48,0,48,0,50,0,57,0,44,0,32,0,49,0,48,0,48,0,55,0,57,0,44,0,32,0,49,0,48,0,48,0,56,0,49,0,10,0,10,0,84,0,104,0,101,0,32,0,110,0,117,0,109,0,98,0,101,0,114,0,105,0,110,0,103,0,32,0,115,0,99,0,104,0,101,0,109,0,101,0,32,0,102,0,111,0,114,0,32,0,116,0,104,0,101,0,32,0,96,0,73,0,83,0,79,0,45,0,56,0,56,0,53,0,57,0,45,0,88,0,96,0,32,0,115,0,101,0,114,0,105,0,101,0,115,0,32,0,105,0,115,0,32,0,96,0,50,0,56,0,53,0,57,0,48,0,32,0,43,0,32,0,88,0,96,0,58,0,10,0,10,0,35,0,35,0,32,0,71,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,100,0,32,0,67,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,102,0,111,0,108,0,108,0,111,0,119,0,105,0,110,0,103,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,97,0,118,0,97,0,105,0,108,0,97,0,98,0,108,0,101,0,32,0,105,0,110,0,32,0,46,0,78,0,69,0,84,0,32,0,111,0,110,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,58,0,10,0,10,0,45,0,32,0,55,0,48,0,56,0,32,0,32,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,65,0,83,0,77,0,79,0,32,0,55,0,48,0,56,0,41,0,10,0,45,0,32,0,55,0,50,0,48,0,32,0,32,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,84,0,114,0,97,0,110,0,115,0,112,0,97,0,114,0,101,0,110,0,116,0,32,0,65,0,83,0,77,0,79,0,41,0,59,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,68,0,79,0,83,0,41,0,10,0,45,0,32,0,56,0,53,0,56,0,32,0,32,0,32,0,79,0,69,0,77,0,32,0,77,0,117,0,108,0,116,0,105,0,108,0,105,0,110,0,103,0,117,0,97,0,108,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,49,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,10,0,45,0,32,0,56,0,55,0,48,0,32,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,77,0,117,0,108,0,116,0,105,0,108,0,105,0,110,0,103,0,117,0,97,0,108,0,47,0,82,0,79,0,69,0,67,0,69,0,32,0,40,0,76,0,97,0,116,0,105,0,110,0,32,0,50,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,77,0,117,0,108,0,116,0,105,0,108,0,105,0,110,0,103,0,117,0,97,0,108,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,50,0,10,0,45,0,32,0,49,0,48,0,52,0,55,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,49,0,47,0,79,0,112,0,101,0,110,0,32,0,83,0,121,0,115,0,116,0,101,0,109,0,10,0,45,0,32,0,49,0,49,0,52,0,48,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,85,0,83,0,45,0,67,0,97,0,110,0,97,0,100,0,97,0,32,0,40,0,48,0,51,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,85,0,83,0,45,0,67,0,97,0,110,0,97,0,100,0,97,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,49,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,71,0,101,0,114,0,109,0,97,0,110,0,121,0,32,0,40,0,50,0,48,0,50,0,55,0,51,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,71,0,101,0,114,0,109,0,97,0,110,0,121,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,50,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,68,0,101,0,110,0,109,0,97,0,114,0,107,0,45,0,78,0,111,0,114,0,119,0,97,0,121,0,32,0,40,0,50,0,48,0,50,0,55,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,68,0,101,0,110,0,109,0,97,0,114,0,107,0,45,0,78,0,111,0,114,0,119,0,97,0,121,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,51,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,105,0,110,0,108,0,97,0,110,0,100,0,45,0,83,0,119,0,101,0,100,0,101,0,110,0,32,0,40,0,50,0,48,0,50,0,55,0,56,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,70,0,105,0,110,0,108,0,97,0,110,0,100,0,45,0,83,0,119,0,101,0,100,0,101,0,110,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,52,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,116,0,97,0,108,0,121,0,32,0,40,0,50,0,48,0,50,0,56,0,48,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,73,0,116,0,97,0,108,0,121,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,53,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,65,0,109,0,101,0,114,0,105,0,99,0,97,0,45,0,83,0,112,0,97,0,105,0,110,0,32,0,40,0,50,0,48,0,50,0,56,0,52,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,83,0,112,0,97,0,105,0,110,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,54,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,85,0,110,0,105,0,116,0,101,0,100,0,32,0,75,0,105,0,110,0,103,0,100,0,111,0,109,0,32,0,40,0,50,0,48,0,50,0,56,0,53,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,85,0,75,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,55,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,114,0,97,0,110,0,99,0,101,0,32,0,40,0,50,0,48,0,50,0,57,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,70,0,114,0,97,0,110,0,99,0,101,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,56,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,110,0,116,0,101,0,114,0,110,0,97,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,53,0,48,0,48,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,73,0,110,0,116,0,101,0,114,0,110,0,97,0,116,0,105,0,111,0,110,0,97,0,108,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,49,0,52,0,57,0,32,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,99,0,101,0,108,0,97,0,110,0,100,0,105,0,99,0,32,0,40,0,50,0,48,0,56,0,55,0,49,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,59,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,40,0,73,0,99,0,101,0,108,0,97,0,110,0,100,0,105,0,99,0,45,0,69,0,117,0,114,0,111,0,41,0,10,0,45,0,32,0,49,0,51,0,54,0,49,0,32,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,40,0,74,0,111,0,104,0,97,0,98,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,49,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,50,0,32,0,77,0,65,0,67,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,66,0,105,0,103,0,53,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,51,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,52,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,53,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,48,0,56,0,32,0,77,0,65,0,67,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,71,0,66,0,32,0,50,0,51,0,49,0,50,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,49,0,48,0,32,0,82,0,111,0,109,0,97,0,110,0,105,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,49,0,55,0,32,0,85,0,107,0,114,0,97,0,105,0,110,0,105,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,50,0,49,0,32,0,84,0,104,0,97,0,105,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,49,0,48,0,48,0,56,0,50,0,32,0,67,0,114,0,111,0,97,0,116,0,105,0,97,0,110,0,32,0,40,0,77,0,97,0,99,0,41,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,48,0,32,0,67,0,78,0,83,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,67,0,78,0,83,0,41,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,49,0,32,0,84,0,67,0,65,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,50,0,32,0,69,0,84,0,69,0,78,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,84,0,114,0,97,0,100,0,105,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,40,0,69,0,84,0,69,0,78,0,41,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,51,0,32,0,73,0,66,0,77,0,53,0,53,0,53,0,48,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,52,0,32,0,84,0,101,0,108,0,101,0,84,0,101,0,120,0,116,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,48,0,48,0,53,0,32,0,87,0,97,0,110,0,103,0,32,0,84,0,97,0,105,0,119,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,53,0,32,0,73,0,65,0,53,0,32,0,40,0,73,0,82,0,86,0,32,0,73,0,110,0,116,0,101,0,114,0,110,0,97,0,116,0,105,0,111,0,110,0,97,0,108,0,32,0,65,0,108,0,112,0,104,0,97,0,98,0,101,0,116,0,32,0,78,0,111,0,46,0,32,0,53,0,44,0,32,0,55,0,45,0,98,0,105,0,116,0,41,0,59,0,32,0,87,0,101,0,115,0,116,0,101,0,114,0,110,0,32,0,69,0,117,0,114,0,111,0,112,0,101,0,97,0,110,0,32,0,40,0,73,0,65,0,53,0,41,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,54,0,32,0,73,0,65,0,53,0,32,0,71,0,101,0,114,0,109,0,97,0,110,0,32,0,40,0,55,0,45,0,98,0,105,0,116,0,41,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,55,0,32,0,73,0,65,0,53,0,32,0,83,0,119,0,101,0,100,0,105,0,115,0,104,0,32,0,40,0,55,0,45,0,98,0,105,0,116,0,41,0,10,0,45,0,32,0,50,0,48,0,49,0,48,0,56,0,32,0,73,0,65,0,53,0,32,0,78,0,111,0,114,0,119,0,101,0,103,0,105,0,97,0,110,0,32,0,40,0,55,0,45,0,98,0,105,0,116,0,41,0,10,0,45,0,32,0,50,0,48,0,50,0,54,0,49,0,32,0,84,0,46,0,54,0,49,0,10,0,45,0,32,0,50,0,48,0,50,0,54,0,57,0,32,0,73,0,83,0,79,0,32,0,54,0,57,0,51,0,55,0,32,0,78,0,111,0,110,0,45,0,83,0,112,0,97,0,99,0,105,0,110,0,103,0,32,0,65,0,99,0,99,0,101,0,110,0,116,0,10,0,45,0,32,0,50,0,48,0,50,0,55,0,51,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,71,0,101,0,114,0,109,0,97,0,110,0,121,0,10,0,45,0,32,0,50,0,48,0,50,0,55,0,55,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,68,0,101,0,110,0,109,0,97,0,114,0,107,0,45,0,78,0,111,0,114,0,119,0,97,0,121,0,10,0,45,0,32,0,50,0,48,0,50,0,55,0,56,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,105,0,110,0,108,0,97,0,110,0,100,0,45,0,83,0,119,0,101,0,100,0,101,0,110,0,10,0,45,0,32,0,50,0,48,0,50,0,56,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,116,0,97,0,108,0,121,0,10,0,45,0,32,0,50,0,48,0,50,0,56,0,52,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,65,0,109,0,101,0,114,0,105,0,99,0,97,0,45,0,83,0,112,0,97,0,105,0,110,0,10,0,45,0,32,0,50,0,48,0,50,0,56,0,53,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,85,0,110,0,105,0,116,0,101,0,100,0,32,0,75,0,105,0,110,0,103,0,100,0,111,0,109,0,10,0,45,0,32,0,50,0,48,0,50,0,57,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,32,0,75,0,97,0,116,0,97,0,107,0,97,0,110,0,97,0,32,0,69,0,120,0,116,0,101,0,110,0,100,0,101,0,100,0,10,0,45,0,32,0,50,0,48,0,50,0,57,0,55,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,70,0,114,0,97,0,110,0,99,0,101,0,10,0,45,0,32,0,50,0,48,0,52,0,50,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,65,0,114,0,97,0,98,0,105,0,99,0,10,0,45,0,32,0,50,0,48,0,52,0,50,0,51,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,71,0,114,0,101,0,101,0,107,0,10,0,45,0,32,0,50,0,48,0,52,0,50,0,52,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,10,0,45,0,32,0,50,0,48,0,56,0,51,0,51,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,69,0,120,0,116,0,101,0,110,0,100,0,101,0,100,0,10,0,45,0,32,0,50,0,48,0,56,0,51,0,56,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,84,0,104,0,97,0,105,0,10,0,45,0,32,0,50,0,48,0,56,0,54,0,54,0,32,0,82,0,117,0,115,0,115,0,105,0,97,0,110,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,82,0,41,0,59,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,82,0,41,0,10,0,45,0,32,0,50,0,48,0,56,0,55,0,49,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,73,0,99,0,101,0,108,0,97,0,110,0,100,0,105,0,99,0,10,0,45,0,32,0,50,0,48,0,56,0,56,0,48,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,82,0,117,0,115,0,115,0,105,0,97,0,110,0,10,0,45,0,32,0,50,0,48,0,57,0,48,0,53,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,84,0,117,0,114,0,107,0,105,0,115,0,104,0,10,0,45,0,32,0,50,0,48,0,57,0,50,0,52,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,76,0,97,0,116,0,105,0,110,0,32,0,49,0,47,0,79,0,112,0,101,0,110,0,32,0,83,0,121,0,115,0,116,0,101,0,109,0,32,0,40,0,49,0,48,0,52,0,55,0,32,0,43,0,32,0,69,0,117,0,114,0,111,0,32,0,115,0,121,0,109,0,98,0,111,0,108,0,41,0,10,0,45,0,32,0,50,0,48,0,57,0,51,0,50,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,32,0,40,0,74,0,73,0,83,0,32,0,48,0,50,0,48,0,56,0,45,0,49,0,57,0,57,0,48,0,32,0,97,0,110,0,100,0,32,0,48,0,50,0,49,0,50,0,45,0,49,0,57,0,57,0,48,0,41,0,10,0,45,0,32,0,50,0,48,0,57,0,51,0,54,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,71,0,66,0,50,0,51,0,49,0,50,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,71,0,66,0,50,0,51,0,49,0,50,0,45,0,56,0,48,0,41,0,10,0,45,0,32,0,50,0,48,0,57,0,52,0,57,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,32,0,87,0,97,0,110,0,115,0,117,0,110,0,103,0,10,0,45,0,32,0,50,0,49,0,48,0,50,0,53,0,32,0,73,0,66,0,77,0,32,0,69,0,66,0,67,0,68,0,73,0,67,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,83,0,101,0,114,0,98,0,105,0,97,0,110,0,45,0,66,0,117,0,108,0,103,0,97,0,114,0,105,0,97,0,110,0,10,0,45,0,32,0,50,0,49,0,48,0,50,0,55,0,32,0,69,0,120,0,116,0,101,0,110,0,100,0,101,0,100,0,47,0,69,0,120,0,116,0,32,0,65,0,108,0,112,0,104,0,97,0,32,0,76,0,111,0,119,0,101,0,114,0,99,0,97,0,115,0,101,0,10,0,45,0,32,0,50,0,49,0,56,0,54,0,54,0,32,0,85,0,107,0,114,0,97,0,105,0,110,0,105,0,97,0,110,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,85,0,41,0,59,0,32,0,67,0,121,0,114,0,105,0,108,0,108,0,105,0,99,0,32,0,40,0,75,0,79,0,73,0,56,0,45,0,85,0,41,0,10,0,45,0,32,0,50,0,57,0,48,0,48,0,49,0,32,0,69,0,117,0,114,0,111,0,112,0,97,0,32,0,51,0,10,0,45,0,32,0,51,0,56,0,53,0,57,0,56,0,32,0,73,0,83,0,79,0,32,0,56,0,56,0,53,0,57,0,45,0,56,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,59,0,32,0,72,0,101,0,98,0,114,0,101,0,119,0,32,0,40,0,73,0,83,0,79,0,45,0,76,0,111,0,103,0,105,0,99,0,97,0,108,0,41,0,10,0,45,0,32,0,53,0,49,0,57,0,51,0,50,0,32,0,69,0,85,0,67,0,32,0,74,0,97,0,112,0,97,0,110,0,101,0,115,0,101,0,10,0,45,0,32,0,53,0,49,0,57,0,51,0,54,0,32,0,69,0,85,0,67,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,69,0,85,0,67,0,41,0,10,0,45,0,32,0,53,0,49,0,57,0,52,0,57,0,32,0,69,0,85,0,67,0,32,0,75,0,111,0,114,0,101,0,97,0,110,0,10,0,45,0,32,0,53,0,50,0,57,0,51,0,54,0,32,0,72,0,90,0,45,0,71,0,66,0,50,0,51,0,49,0,50,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,72,0,90,0,41,0,10,0,45,0,32,0,53,0,52,0,57,0,51,0,54,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,32,0,88,0,80,0,32,0,97,0,110,0,100,0,32,0,108,0,97,0,116,0,101,0,114,0,58,0,32,0,71,0,66,0,49,0,56,0,48,0,51,0,48,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,40,0,52,0,32,0,98,0,121,0,116,0,101,0,41,0,59,0,32,0,67,0,104,0,105,0,110,0,101,0,115,0,101,0,32,0,83,0,105,0,109,0,112,0,108,0,105,0,102,0,105,0,101,0,100,0,32,0,40,0,71,0,66,0,49,0,56,0,48,0,51,0,48,0,41,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,50,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,68,0,101,0,118,0,97,0,110,0,97,0,103,0,97,0,114,0,105,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,51,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,66,0,101,0,110,0,103,0,97,0,108,0,105,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,52,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,84,0,97,0,109,0,105,0,108,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,53,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,84,0,101,0,108,0,117,0,103,0,117,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,54,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,65,0,115,0,115,0,97,0,109,0,101,0,115,0,101,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,55,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,79,0,114,0,105,0,121,0,97,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,56,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,75,0,97,0,110,0,110,0,97,0,100,0,97,0,10,0,45,0,32,0,53,0,55,0,48,0,48,0,57,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,77,0,97,0,108,0,97,0,121,0,97,0,108,0,97,0,109,0,10,0,45,0,32,0,53,0,55,0,48,0,49,0,48,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,71,0,117,0,106,0,97,0,114,0,97,0,116,0,105,0,10,0,45,0,32,0,53,0,55,0,48,0,49,0,49,0,32,0,73,0,83,0,67,0,73,0,73,0,32,0,80,0,117,0,110,0,106,0,97,0,98,0,105,0,10,0,10,0,84,0,104,0,101,0,32,0,102,0,111,0,108,0,108,0,111,0,119,0,105,0,110,0,103,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,100,0,101,0,112,0,101,0,110,0,100,0,101,0,110,0,99,0,105,0,101,0,115,0,32,0,102,0,111,0,114,0,32,0,86,0,105,0,115,0,117,0,97,0,108,0,32,0,70,0,111,0,120,0,80,0,114,0,111,0,58,0,10,0,10,0,45,0,32,0,54,0,50,0,48,0,32,0,77,0,97,0,122,0,111,0,118,0,105,0,97,0,32,0,40,0,80,0,111,0,108,0,105,0,115,0,104,0,41,0,32,0,77,0,83,0,45,0,68,0,79,0,83,0,10,0,45,0,32,0,56,0,57,0,53,0,32,0,75,0,97,0,109,0,101,0,110,0,105,0,99,0,107,0,253,0,32,0,40,0,67,0,122,0,101,0,99,0,104,0,41,0,32,0,77,0,83,0,45,0,68,0,79,0,83,0,10,0,10,0,35,0,35,0,32,0,66,0,117,0,105,0,108,0,100,0,105,0,110,0,103,0,32,0,78,0,111,0,116,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,32,0,96,0,109,0,97,0,107,0,101,0,46,0,115,0,104,0,96,0,32,0,40,0,100,0,101,0,115,0,99,0,114,0,105,0,98,0,101,0,100,0,32,0,108,0,97,0,116,0,101,0,114,0,41,0,32,0,119,0,105,0,108,0,108,0,32,0,103,0,101,0,116,0,32,0,116,0,104,0,101,0,115,0,101,0,32,0,102,0,105,0,108,0,101,0,115,0,32,0,97,0,110,0,100,0,32,0,109,0,97,0,115,0,115,0,97,0,103,0,101,0,32,0,116,0,104,0,101,0,32,0,100,0,97,0,116,0,97,0,10,0,40,0,112,0,114,0,105,0,110,0,116,0,105,0,110,0,103,0,32,0,99,0,111,0,100,0,101,0,45,0,85,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,112,0,97,0,105,0,114,0,115,0,41,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,101,0,118,0,101,0,110,0,116,0,117,0,97,0,108,0,32,0,116,0,97,0,98,0,108,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,100,0,114,0,111,0,112,0,112,0,101,0,100,0,32,0,105,0,110,0,32,0,116,0,104,0,101,0,32,0,112,0,97,0,116,0,104,0,115,0,10,0,96,0,46,0,47,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,47,0,60,0,67,0,79,0,68,0,69,0,80,0,65,0,71,0,69,0,62,0,46,0,84,0,66,0,76,0,96,0,46,0,32,0,32,0,70,0,111,0,114,0,32,0,101,0,120,0,97,0,109,0,112,0,108,0,101,0,44,0,32,0,116,0,104,0,101,0,32,0,108,0,97,0,115,0,116,0,32,0,49,0,48,0,32,0,108,0,105,0,110,0,101,0,115,0,32,0,111,0,102,0,32,0,96,0,49,0,48,0,48,0,48,0,48,0,46,0,84,0,66,0,76,0,96,0,32,0,97,0,114,0,101,0,10,0,10,0,96,0,96,0,96,0,62,0,10,0,48,0,120,0,70,0,54,0,9,0,48,0,120,0,48,0,50,0,67,0,54,0,10,0,48,0,120,0,70,0,55,0,9,0,48,0,120,0,48,0,50,0,68,0,67,0,10,0,48,0,120,0,70,0,56,0,9,0,48,0,120,0,48,0,48,0,65,0,70,0,10,0,48,0,120,0,70,0,57,0,9,0,48,0,120,0,48,0,50,0,68,0,56,0,10,0,48,0,120,0,70,0,65,0,9,0,48,0,120,0,48,0,50,0,68,0,57,0,10,0,48,0,120,0,70,0,66,0,9,0,48,0,120,0,48,0,50,0,68,0,65,0,10,0,48,0,120,0,70,0,67,0,9,0,48,0,120,0,48,0,48,0,66,0,56,0,10,0,48,0,120,0,70,0,68,0,9,0,48,0,120,0,48,0,50,0,68,0,68,0,10,0,48,0,120,0,70,0,69,0,9,0,48,0,120,0,48,0,50,0,68,0,66,0,10,0,48,0,120,0,70,0,70,0,9,0,48,0,120,0,48,0,50,0,67,0,55,0,10,0,96,0,96,0,96,0,10,0,10,0,119,0,104,0,105,0,99,0,104,0,32,0,105,0,109,0,112,0,108,0,105,0,101,0,115,0,32,0,116,0,104,0,97,0,116,0,32,0,99,0,111,0,100,0,101,0,32,0,96,0,48,0,120,0,70,0,54,0,96,0,32,0,105,0,115,0,32,0,96,0,83,0,116,0,114,0,105,0,110,0,103,0,46,0,102,0,114,0,111,0,109,0,67,0,104,0,97,0,114,0,67,0,111,0,100,0,101,0,40,0,48,0,120,0,48,0,50,0,67,0,54,0,41,0,96,0,32,0,97,0,110,0,100,0,32,0,118,0,105,0,99,0,101,0,32,0,118,0,101,0,114,0,115,0,97,0,46,0,10,0,10,0,35,0,35,0,32,0,87,0,105,0,110,0,100,0,111,0,119,0,115,0,45,0,100,0,101,0,112,0,101,0,110,0,100,0,101,0,110,0,116,0,32,0,98,0,117,0,105,0,108,0,100,0,32,0,115,0,116,0,101,0,112,0,10,0,10,0,84,0,111,0,32,0,98,0,117,0,105,0,108,0,100,0,32,0,116,0,104,0,101,0,32,0,115,0,111,0,117,0,114,0,99,0,101,0,115,0,32,0,111,0,110,0,32,0,119,0,105,0,110,0,100,0,111,0,119,0,115,0,44,0,32,0,99,0,111,0,110,0,115,0,117,0,108,0,116,0,32,0,96,0,100,0,111,0,116,0,110,0,101,0,116,0,47,0,77,0,97,0,107,0,101,0,69,0,110,0,99,0,111,0,100,0,105,0,110,0,103,0,46,0,99,0,115,0,96,0,46,0,10,0,10,0,65,0,102,0,116,0,101,0,114,0,32,0,115,0,97,0,118,0,105,0,110,0,103,0,32,0,115,0,116,0,97,0,110,0,100,0,97,0,114,0,100,0,32,0,111,0,117,0,116,0,112,0,117,0,116,0,32,0,116,0,111,0,32,0,96,0,111,0,117,0,116,0,96,0,44,0,32,0,116,0,104,0,101,0,32,0,96,0,100,0,111,0,116,0,110,0,101,0,116,0,46,0,115,0,104,0,96,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,32,0,112,0,114,0,111,0,99,0,101,0,115,0,115,0,101,0,115,0,32,0,114,0,101,0,115,0,117,0,108,0,116,0,115,0,46,0,32,0,10,0,10,0,35,0,32,0,66,0,117,0,105,0,108,0,100,0,105,0,110,0,103,0,32,0,116,0,104,0,101,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,10,0,10,0,96,0,109,0,97,0,107,0,101,0,46,0,110,0,106,0,115,0,96,0,32,0,116,0,97,0,107,0,101,0,115,0,32,0,97,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,32,0,97,0,114,0,103,0,117,0,109,0,101,0,110,0,116,0,44,0,32,0,114,0,101,0,97,0,100,0,115,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,114,0,114,0,101,0,115,0,112,0,111,0,110,0,100,0,105,0,110,0,103,0,32,0,116,0,97,0,98,0,108,0,101,0,32,0,102,0,105,0,108,0,101,0,32,0,97,0,110,0,100,0,10,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,115,0,32,0,74,0,83,0,32,0,99,0,111,0,100,0,101,0,32,0,102,0,111,0,114,0,32,0,101,0,110,0,99,0,111,0,100,0,105,0,110,0,103,0,32,0,97,0,110,0,100,0,32,0,100,0,101,0,99,0,111,0,100,0,105,0,110,0,103,0,58,0,10,0,10,0,35,0,35,0,32,0,82,0,97,0,119,0,32,0,67,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,68,0,66,0,67,0,83,0,32,0,97,0,110,0,100,0,32,0,83,0,66,0,67,0,83,0,32,0,99,0,111,0,100,0,101,0,32,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,0,115,0,116,0,114,0,97,0,116,0,101,0,103,0,105,0,101,0,115,0,32,0,97,0,114,0,101,0,32,0,100,0,105,0,102,0,102,0,101,0,114,0,101,0,110,0,116,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,109,0,97,0,120,0,105,0,109,0,117,0,109,0,32,0,99,0,111,0,100,0,101,0,32,0,105,0,115,0,10,0,117,0,115,0,101,0,100,0,32,0,116,0,111,0,32,0,100,0,105,0,115,0,116,0,105,0,110,0,103,0,117,0,105,0,115,0,104,0,32,0,40,0,109,0,97,0,120,0,32,0,96,0,48,0,120,0,70,0,70,0,96,0,32,0,102,0,111,0,114,0,32,0,83,0,66,0,67,0,83,0,41,0,46,0,10,0,10,0,84,0,104,0,101,0,32,0,85,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,32,0,96,0,48,0,120,0,70,0,70,0,70,0,68,0,96,0,32,0,40,0,82,0,69,0,80,0,76,0,65,0,67,0,69,0,77,0,69,0,78,0,84,0,32,0,67,0,72,0,65,0,82,0,65,0,67,0,84,0,69,0,82,0,41,0,32,0,105,0,115,0,32,0,117,0,115,0,101,0,100,0,32,0,97,0,115,0,32,0,97,0,32,0,112,0,108,0,97,0,99,0,101,0,104,0,111,0,108,0,100,0,101,0,114,0,10,0,102,0,111,0,114,0,32,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,115,0,32,0,116,0,104,0,97,0,116,0,32,0,97,0,114,0,101,0,32,0,110,0,111,0,116,0,32,0,115,0,112,0,101,0,99,0,105,0,102,0,105,0,101,0,100,0,32,0,105,0,110,0,32,0,116,0,104,0,101,0,32,0,109,0,97,0,112,0,32,0,40,0,102,0,111,0,114,0,32,0,101,0,120,0,97,0,109,0,112,0,108,0,101,0,44,0,32,0,96,0,48,0,120,0,70,0,48,0,96,0,32,0,105,0,115,0,32,0,110,0,111,0,116,0,32,0,105,0,110,0,10,0,99,0,111,0,100,0,101,0,32,0,112,0,97,0,103,0,101,0,32,0,49,0,48,0,48,0,48,0,48,0,41,0,46,0,10,0,10,0,70,0,111,0,114,0,32,0,83,0,66,0,67,0,83,0,44,0,32,0,116,0,104,0,101,0,32,0,105,0,100,0,101,0,97,0,32,0,105,0,115,0,32,0,116,0,111,0,32,0,101,0,109,0,98,0,101,0,100,0,32,0,97,0,32,0,114,0,97,0,119,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,32,0,119,0,105,0,116,0,104,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,110,0,116,0,101,0,110,0,116,0,115,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,50,0,53,0,54,0,32,0,99,0,111,0,100,0,101,0,115,0,46,0,10,0,84,0,104,0,101,0,32,0,96,0,100,0,101,0,99,0,96,0,32,0,102,0,105,0,101,0,108,0,100,0,32,0,105,0,115,0,32,0,109,0,101,0,114,0,101,0,108,0,121,0,32,0,97,0,32,0,115,0,112,0,108,0,105,0,116,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,44,0,32,0,97,0,110,0,100,0,32,0,96,0,101,0,110,0,99,0,96,0,32,0,105,0,115,0,32,0,97,0,110,0,32,0,101,0,118,0,101,0,114,0,115,0,105,0,111,0,110,0,58,0,10,0,10,0,68,0,66,0,67,0,83,0,32,0,105,0,115,0,32,0,115,0,105,0,109,0,105,0,108,0,97,0,114,0,44,0,32,0,101,0,120,0,99,0,101,0,112,0,116,0,32,0,116,0,104,0,97,0,116,0,32,0,116,0,104,0,101,0,32,0,115,0,112,0,97,0,99,0,101,0,32,0,105,0,115,0,32,0,115,0,108,0,105,0,99,0,101,0,100,0,32,0,105,0,110,0,32,0,99,0,104,0,117,0,110,0,107,0,115,0,32,0,111,0,102,0,32,0,50,0,53,0,54,0,32,0,98,0,121,0,116,0,101,0,115,0,32,0,40,0,115,0,116,0,114,0,105,0,110,0,103,0,115,0,10,0,97,0,114,0,101,0,32,0,111,0,110,0,108,0,121,0,32,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,100,0,32,0,102,0,111,0,114,0,32,0,116,0,104,0,111,0,115,0,101,0,32,0,104,0,105,0,103,0,104,0,45,0,98,0,121,0,116,0,101,0,115,0,32,0,114,0,101,0,112,0,114,0,101,0,115,0,101,0,110,0,116,0,101,0,100,0,32,0,105,0,110,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,100,0,101,0,112,0,97,0,103,0,101,0,41,0,46,0,10,0,10,0,84,0,104,0,101,0,32,0,115,0,116,0,114,0,97,0,116,0,101,0,103,0,121,0,32,0,105,0,115,0,32,0,116,0,111,0,32,0,99,0,111,0,110,0,115,0,116,0,114,0,117,0,99,0,116,0,32,0,97,0,110,0,32,0,97,0,114,0,114,0,97,0,121,0,45,0,111,0,102,0,45,0,97,0,114,0,114,0,97,0,121,0,115,0,32,0,115,0,111,0,32,0,116,0,104,0,97,0,116,0,32,0,96,0,100,0,100,0,91,0,104,0,105,0,103,0,104,0,93,0,91,0,108,0,111,0,119,0,93,0,96,0,32,0,105,0,115,0,32,0,116,0,104,0,101,0,10,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,32,0,97,0,115,0,115,0,111,0,99,0,105,0,97,0,116,0,101,0,100,0,32,0,119,0,105,0,116,0,104,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,100,0,101,0,46,0,32,0,32,0,84,0,104,0,105,0,115,0,32,0,97,0,114,0,114,0,97,0,121,0,32,0,105,0,115,0,32,0,99,0,111,0,109,0,98,0,105,0,110,0,101,0,100,0,32,0,97,0,116,0,32,0,114,0,117,0,110,0,116,0,105,0,109,0,101,0,32,0,116,0,111,0,32,0,121,0,105,0,101,0,108,0,100,0,10,0,116,0,104,0,101,0,32,0,99,0,111,0,109,0,112,0,108,0,101,0,116,0,101,0,32,0,100,0,101,0,99,0,111,0,100,0,105,0,110,0,103,0,32,0,111,0,98,0,106,0,101,0,99,0,116,0,32,0,40,0,97,0,110,0,100,0,32,0,116,0,104,0,101,0,32,0,101,0,110,0,99,0,111,0,100,0,105,0,110,0,103,0,32,0,111,0,98,0,106,0,101,0,99,0,116,0,32,0,105,0,115,0,32,0,97,0,110,0,32,0,101,0,118,0,101,0,114,0,115,0,105,0,111,0,110,0,41,0,58,0,10,0,10,0,96,0,109,0,97,0,107,0,101,0,46,0,115,0,104,0,96,0,32,0,103,0,101,0,110,0,101,0,114,0,97,0,116,0,101,0,115,0,32,0,116,0,104,0,101,0,32,0,116,0,97,0,98,0,108,0,101,0,115,0,32,0,117,0,115,0,101,0,100,0,32,0,98,0,121,0,32,0,96,0,109,0,97,0,107,0,101,0,46,0,110,0,106,0,115,0,96,0,46,0,32,0,32,0,84,0,104,0,101,0,32,0,114,0,97,0,119,0,32,0,85,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,84,0,88,0,84,0,32,0,102,0,105,0,108,0,101,0,115,0,10,0,97,0,114,0,101,0,32,0,99,0,111,0,108,0,117,0,109,0,110,0,97,0,114,0,58,0,32,0,96,0,99,0,111,0,100,0,101,0,32,0,117,0,110,0,105,0,99,0,111,0,100,0,101,0,32,0,35,0,99,0,111,0,109,0,109,0,101,0,110,0,116,0,115,0,96,0,46,0,32,0,32,0,70,0,111,0,114,0,32,0,101,0,120,0,97,0,109,0,112,0,108,0,101,0,44,0,32,0,116,0,104,0,101,0,32,0,108,0,97,0,115,0,116,0,32,0,49,0,48,0,32,0,108,0,105,0,110,0,101,0,115,0,32,0,111,0,102,0,32,0,116,0,104,0,101,0,10,0,116,0,101,0,120,0,116,0,32,0,102,0,105,0,108,0,101,0,32,0,96,0,82,0,79,0,77,0,65,0,78,0,46,0,84,0,88,0,84,0,96,0,32,0,40,0,102,0,111,0,114,0,32,0,67,0,80,0,32,0,49,0,48,0,48,0,48,0,48,0,41,0,32,0,97,0,114,0,101,0,58,0,10,0,10,0,96,0,96,0,96,0,62,0,10,0,48,0,120,0,70,0,54,0,9,0,48,0,120,0,48,0,50,0,67,0,54,0,9,0,35,0,77,0,79,0,68,0,73,0,70,0,73,0,69,0,82,0,32,0,76,0,69,0,84,0,84,0,69,0,82,0,32,0,67,0,73,0,82,0,67,0,85,0,77,0,70,0,76,0,69,0,88,0,32,0,65,0,67,0,67,0,69,0,78,0,84,0,10,0,48,0,120,0,70,0,55,0,9,0,48,0,120,0,48,0,50,0,68,0,67,0,9,0,35,0,83,0,77,0,65,0,76,0,76,0,32,0,84,0,73,0,76,0,68,0,69,0,10,0,48,0,120,0,70,0,56,0,9,0,48,0,120,0,48,0,48,0,65,0,70,0,9,0,35,0,77,0,65,0,67,0,82,0,79,0,78,0,10,0,48,0,120,0,70,0,57,0,9,0,48,0,120,0,48,0,50,0,68,0,56,0,9,0,35,0,66,0,82,0,69,0,86,0,69,0,10,0,48,0,120,0,70,0,65,0,9,0,48,0,120,0,48,0,50,0,68,0,57,0,9,0,35,0,68,0,79,0,84,0,32,0,65,0,66,0,79,0,86,0,69,0,10,0,48,0,120,0,70,0,66,0,9,0,48,0,120,0,48,0,50,0,68,0,65,0,9,0,35,0,82,0,73,0,78,0,71,0,32,0,65,0,66,0,79,0,86,0,69,0,10,0,48,0,120,0,70,0,67,0,9,0,48,0,120,0,48,0,48,0,66,0,56,0,9,0,35,0,67,0,69,0,68,0,73,0,76,0,76,0,65,0,10,0,48,0,120,0,70,0,68,0,9,0,48,0,120,0,48,0,50,0,68,0,68,0,9,0,35,0,68,0,79,0,85,0,66,0,76,0,69,0,32,0,65,0,67,0,85,0,84,0,69,0,32,0,65,0,67,0,67,0,69,0,78,0,84,0,10,0,48,0,120,0,70,0,69,0,9,0,48,0,120,0,48,0,50,0,68,0,66,0,9,0,35,0,79,0,71,0,79,0,78,0,69,0,75,0,10,0,48,0,120,0,70,0,70,0,9,0,48,0,120,0,48,0,50,0,67,0,55,0,9,0,35,0,67,0,65,0,82,0,79,0,78,0,10,0,96,0,96,0,96,0,10,0,10,0,73,0,110,0,32,0,112,0,114,0,111,0,99,0,101,0,115,0,115,0,105,0,110,0,103,0,32,0,116,0,104,0,101,0,32,0,100,0,97,0,116,0,97,0,44,0,32,0,116,0,104,0,101,0,32,0,99,0,111,0,109,0,109,0,101,0,110,0,116,0,115,0,32,0,40,0,97,0,102,0,116,0,101,0,114,0,32,0,116,0,104,0,101,0,32,0,96,0,35,0,96,0,41,0,32,0,97,0,114,0,101,0,32,0,115,0,116,0,114,0,105,0,112,0,112,0,101,0,100,0,32,0,97,0,110,0,100,0,32,0,117,0,110,0,100,0,101,0,102,0,105,0,110,0,101,0,100,0,10,0,101,0,108,0,101,0,109,0,101,0,110,0,116,0,115,0,32,0,40,0,108,0,105,0,107,0,101,0,32,0,96,0,48,0,120,0,55,0,70,0,96,0,32,0,102,0,111,0,114,0,32,0,67,0,80,0,32,0,49,0,48,0,48,0,48,0,48,0,41,0,32,0,97,0,114,0,101,0,32,0,114,0,101,0,109,0,111,0,118,0,101,0,100,0,46,0,10,0,10,0,35,0,35,0,32,0,85,0,116,0,105,0,108,0,105,0,116,0,105,0,101,0,115,0,10,0,10,0,84,0,104,0,101,0,32,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,97,0,110,0,100,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,102,0,117,0,110,0,99,0,116,0,105,0,111,0,110,0,115,0,32,0,97,0,114,0,101,0,32,0,107,0,101,0,112,0,116,0,32,0,105,0,110,0,32,0,97,0,32,0,115,0,101,0,112,0,97,0,114,0,97,0,116,0,101,0,32,0,115,0,99,0,114,0,105,0,112,0,116,0,32,0,40,0,96,0,99,0,112,0,117,0,116,0,105,0,108,0,115,0,46,0,106,0,115,0,96,0,41,0,46,0,10,0,10,0,66,0,111,0,116,0,104,0,32,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,97,0,110,0,100,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,100,0,101,0,97,0,108,0,32,0,119,0,105,0,116,0,104,0,32,0,100,0,97,0,116,0,97,0,32,0,114,0,101,0,112,0,114,0,101,0,115,0,101,0,110,0,116,0,101,0,100,0,32,0,97,0,115,0,58,0,10,0,10,0,45,0,32,0,83,0,116,0,114,0,105,0,110,0,103,0,32,0,40,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,74,0,83,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,44,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,105,0,110,0,116,0,101,0,114,0,112,0,114,0,101,0,116,0,115,0,32,0,85,0,67,0,83,0,50,0,32,0,99,0,104,0,97,0,114,0,115,0,32,0,97,0,115,0,32,0,99,0,111,0,100,0,101,0,115,0,41,0,10,0,45,0,32,0,65,0,114,0,114,0,97,0,121,0,32,0,40,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,97,0,114,0,114,0,97,0,121,0,32,0,111,0,102,0,32,0,74,0,83,0,32,0,83,0,116,0,114,0,105,0,110,0,103,0,32,0,99,0,104,0,97,0,114,0,97,0,99,0,116,0,101,0,114,0,115,0,44,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,110,0,117,0,109,0,98,0,101,0,114,0,115,0,41,0,10,0,45,0,32,0,66,0,117,0,102,0,102,0,101,0,114,0,32,0,40,0,101,0,110,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,85,0,84,0,70,0,45,0,56,0,32,0,115,0,116,0,114,0,105,0,110,0,103,0,44,0,32,0,100,0,101,0,99,0,111,0,100,0,101,0,32,0,101,0,120,0,112,0,101,0,99,0,116,0,115,0,32,0,99,0,111,0,100,0,101,0,112,0,111,0,105,0,110,0,116,0,115,0,47,0,98,0,121,0,116,0,101,0,115,0,41,0,46,0,10,0,10,0,84,0,104,0,101,0,32,0,96,0,111,0,102,0,109,0,116,0,96,0,32,0,118,0,97,0,114,0,105,0,97,0,98,0,108,0,101,0,32,0,99,0,111,0,110,0,116,0,114,0,111,0,108,0,115,0,32,0,96,0,101,0,110,0,99,0,111,0,100,0,101,0,96,0,32,0,111,0,117,0,116,0,112,0,117,0,116,0,32,0,40,0,96,0,115,0,116,0,114,0,96,0,44,0,32,0,96,0,97,0,114,0,114,0,96,0,32,0,114,0,101,0,115,0,112,0,101,0,99,0,116,0,105,0,118,0,101,0,108,0,121,0,41,0,10,0,119,0,104,0,105,0,108,0,101,0,32,0,116,0,104,0,101,0,32,0,105,0,110,0,112,0,117,0,116,0,32,0,102,0,111,0,114,0,109,0,97,0,116,0,32,0,105,0,115,0,32,0,97,0,117,0,116,0,111,0,109,0,97,0,116,0,105,0,99,0,97,0,108,0,108,0,121,0,32,0,100,0,101,0,116,0,101,0,114,0,109,0,105,0,110,0,101,0,100,0,46,0,10,0,10,0,35,0,32,0,78,0,105,0,116,0,116,0,121,0,32,0,71,0,114,0,105,0,116,0,116,0,121,0,10,0,10,0,96,0,96,0,96,0,62,0,46,0,118,0,111,0,99,0,114,0,99,0,10,0,123,0,32,0,34,0,112,0,111,0,115,0,116,0,34,0,58,0,32,0,34,0,109,0,97,0,107,0,101,0,32,0,106,0,115,0,34,0,32,0,125,0,10,0,96,0,96,0,96,0,10]}
;
README['utf32le'] = 
{"type":"Buffer","data":[35,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,116,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,108,0,0,0,100,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,46,0,0,0,99,0,0,0,115,0,0,0,118,0,0,0,96,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,105,0,0,0,102,0,0,0,101,0,0,0,115,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,44,0,0,0,117,0,0,0,114,0,0,0,108,0,0,0,44,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,61,0,0,0,49,0,0,0,44,0,0,0,32,0,0,0,68,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,61,0,0,0,50,0,0,0,41,0,0,0,10,0,0,0,10,0,0,0,78,0,0,0,111,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,10,0,0,0,100,0,0,0,105,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,118,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,56,0,0,0,70,0,0,0,70,0,0,0,96,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,99,0,0,0,104,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,65,0,0,0,112,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,10,0,0,0,108,0,0,0,111,0,0,0,103,0,0,0,111,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,99,0,0,0,115,0,0,0,32,0,0,0,98,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,103,0,0,0,97,0,0,0,114,0,0,0,98,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,111,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,111,0,0,0,112,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,115,0,0,0,41,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,116,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,98,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,105,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,10,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,108,0,0,0,32,0,0,0,98,0,0,0,97,0,0,0,99,0,0,0,107,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,98,0,0,0,101,0,0,0,104,0,0,0,97,0,0,0,118,0,0,0,105,0,0,0,111,0,0,0,114,0,0,0,44,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,99,0,0,0,104,0,0,0,32,0,0,0,99,0,0,0,97,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,65,0,0,0,80,0,0,0,80,0,0,0,76,0,0,0,69,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,110,0,0,0,111,0,0,0,116,0,0,0,10,0,0,0,77,0,0,0,73,0,0,0,67,0,0,0,83,0,0,0,70,0,0,0,84,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,54,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,55,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,55,0,0,0,57,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,49,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,110,0,0,0,117,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,104,0,0,0,101,0,0,0,109,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,45,0,0,0,56,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,45,0,0,0,88,0,0,0,96,0,0,0,32,0,0,0,115,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,96,0,0,0,50,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,48,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,88,0,0,0,96,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,108,0,0,0,108,0,0,0,111,0,0,0,119,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,118,0,0,0,97,0,0,0,105,0,0,0,108,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,46,0,0,0,78,0,0,0,69,0,0,0,84,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,55,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,65,0,0,0,83,0,0,0,77,0,0,0,79,0,0,0,32,0,0,0,55,0,0,0,48,0,0,0,56,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,55,0,0,0,50,0,0,0,48,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,115,0,0,0,112,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,32,0,0,0,65,0,0,0,83,0,0,0,77,0,0,0,79,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,68,0,0,0,79,0,0,0,83,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,56,0,0,0,53,0,0,0,56,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,79,0,0,0,69,0,0,0,77,0,0,0,32,0,0,0,77,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,49,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,56,0,0,0,55,0,0,0,48,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,77,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,47,0,0,0,82,0,0,0,79,0,0,0,69,0,0,0,67,0,0,0,69,0,0,0,32,0,0,0,40,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,50,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,77,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,50,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,52,0,0,0,55,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,49,0,0,0,47,0,0,0,79,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,32,0,0,0,83,0,0,0,121,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,48,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,85,0,0,0,83,0,0,0,45,0,0,0,67,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,100,0,0,0,97,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,51,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,85,0,0,0,83,0,0,0,45,0,0,0,67,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,100,0,0,0,97,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,49,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,51,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,121,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,50,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,68,0,0,0,101,0,0,0,110,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,107,0,0,0,45,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,68,0,0,0,101,0,0,0,110,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,107,0,0,0,45,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,97,0,0,0,121,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,51,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,105,0,0,0,110,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,45,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,56,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,70,0,0,0,105,0,0,0,110,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,45,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,52,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,116,0,0,0,97,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,48,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,116,0,0,0,97,0,0,0,108,0,0,0,121,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,53,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,65,0,0,0,109,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,45,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,52,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,54,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,75,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,100,0,0,0,111,0,0,0,109,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,53,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,85,0,0,0,75,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,55,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,70,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,56,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,53,0,0,0,48,0,0,0,48,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,57,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,99,0,0,0,101,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,55,0,0,0,49,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,99,0,0,0,101,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,99,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,51,0,0,0,54,0,0,0,49,0,0,0,32,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,74,0,0,0,111,0,0,0,104,0,0,0,97,0,0,0,98,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,32,0,0,0,77,0,0,0,65,0,0,0,67,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,66,0,0,0,105,0,0,0,103,0,0,0,53,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,51,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,52,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,77,0,0,0,65,0,0,0,67,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,32,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,82,0,0,0,111,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,55,0,0,0,32,0,0,0,85,0,0,0,107,0,0,0,114,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,49,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,97,0,0,0,105,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,50,0,0,0,32,0,0,0,67,0,0,0,114,0,0,0,111,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,32,0,0,0,67,0,0,0,78,0,0,0,83,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,67,0,0,0,78,0,0,0,83,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,84,0,0,0,67,0,0,0,65,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,32,0,0,0,69,0,0,0,84,0,0,0,69,0,0,0,78,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,69,0,0,0,84,0,0,0,69,0,0,0,78,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,53,0,0,0,53,0,0,0,53,0,0,0,48,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,52,0,0,0,32,0,0,0,84,0,0,0,101,0,0,0,108,0,0,0,101,0,0,0,84,0,0,0,101,0,0,0,120,0,0,0,116,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,87,0,0,0,97,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,82,0,0,0,86,0,0,0,32,0,0,0,73,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,65,0,0,0,108,0,0,0,112,0,0,0,104,0,0,0,97,0,0,0,98,0,0,0,101,0,0,0,116,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,46,0,0,0,32,0,0,0,53,0,0,0,44,0,0,0,32,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,87,0,0,0,101,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,112,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,54,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,32,0,0,0,40,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,101,0,0,0,103,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,49,0,0,0,32,0,0,0,84,0,0,0,46,0,0,0,54,0,0,0,49,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,57,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,32,0,0,0,54,0,0,0,57,0,0,0,51,0,0,0,55,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,110,0,0,0,45,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,99,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,65,0,0,0,99,0,0,0,99,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,121,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,68,0,0,0,101,0,0,0,110,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,107,0,0,0,45,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,97,0,0,0,121,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,105,0,0,0,110,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,45,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,116,0,0,0,97,0,0,0,108,0,0,0,121,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,65,0,0,0,109,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,45,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,75,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,100,0,0,0,111,0,0,0,109,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,75,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,107,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,32,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,100,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,52,0,0,0,50,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,52,0,0,0,50,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,71,0,0,0,114,0,0,0,101,0,0,0,101,0,0,0,107,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,52,0,0,0,50,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,51,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,100,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,51,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,97,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,54,0,0,0,54,0,0,0,32,0,0,0,82,0,0,0,117,0,0,0,115,0,0,0,115,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,82,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,82,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,55,0,0,0,49,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,99,0,0,0,101,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,99,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,56,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,82,0,0,0,117,0,0,0,115,0,0,0,115,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,84,0,0,0,117,0,0,0,114,0,0,0,107,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,50,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,49,0,0,0,47,0,0,0,79,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,32,0,0,0,83,0,0,0,121,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,32,0,0,0,40,0,0,0,49,0,0,0,48,0,0,0,52,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,51,0,0,0,50,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,74,0,0,0,73,0,0,0,83,0,0,0,32,0,0,0,48,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,45,0,0,0,49,0,0,0,57,0,0,0,57,0,0,0,48,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,48,0,0,0,50,0,0,0,49,0,0,0,50,0,0,0,45,0,0,0,49,0,0,0,57,0,0,0,57,0,0,0,48,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,45,0,0,0,56,0,0,0,48,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,52,0,0,0,57,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,87,0,0,0,97,0,0,0,110,0,0,0,115,0,0,0,117,0,0,0,110,0,0,0,103,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,49,0,0,0,48,0,0,0,50,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,83,0,0,0,101,0,0,0,114,0,0,0,98,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,45,0,0,0,66,0,0,0,117,0,0,0,108,0,0,0,103,0,0,0,97,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,49,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,32,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,100,0,0,0,47,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,32,0,0,0,65,0,0,0,108,0,0,0,112,0,0,0,104,0,0,0,97,0,0,0,32,0,0,0,76,0,0,0,111,0,0,0,119,0,0,0,101,0,0,0,114,0,0,0,99,0,0,0,97,0,0,0,115,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,49,0,0,0,56,0,0,0,54,0,0,0,54,0,0,0,32,0,0,0,85,0,0,0,107,0,0,0,114,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,85,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,85,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,57,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,112,0,0,0,97,0,0,0,32,0,0,0,51,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,51,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,32,0,0,0,56,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,45,0,0,0,56,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,59,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,45,0,0,0,76,0,0,0,111,0,0,0,103,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,108,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,49,0,0,0,57,0,0,0,51,0,0,0,50,0,0,0,32,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,49,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,49,0,0,0,57,0,0,0,52,0,0,0,57,0,0,0,32,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,50,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,72,0,0,0,90,0,0,0,45,0,0,0,71,0,0,0,66,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,72,0,0,0,90,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,52,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,32,0,0,0,88,0,0,0,80,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,58,0,0,0,32,0,0,0,71,0,0,0,66,0,0,0,49,0,0,0,56,0,0,0,48,0,0,0,51,0,0,0,48,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,52,0,0,0,32,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,49,0,0,0,56,0,0,0,48,0,0,0,51,0,0,0,48,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,68,0,0,0,101,0,0,0,118,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,103,0,0,0,97,0,0,0,114,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,66,0,0,0,101,0,0,0,110,0,0,0,103,0,0,0,97,0,0,0,108,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,109,0,0,0,105,0,0,0,108,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,84,0,0,0,101,0,0,0,108,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,54,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,65,0,0,0,115,0,0,0,115,0,0,0,97,0,0,0,109,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,79,0,0,0,114,0,0,0,105,0,0,0,121,0,0,0,97,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,75,0,0,0,97,0,0,0,110,0,0,0,110,0,0,0,97,0,0,0,100,0,0,0,97,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,57,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,77,0,0,0,97,0,0,0,108,0,0,0,97,0,0,0,121,0,0,0,97,0,0,0,108,0,0,0,97,0,0,0,109,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,71,0,0,0,117,0,0,0,106,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,49,0,0,0,49,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,80,0,0,0,117,0,0,0,110,0,0,0,106,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,108,0,0,0,108,0,0,0,111,0,0,0,119,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,86,0,0,0,105,0,0,0,115,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,70,0,0,0,111,0,0,0,120,0,0,0,80,0,0,0,114,0,0,0,111,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,54,0,0,0,50,0,0,0,48,0,0,0,32,0,0,0,77,0,0,0,97,0,0,0,122,0,0,0,111,0,0,0,118,0,0,0,105,0,0,0,97,0,0,0,32,0,0,0,40,0,0,0,80,0,0,0,111,0,0,0,108,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,41,0,0,0,32,0,0,0,77,0,0,0,83,0,0,0,45,0,0,0,68,0,0,0,79,0,0,0,83,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,56,0,0,0,57,0,0,0,53,0,0,0,32,0,0,0,75,0,0,0,97,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,107,0,0,0,253,0,0,0,32,0,0,0,40,0,0,0,67,0,0,0,122,0,0,0,101,0,0,0,99,0,0,0,104,0,0,0,41,0,0,0,32,0,0,0,77,0,0,0,83,0,0,0,45,0,0,0,68,0,0,0,79,0,0,0,83,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,66,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,115,0,0,0,104,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,98,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,41,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,115,0,0,0,115,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,10,0,0,0,40,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,45,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,114,0,0,0,115,0,0,0,41,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,118,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,114,0,0,0,111,0,0,0,112,0,0,0,112,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,116,0,0,0,104,0,0,0,115,0,0,0,10,0,0,0,96,0,0,0,46,0,0,0,47,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,47,0,0,0,60,0,0,0,67,0,0,0,79,0,0,0,68,0,0,0,69,0,0,0,80,0,0,0,65,0,0,0,71,0,0,0,69,0,0,0,62,0,0,0,46,0,0,0,84,0,0,0,66,0,0,0,76,0,0,0,96,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,70,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,97,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,115,0,0,0,116,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,96,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,46,0,0,0,84,0,0,0,66,0,0,0,76,0,0,0,96,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,62,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,54,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,54,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,55,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,67,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,56,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,65,0,0,0,70,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,57,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,56,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,65,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,57,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,66,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,65,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,67,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,66,0,0,0,56,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,68,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,68,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,69,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,66,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,55,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,10,0,0,0,10,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,99,0,0,0,104,0,0,0,32,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,54,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,96,0,0,0,83,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,46,0,0,0,102,0,0,0,114,0,0,0,111,0,0,0,109,0,0,0,67,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,40,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,54,0,0,0,41,0,0,0,96,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,118,0,0,0,105,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,118,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,97,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,45,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,32,0,0,0,98,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,112,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,111,0,0,0,32,0,0,0,98,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,111,0,0,0,117,0,0,0,114,0,0,0,99,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,44,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,115,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,111,0,0,0,116,0,0,0,110,0,0,0,101,0,0,0,116,0,0,0,47,0,0,0,77,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,69,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,46,0,0,0,99,0,0,0,115,0,0,0,96,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,65,0,0,0,102,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,115,0,0,0,97,0,0,0,118,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,114,0,0,0,100,0,0,0,32,0,0,0,111,0,0,0,117,0,0,0,116,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,96,0,0,0,111,0,0,0,117,0,0,0,116,0,0,0,96,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,111,0,0,0,116,0,0,0,110,0,0,0,101,0,0,0,116,0,0,0,46,0,0,0,115,0,0,0,104,0,0,0,96,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,111,0,0,0,99,0,0,0,101,0,0,0,115,0,0,0,115,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,115,0,0,0,46,0,0,0,32,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,32,0,0,0,66,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,110,0,0,0,106,0,0,0,115,0,0,0,96,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,103,0,0,0,117,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,44,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,100,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,114,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,112,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,10,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,74,0,0,0,83,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,82,0,0,0,97,0,0,0,119,0,0,0,32,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,68,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,103,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,105,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,120,0,0,0,105,0,0,0,109,0,0,0,117,0,0,0,109,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,10,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,100,0,0,0,105,0,0,0,115,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,32,0,0,0,40,0,0,0,109,0,0,0,97,0,0,0,120,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,96,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,70,0,0,0,68,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,82,0,0,0,69,0,0,0,80,0,0,0,76,0,0,0,65,0,0,0,67,0,0,0,69,0,0,0,77,0,0,0,69,0,0,0,78,0,0,0,84,0,0,0,32,0,0,0,67,0,0,0,72,0,0,0,65,0,0,0,82,0,0,0,65,0,0,0,67,0,0,0,84,0,0,0,69,0,0,0,82,0,0,0,41,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,112,0,0,0,108,0,0,0,97,0,0,0,99,0,0,0,101,0,0,0,104,0,0,0,111,0,0,0,108,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,10,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,110,0,0,0,111,0,0,0,116,0,0,0,32,0,0,0,115,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,112,0,0,0,32,0,0,0,40,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,97,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,44,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,48,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,110,0,0,0,111,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,10,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,70,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,100,0,0,0,101,0,0,0,97,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,114,0,0,0,97,0,0,0,119,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,50,0,0,0,53,0,0,0,54,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,46,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,96,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,108,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,109,0,0,0,101,0,0,0,114,0,0,0,101,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,115,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,116,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,44,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,96,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,101,0,0,0,118,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,68,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,115,0,0,0,105,0,0,0,109,0,0,0,105,0,0,0,108,0,0,0,97,0,0,0,114,0,0,0,44,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,99,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,112,0,0,0,97,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,115,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,117,0,0,0,110,0,0,0,107,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,50,0,0,0,53,0,0,0,54,0,0,0,32,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,40,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,115,0,0,0,10,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,111,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,104,0,0,0,105,0,0,0,103,0,0,0,104,0,0,0,45,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,112,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,103,0,0,0,121,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,99,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,45,0,0,0,111,0,0,0,102,0,0,0,45,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,115,0,0,0,32,0,0,0,115,0,0,0,111,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,100,0,0,0,91,0,0,0,104,0,0,0,105,0,0,0,103,0,0,0,104,0,0,0,93,0,0,0,91,0,0,0,108,0,0,0,111,0,0,0,119,0,0,0,93,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,10,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,115,0,0,0,111,0,0,0,99,0,0,0,105,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,98,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,114,0,0,0,117,0,0,0,110,0,0,0,116,0,0,0,105,0,0,0,109,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,121,0,0,0,105,0,0,0,101,0,0,0,108,0,0,0,100,0,0,0,10,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,111,0,0,0,98,0,0,0,106,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,32,0,0,0,40,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,111,0,0,0,98,0,0,0,106,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,101,0,0,0,118,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,41,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,115,0,0,0,104,0,0,0,96,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,98,0,0,0,121,0,0,0,32,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,110,0,0,0,106,0,0,0,115,0,0,0,96,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,114,0,0,0,97,0,0,0,119,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,88,0,0,0,84,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,108,0,0,0,117,0,0,0,109,0,0,0,110,0,0,0,97,0,0,0,114,0,0,0,58,0,0,0,32,0,0,0,96,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,117,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,35,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,96,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,70,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,97,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,115,0,0,0,116,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,10,0,0,0,116,0,0,0,101,0,0,0,120,0,0,0,116,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,82,0,0,0,79,0,0,0,77,0,0,0,65,0,0,0,78,0,0,0,46,0,0,0,84,0,0,0,88,0,0,0,84,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,67,0,0,0,80,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,41,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,62,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,54,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,54,0,0,0,9,0,0,0,35,0,0,0,77,0,0,0,79,0,0,0,68,0,0,0,73,0,0,0,70,0,0,0,73,0,0,0,69,0,0,0,82,0,0,0,32,0,0,0,76,0,0,0,69,0,0,0,84,0,0,0,84,0,0,0,69,0,0,0,82,0,0,0,32,0,0,0,67,0,0,0,73,0,0,0,82,0,0,0,67,0,0,0,85,0,0,0,77,0,0,0,70,0,0,0,76,0,0,0,69,0,0,0,88,0,0,0,32,0,0,0,65,0,0,0,67,0,0,0,67,0,0,0,69,0,0,0,78,0,0,0,84,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,55,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,67,0,0,0,9,0,0,0,35,0,0,0,83,0,0,0,77,0,0,0,65,0,0,0,76,0,0,0,76,0,0,0,32,0,0,0,84,0,0,0,73,0,0,0,76,0,0,0,68,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,56,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,65,0,0,0,70,0,0,0,9,0,0,0,35,0,0,0,77,0,0,0,65,0,0,0,67,0,0,0,82,0,0,0,79,0,0,0,78,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,57,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,56,0,0,0,9,0,0,0,35,0,0,0,66,0,0,0,82,0,0,0,69,0,0,0,86,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,65,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,57,0,0,0,9,0,0,0,35,0,0,0,68,0,0,0,79,0,0,0,84,0,0,0,32,0,0,0,65,0,0,0,66,0,0,0,79,0,0,0,86,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,66,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,65,0,0,0,9,0,0,0,35,0,0,0,82,0,0,0,73,0,0,0,78,0,0,0,71,0,0,0,32,0,0,0,65,0,0,0,66,0,0,0,79,0,0,0,86,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,67,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,66,0,0,0,56,0,0,0,9,0,0,0,35,0,0,0,67,0,0,0,69,0,0,0,68,0,0,0,73,0,0,0,76,0,0,0,76,0,0,0,65,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,68,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,68,0,0,0,9,0,0,0,35,0,0,0,68,0,0,0,79,0,0,0,85,0,0,0,66,0,0,0,76,0,0,0,69,0,0,0,32,0,0,0,65,0,0,0,67,0,0,0,85,0,0,0,84,0,0,0,69,0,0,0,32,0,0,0,65,0,0,0,67,0,0,0,67,0,0,0,69,0,0,0,78,0,0,0,84,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,69,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,66,0,0,0,9,0,0,0,35,0,0,0,79,0,0,0,71,0,0,0,79,0,0,0,78,0,0,0,69,0,0,0,75,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,55,0,0,0,9,0,0,0,35,0,0,0,67,0,0,0,65,0,0,0,82,0,0,0,79,0,0,0,78,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,10,0,0,0,10,0,0,0,73,0,0,0,110,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,111,0,0,0,99,0,0,0,101,0,0,0,115,0,0,0,115,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,40,0,0,0,97,0,0,0,102,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,35,0,0,0,96,0,0,0,41,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,112,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,100,0,0,0,10,0,0,0,101,0,0,0,108,0,0,0,101,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,40,0,0,0,108,0,0,0,105,0,0,0,107,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,55,0,0,0,70,0,0,0,96,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,67,0,0,0,80,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,41,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,109,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,100,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,85,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,117,0,0,0,110,0,0,0,99,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,107,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,115,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,40,0,0,0,96,0,0,0,99,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,115,0,0,0,46,0,0,0,106,0,0,0,115,0,0,0,96,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,66,0,0,0,111,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,100,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,112,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,83,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,40,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,74,0,0,0,83,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,44,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,112,0,0,0,114,0,0,0,101,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,85,0,0,0,67,0,0,0,83,0,0,0,50,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,74,0,0,0,83,0,0,0,32,0,0,0,83,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,44,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,110,0,0,0,117,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,66,0,0,0,117,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,40,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,85,0,0,0,84,0,0,0,70,0,0,0,45,0,0,0,56,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,44,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,111,0,0,0,105,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,47,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,111,0,0,0,102,0,0,0,109,0,0,0,116,0,0,0,96,0,0,0,32,0,0,0,118,0,0,0,97,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,116,0,0,0,114,0,0,0,111,0,0,0,108,0,0,0,115,0,0,0,32,0,0,0,96,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,96,0,0,0,32,0,0,0,111,0,0,0,117,0,0,0,116,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,40,0,0,0,96,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,96,0,0,0,44,0,0,0,32,0,0,0,96,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,96,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,105,0,0,0,118,0,0,0,101,0,0,0,108,0,0,0,121,0,0,0,41,0,0,0,10,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,117,0,0,0,116,0,0,0,111,0,0,0,109,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,108,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,100,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,32,0,0,0,78,0,0,0,105,0,0,0,116,0,0,0,116,0,0,0,121,0,0,0,32,0,0,0,71,0,0,0,114,0,0,0,105,0,0,0,116,0,0,0,116,0,0,0,121,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,62,0,0,0,46,0,0,0,118,0,0,0,111,0,0,0,99,0,0,0,114,0,0,0,99,0,0,0,10,0,0,0,123,0,0,0,32,0,0,0,34,0,0,0,112,0,0,0,111,0,0,0,115,0,0,0,116,0,0,0,34,0,0,0,58,0,0,0,32,0,0,0,34,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,32,0,0,0,106,0,0,0,115,0,0,0,34,0,0,0,32,0,0,0,125,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,10,0,0,0]}
;
README['utf32be'] = 
{"type":"Buffer","data":[0,0,0,35,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,116,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,108,0,0,0,100,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,46,0,0,0,99,0,0,0,115,0,0,0,118,0,0,0,96,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,105,0,0,0,102,0,0,0,101,0,0,0,115,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,44,0,0,0,117,0,0,0,114,0,0,0,108,0,0,0,44,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,61,0,0,0,49,0,0,0,44,0,0,0,32,0,0,0,68,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,61,0,0,0,50,0,0,0,41,0,0,0,10,0,0,0,10,0,0,0,78,0,0,0,111,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,10,0,0,0,100,0,0,0,105,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,118,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,56,0,0,0,70,0,0,0,70,0,0,0,96,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,99,0,0,0,104,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,65,0,0,0,112,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,10,0,0,0,108,0,0,0,111,0,0,0,103,0,0,0,111,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,99,0,0,0,115,0,0,0,32,0,0,0,98,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,103,0,0,0,97,0,0,0,114,0,0,0,98,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,111,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,111,0,0,0,112,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,115,0,0,0,41,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,116,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,98,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,105,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,10,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,108,0,0,0,32,0,0,0,98,0,0,0,97,0,0,0,99,0,0,0,107,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,98,0,0,0,101,0,0,0,104,0,0,0,97,0,0,0,118,0,0,0,105,0,0,0,111,0,0,0,114,0,0,0,44,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,99,0,0,0,104,0,0,0,32,0,0,0,99,0,0,0,97,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,65,0,0,0,80,0,0,0,80,0,0,0,76,0,0,0,69,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,110,0,0,0,111,0,0,0,116,0,0,0,10,0,0,0,77,0,0,0,73,0,0,0,67,0,0,0,83,0,0,0,70,0,0,0,84,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,54,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,55,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,55,0,0,0,57,0,0,0,44,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,49,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,110,0,0,0,117,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,104,0,0,0,101,0,0,0,109,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,45,0,0,0,56,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,45,0,0,0,88,0,0,0,96,0,0,0,32,0,0,0,115,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,96,0,0,0,50,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,48,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,88,0,0,0,96,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,108,0,0,0,108,0,0,0,111,0,0,0,119,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,118,0,0,0,97,0,0,0,105,0,0,0,108,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,46,0,0,0,78,0,0,0,69,0,0,0,84,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,55,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,65,0,0,0,83,0,0,0,77,0,0,0,79,0,0,0,32,0,0,0,55,0,0,0,48,0,0,0,56,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,55,0,0,0,50,0,0,0,48,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,115,0,0,0,112,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,32,0,0,0,65,0,0,0,83,0,0,0,77,0,0,0,79,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,68,0,0,0,79,0,0,0,83,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,56,0,0,0,53,0,0,0,56,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,79,0,0,0,69,0,0,0,77,0,0,0,32,0,0,0,77,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,49,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,56,0,0,0,55,0,0,0,48,0,0,0,32,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,77,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,47,0,0,0,82,0,0,0,79,0,0,0,69,0,0,0,67,0,0,0,69,0,0,0,32,0,0,0,40,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,50,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,77,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,50,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,52,0,0,0,55,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,49,0,0,0,47,0,0,0,79,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,32,0,0,0,83,0,0,0,121,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,48,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,85,0,0,0,83,0,0,0,45,0,0,0,67,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,100,0,0,0,97,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,51,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,85,0,0,0,83,0,0,0,45,0,0,0,67,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,100,0,0,0,97,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,49,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,51,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,121,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,50,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,68,0,0,0,101,0,0,0,110,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,107,0,0,0,45,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,68,0,0,0,101,0,0,0,110,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,107,0,0,0,45,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,97,0,0,0,121,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,51,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,105,0,0,0,110,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,45,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,56,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,70,0,0,0,105,0,0,0,110,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,45,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,52,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,116,0,0,0,97,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,48,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,116,0,0,0,97,0,0,0,108,0,0,0,121,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,53,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,65,0,0,0,109,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,45,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,52,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,54,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,75,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,100,0,0,0,111,0,0,0,109,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,53,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,85,0,0,0,75,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,55,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,70,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,56,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,53,0,0,0,48,0,0,0,48,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,49,0,0,0,52,0,0,0,57,0,0,0,32,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,99,0,0,0,101,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,55,0,0,0,49,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,99,0,0,0,101,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,99,0,0,0,45,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,51,0,0,0,54,0,0,0,49,0,0,0,32,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,74,0,0,0,111,0,0,0,104,0,0,0,97,0,0,0,98,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,32,0,0,0,77,0,0,0,65,0,0,0,67,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,66,0,0,0,105,0,0,0,103,0,0,0,53,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,51,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,52,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,77,0,0,0,65,0,0,0,67,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,32,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,82,0,0,0,111,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,55,0,0,0,32,0,0,0,85,0,0,0,107,0,0,0,114,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,49,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,97,0,0,0,105,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,50,0,0,0,32,0,0,0,67,0,0,0,114,0,0,0,111,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,77,0,0,0,97,0,0,0,99,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,32,0,0,0,67,0,0,0,78,0,0,0,83,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,67,0,0,0,78,0,0,0,83,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,84,0,0,0,67,0,0,0,65,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,32,0,0,0,69,0,0,0,84,0,0,0,69,0,0,0,78,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,114,0,0,0,97,0,0,0,100,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,40,0,0,0,69,0,0,0,84,0,0,0,69,0,0,0,78,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,53,0,0,0,53,0,0,0,53,0,0,0,48,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,52,0,0,0,32,0,0,0,84,0,0,0,101,0,0,0,108,0,0,0,101,0,0,0,84,0,0,0,101,0,0,0,120,0,0,0,116,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,87,0,0,0,97,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,105,0,0,0,119,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,82,0,0,0,86,0,0,0,32,0,0,0,73,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,65,0,0,0,108,0,0,0,112,0,0,0,104,0,0,0,97,0,0,0,98,0,0,0,101,0,0,0,116,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,46,0,0,0,32,0,0,0,53,0,0,0,44,0,0,0,32,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,87,0,0,0,101,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,110,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,112,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,54,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,32,0,0,0,40,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,65,0,0,0,53,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,101,0,0,0,103,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,55,0,0,0,45,0,0,0,98,0,0,0,105,0,0,0,116,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,49,0,0,0,32,0,0,0,84,0,0,0,46,0,0,0,54,0,0,0,49,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,57,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,32,0,0,0,54,0,0,0,57,0,0,0,51,0,0,0,55,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,110,0,0,0,45,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,99,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,65,0,0,0,99,0,0,0,99,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,71,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,110,0,0,0,121,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,68,0,0,0,101,0,0,0,110,0,0,0,109,0,0,0,97,0,0,0,114,0,0,0,107,0,0,0,45,0,0,0,78,0,0,0,111,0,0,0,114,0,0,0,119,0,0,0,97,0,0,0,121,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,105,0,0,0,110,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,45,0,0,0,83,0,0,0,119,0,0,0,101,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,116,0,0,0,97,0,0,0,108,0,0,0,121,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,65,0,0,0,109,0,0,0,101,0,0,0,114,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,45,0,0,0,83,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,56,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,75,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,100,0,0,0,111,0,0,0,109,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,75,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,107,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,32,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,100,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,50,0,0,0,57,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,70,0,0,0,114,0,0,0,97,0,0,0,110,0,0,0,99,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,52,0,0,0,50,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,99,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,52,0,0,0,50,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,71,0,0,0,114,0,0,0,101,0,0,0,101,0,0,0,107,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,52,0,0,0,50,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,51,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,100,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,51,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,97,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,54,0,0,0,54,0,0,0,32,0,0,0,82,0,0,0,117,0,0,0,115,0,0,0,115,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,82,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,82,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,55,0,0,0,49,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,73,0,0,0,99,0,0,0,101,0,0,0,108,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,99,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,56,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,82,0,0,0,117,0,0,0,115,0,0,0,115,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,84,0,0,0,117,0,0,0,114,0,0,0,107,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,50,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,76,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,49,0,0,0,47,0,0,0,79,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,32,0,0,0,83,0,0,0,121,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,32,0,0,0,40,0,0,0,49,0,0,0,48,0,0,0,52,0,0,0,55,0,0,0,32,0,0,0,43,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,32,0,0,0,115,0,0,0,121,0,0,0,109,0,0,0,98,0,0,0,111,0,0,0,108,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,51,0,0,0,50,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,74,0,0,0,73,0,0,0,83,0,0,0,32,0,0,0,48,0,0,0,50,0,0,0,48,0,0,0,56,0,0,0,45,0,0,0,49,0,0,0,57,0,0,0,57,0,0,0,48,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,48,0,0,0,50,0,0,0,49,0,0,0,50,0,0,0,45,0,0,0,49,0,0,0,57,0,0,0,57,0,0,0,48,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,45,0,0,0,56,0,0,0,48,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,48,0,0,0,57,0,0,0,52,0,0,0,57,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,87,0,0,0,97,0,0,0,110,0,0,0,115,0,0,0,117,0,0,0,110,0,0,0,103,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,49,0,0,0,48,0,0,0,50,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,66,0,0,0,77,0,0,0,32,0,0,0,69,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,73,0,0,0,67,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,83,0,0,0,101,0,0,0,114,0,0,0,98,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,45,0,0,0,66,0,0,0,117,0,0,0,108,0,0,0,103,0,0,0,97,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,49,0,0,0,48,0,0,0,50,0,0,0,55,0,0,0,32,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,100,0,0,0,47,0,0,0,69,0,0,0,120,0,0,0,116,0,0,0,32,0,0,0,65,0,0,0,108,0,0,0,112,0,0,0,104,0,0,0,97,0,0,0,32,0,0,0,76,0,0,0,111,0,0,0,119,0,0,0,101,0,0,0,114,0,0,0,99,0,0,0,97,0,0,0,115,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,49,0,0,0,56,0,0,0,54,0,0,0,54,0,0,0,32,0,0,0,85,0,0,0,107,0,0,0,114,0,0,0,97,0,0,0,105,0,0,0,110,0,0,0,105,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,85,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,121,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,32,0,0,0,40,0,0,0,75,0,0,0,79,0,0,0,73,0,0,0,56,0,0,0,45,0,0,0,85,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,50,0,0,0,57,0,0,0,48,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,69,0,0,0,117,0,0,0,114,0,0,0,111,0,0,0,112,0,0,0,97,0,0,0,32,0,0,0,51,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,51,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,32,0,0,0,56,0,0,0,56,0,0,0,53,0,0,0,57,0,0,0,45,0,0,0,56,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,59,0,0,0,32,0,0,0,72,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,101,0,0,0,119,0,0,0,32,0,0,0,40,0,0,0,73,0,0,0,83,0,0,0,79,0,0,0,45,0,0,0,76,0,0,0,111,0,0,0,103,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,108,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,49,0,0,0,57,0,0,0,51,0,0,0,50,0,0,0,32,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,32,0,0,0,74,0,0,0,97,0,0,0,112,0,0,0,97,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,49,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,49,0,0,0,57,0,0,0,52,0,0,0,57,0,0,0,32,0,0,0,69,0,0,0,85,0,0,0,67,0,0,0,32,0,0,0,75,0,0,0,111,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,110,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,50,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,72,0,0,0,90,0,0,0,45,0,0,0,71,0,0,0,66,0,0,0,50,0,0,0,51,0,0,0,49,0,0,0,50,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,72,0,0,0,90,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,52,0,0,0,57,0,0,0,51,0,0,0,54,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,32,0,0,0,88,0,0,0,80,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,58,0,0,0,32,0,0,0,71,0,0,0,66,0,0,0,49,0,0,0,56,0,0,0,48,0,0,0,51,0,0,0,48,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,40,0,0,0,52,0,0,0,32,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,41,0,0,0,59,0,0,0,32,0,0,0,67,0,0,0,104,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,83,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,40,0,0,0,71,0,0,0,66,0,0,0,49,0,0,0,56,0,0,0,48,0,0,0,51,0,0,0,48,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,50,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,68,0,0,0,101,0,0,0,118,0,0,0,97,0,0,0,110,0,0,0,97,0,0,0,103,0,0,0,97,0,0,0,114,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,51,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,66,0,0,0,101,0,0,0,110,0,0,0,103,0,0,0,97,0,0,0,108,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,52,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,84,0,0,0,97,0,0,0,109,0,0,0,105,0,0,0,108,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,53,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,84,0,0,0,101,0,0,0,108,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,54,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,65,0,0,0,115,0,0,0,115,0,0,0,97,0,0,0,109,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,55,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,79,0,0,0,114,0,0,0,105,0,0,0,121,0,0,0,97,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,56,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,75,0,0,0,97,0,0,0,110,0,0,0,110,0,0,0,97,0,0,0,100,0,0,0,97,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,48,0,0,0,57,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,77,0,0,0,97,0,0,0,108,0,0,0,97,0,0,0,121,0,0,0,97,0,0,0,108,0,0,0,97,0,0,0,109,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,71,0,0,0,117,0,0,0,106,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,53,0,0,0,55,0,0,0,48,0,0,0,49,0,0,0,49,0,0,0,32,0,0,0,73,0,0,0,83,0,0,0,67,0,0,0,73,0,0,0,73,0,0,0,32,0,0,0,80,0,0,0,117,0,0,0,110,0,0,0,106,0,0,0,97,0,0,0,98,0,0,0,105,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,108,0,0,0,108,0,0,0,111,0,0,0,119,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,86,0,0,0,105,0,0,0,115,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,70,0,0,0,111,0,0,0,120,0,0,0,80,0,0,0,114,0,0,0,111,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,54,0,0,0,50,0,0,0,48,0,0,0,32,0,0,0,77,0,0,0,97,0,0,0,122,0,0,0,111,0,0,0,118,0,0,0,105,0,0,0,97,0,0,0,32,0,0,0,40,0,0,0,80,0,0,0,111,0,0,0,108,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,41,0,0,0,32,0,0,0,77,0,0,0,83,0,0,0,45,0,0,0,68,0,0,0,79,0,0,0,83,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,56,0,0,0,57,0,0,0,53,0,0,0,32,0,0,0,75,0,0,0,97,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,107,0,0,0,253,0,0,0,32,0,0,0,40,0,0,0,67,0,0,0,122,0,0,0,101,0,0,0,99,0,0,0,104,0,0,0,41,0,0,0,32,0,0,0,77,0,0,0,83,0,0,0,45,0,0,0,68,0,0,0,79,0,0,0,83,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,66,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,78,0,0,0,111,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,115,0,0,0,104,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,98,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,41,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,108,0,0,0,108,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,115,0,0,0,115,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,10,0,0,0,40,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,45,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,105,0,0,0,114,0,0,0,115,0,0,0,41,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,118,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,117,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,114,0,0,0,111,0,0,0,112,0,0,0,112,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,116,0,0,0,104,0,0,0,115,0,0,0,10,0,0,0,96,0,0,0,46,0,0,0,47,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,47,0,0,0,60,0,0,0,67,0,0,0,79,0,0,0,68,0,0,0,69,0,0,0,80,0,0,0,65,0,0,0,71,0,0,0,69,0,0,0,62,0,0,0,46,0,0,0,84,0,0,0,66,0,0,0,76,0,0,0,96,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,70,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,97,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,115,0,0,0,116,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,96,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,46,0,0,0,84,0,0,0,66,0,0,0,76,0,0,0,96,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,62,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,54,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,54,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,55,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,67,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,56,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,65,0,0,0,70,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,57,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,56,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,65,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,57,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,66,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,65,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,67,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,66,0,0,0,56,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,68,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,68,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,69,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,66,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,55,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,10,0,0,0,10,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,99,0,0,0,104,0,0,0,32,0,0,0,105,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,54,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,96,0,0,0,83,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,46,0,0,0,102,0,0,0,114,0,0,0,111,0,0,0,109,0,0,0,67,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,40,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,54,0,0,0,41,0,0,0,96,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,118,0,0,0,105,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,118,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,97,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,87,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,45,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,101,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,32,0,0,0,98,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,101,0,0,0,112,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,111,0,0,0,32,0,0,0,98,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,111,0,0,0,117,0,0,0,114,0,0,0,99,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,110,0,0,0,100,0,0,0,111,0,0,0,119,0,0,0,115,0,0,0,44,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,115,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,111,0,0,0,116,0,0,0,110,0,0,0,101,0,0,0,116,0,0,0,47,0,0,0,77,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,69,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,46,0,0,0,99,0,0,0,115,0,0,0,96,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,65,0,0,0,102,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,115,0,0,0,97,0,0,0,118,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,114,0,0,0,100,0,0,0,32,0,0,0,111,0,0,0,117,0,0,0,116,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,96,0,0,0,111,0,0,0,117,0,0,0,116,0,0,0,96,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,111,0,0,0,116,0,0,0,110,0,0,0,101,0,0,0,116,0,0,0,46,0,0,0,115,0,0,0,104,0,0,0,96,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,111,0,0,0,99,0,0,0,101,0,0,0,115,0,0,0,115,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,117,0,0,0,108,0,0,0,116,0,0,0,115,0,0,0,46,0,0,0,32,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,32,0,0,0,66,0,0,0,117,0,0,0,105,0,0,0,108,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,110,0,0,0,106,0,0,0,115,0,0,0,96,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,103,0,0,0,117,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,44,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,97,0,0,0,100,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,114,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,112,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,10,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,74,0,0,0,83,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,82,0,0,0,97,0,0,0,119,0,0,0,32,0,0,0,67,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,68,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,103,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,105,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,114,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,120,0,0,0,105,0,0,0,109,0,0,0,117,0,0,0,109,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,10,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,100,0,0,0,105,0,0,0,115,0,0,0,116,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,117,0,0,0,105,0,0,0,115,0,0,0,104,0,0,0,32,0,0,0,40,0,0,0,109,0,0,0,97,0,0,0,120,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,96,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,70,0,0,0,68,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,82,0,0,0,69,0,0,0,80,0,0,0,76,0,0,0,65,0,0,0,67,0,0,0,69,0,0,0,77,0,0,0,69,0,0,0,78,0,0,0,84,0,0,0,32,0,0,0,67,0,0,0,72,0,0,0,65,0,0,0,82,0,0,0,65,0,0,0,67,0,0,0,84,0,0,0,69,0,0,0,82,0,0,0,41,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,112,0,0,0,108,0,0,0,97,0,0,0,99,0,0,0,101,0,0,0,104,0,0,0,111,0,0,0,108,0,0,0,100,0,0,0,101,0,0,0,114,0,0,0,10,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,110,0,0,0,111,0,0,0,116,0,0,0,32,0,0,0,115,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,105,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,109,0,0,0,97,0,0,0,112,0,0,0,32,0,0,0,40,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,97,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,44,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,48,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,110,0,0,0,111,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,10,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,70,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,83,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,100,0,0,0,101,0,0,0,97,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,114,0,0,0,97,0,0,0,119,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,50,0,0,0,53,0,0,0,54,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,46,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,96,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,101,0,0,0,108,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,109,0,0,0,101,0,0,0,114,0,0,0,101,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,115,0,0,0,112,0,0,0,108,0,0,0,105,0,0,0,116,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,44,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,96,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,101,0,0,0,118,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,68,0,0,0,66,0,0,0,67,0,0,0,83,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,115,0,0,0,105,0,0,0,109,0,0,0,105,0,0,0,108,0,0,0,97,0,0,0,114,0,0,0,44,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,99,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,112,0,0,0,97,0,0,0,99,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,115,0,0,0,108,0,0,0,105,0,0,0,99,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,117,0,0,0,110,0,0,0,107,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,50,0,0,0,53,0,0,0,54,0,0,0,32,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,40,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,115,0,0,0,10,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,111,0,0,0,110,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,111,0,0,0,115,0,0,0,101,0,0,0,32,0,0,0,104,0,0,0,105,0,0,0,103,0,0,0,104,0,0,0,45,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,112,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,103,0,0,0,101,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,103,0,0,0,121,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,99,0,0,0,116,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,45,0,0,0,111,0,0,0,102,0,0,0,45,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,115,0,0,0,32,0,0,0,115,0,0,0,111,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,96,0,0,0,100,0,0,0,100,0,0,0,91,0,0,0,104,0,0,0,105,0,0,0,103,0,0,0,104,0,0,0,93,0,0,0,91,0,0,0,108,0,0,0,111,0,0,0,119,0,0,0,93,0,0,0,96,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,10,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,115,0,0,0,111,0,0,0,99,0,0,0,105,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,98,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,114,0,0,0,117,0,0,0,110,0,0,0,116,0,0,0,105,0,0,0,109,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,111,0,0,0,32,0,0,0,121,0,0,0,105,0,0,0,101,0,0,0,108,0,0,0,100,0,0,0,10,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,111,0,0,0,98,0,0,0,106,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,32,0,0,0,40,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,111,0,0,0,98,0,0,0,106,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,32,0,0,0,101,0,0,0,118,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,41,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,115,0,0,0,104,0,0,0,96,0,0,0,32,0,0,0,103,0,0,0,101,0,0,0,110,0,0,0,101,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,117,0,0,0,115,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,98,0,0,0,121,0,0,0,32,0,0,0,96,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,46,0,0,0,110,0,0,0,106,0,0,0,115,0,0,0,96,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,114,0,0,0,97,0,0,0,119,0,0,0,32,0,0,0,85,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,84,0,0,0,88,0,0,0,84,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,108,0,0,0,117,0,0,0,109,0,0,0,110,0,0,0,97,0,0,0,114,0,0,0,58,0,0,0,32,0,0,0,96,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,117,0,0,0,110,0,0,0,105,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,35,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,96,0,0,0,46,0,0,0,32,0,0,0,32,0,0,0,70,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,97,0,0,0,109,0,0,0,112,0,0,0,108,0,0,0,101,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,108,0,0,0,97,0,0,0,115,0,0,0,116,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,32,0,0,0,108,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,10,0,0,0,116,0,0,0,101,0,0,0,120,0,0,0,116,0,0,0,32,0,0,0,102,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,82,0,0,0,79,0,0,0,77,0,0,0,65,0,0,0,78,0,0,0,46,0,0,0,84,0,0,0,88,0,0,0,84,0,0,0,96,0,0,0,32,0,0,0,40,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,67,0,0,0,80,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,41,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,62,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,54,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,54,0,0,0,9,0,0,0,35,0,0,0,77,0,0,0,79,0,0,0,68,0,0,0,73,0,0,0,70,0,0,0,73,0,0,0,69,0,0,0,82,0,0,0,32,0,0,0,76,0,0,0,69,0,0,0,84,0,0,0,84,0,0,0,69,0,0,0,82,0,0,0,32,0,0,0,67,0,0,0,73,0,0,0,82,0,0,0,67,0,0,0,85,0,0,0,77,0,0,0,70,0,0,0,76,0,0,0,69,0,0,0,88,0,0,0,32,0,0,0,65,0,0,0,67,0,0,0,67,0,0,0,69,0,0,0,78,0,0,0,84,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,55,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,67,0,0,0,9,0,0,0,35,0,0,0,83,0,0,0,77,0,0,0,65,0,0,0,76,0,0,0,76,0,0,0,32,0,0,0,84,0,0,0,73,0,0,0,76,0,0,0,68,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,56,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,65,0,0,0,70,0,0,0,9,0,0,0,35,0,0,0,77,0,0,0,65,0,0,0,67,0,0,0,82,0,0,0,79,0,0,0,78,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,57,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,56,0,0,0,9,0,0,0,35,0,0,0,66,0,0,0,82,0,0,0,69,0,0,0,86,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,65,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,57,0,0,0,9,0,0,0,35,0,0,0,68,0,0,0,79,0,0,0,84,0,0,0,32,0,0,0,65,0,0,0,66,0,0,0,79,0,0,0,86,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,66,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,65,0,0,0,9,0,0,0,35,0,0,0,82,0,0,0,73,0,0,0,78,0,0,0,71,0,0,0,32,0,0,0,65,0,0,0,66,0,0,0,79,0,0,0,86,0,0,0,69,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,67,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,48,0,0,0,66,0,0,0,56,0,0,0,9,0,0,0,35,0,0,0,67,0,0,0,69,0,0,0,68,0,0,0,73,0,0,0,76,0,0,0,76,0,0,0,65,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,68,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,68,0,0,0,9,0,0,0,35,0,0,0,68,0,0,0,79,0,0,0,85,0,0,0,66,0,0,0,76,0,0,0,69,0,0,0,32,0,0,0,65,0,0,0,67,0,0,0,85,0,0,0,84,0,0,0,69,0,0,0,32,0,0,0,65,0,0,0,67,0,0,0,67,0,0,0,69,0,0,0,78,0,0,0,84,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,69,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,68,0,0,0,66,0,0,0,9,0,0,0,35,0,0,0,79,0,0,0,71,0,0,0,79,0,0,0,78,0,0,0,69,0,0,0,75,0,0,0,10,0,0,0,48,0,0,0,120,0,0,0,70,0,0,0,70,0,0,0,9,0,0,0,48,0,0,0,120,0,0,0,48,0,0,0,50,0,0,0,67,0,0,0,55,0,0,0,9,0,0,0,35,0,0,0,67,0,0,0,65,0,0,0,82,0,0,0,79,0,0,0,78,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,10,0,0,0,10,0,0,0,73,0,0,0,110,0,0,0,32,0,0,0,112,0,0,0,114,0,0,0,111,0,0,0,99,0,0,0,101,0,0,0,115,0,0,0,115,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,44,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,109,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,40,0,0,0,97,0,0,0,102,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,35,0,0,0,96,0,0,0,41,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,112,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,100,0,0,0,10,0,0,0,101,0,0,0,108,0,0,0,101,0,0,0,109,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,40,0,0,0,108,0,0,0,105,0,0,0,107,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,48,0,0,0,120,0,0,0,55,0,0,0,70,0,0,0,96,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,32,0,0,0,67,0,0,0,80,0,0,0,32,0,0,0,49,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,41,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,109,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,100,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,35,0,0,0,32,0,0,0,85,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,105,0,0,0,116,0,0,0,105,0,0,0,101,0,0,0,115,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,102,0,0,0,117,0,0,0,110,0,0,0,99,0,0,0,116,0,0,0,105,0,0,0,111,0,0,0,110,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,101,0,0,0,32,0,0,0,107,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,32,0,0,0,97,0,0,0,32,0,0,0,115,0,0,0,101,0,0,0,112,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,116,0,0,0,101,0,0,0,32,0,0,0,115,0,0,0,99,0,0,0,114,0,0,0,105,0,0,0,112,0,0,0,116,0,0,0,32,0,0,0,40,0,0,0,96,0,0,0,99,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,105,0,0,0,108,0,0,0,115,0,0,0,46,0,0,0,106,0,0,0,115,0,0,0,96,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,66,0,0,0,111,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,97,0,0,0,110,0,0,0,100,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,97,0,0,0,108,0,0,0,32,0,0,0,119,0,0,0,105,0,0,0,116,0,0,0,104,0,0,0,32,0,0,0,100,0,0,0,97,0,0,0,116,0,0,0,97,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,112,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,101,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,100,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,58,0,0,0,10,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,83,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,40,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,74,0,0,0,83,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,44,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,112,0,0,0,114,0,0,0,101,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,85,0,0,0,67,0,0,0,83,0,0,0,50,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,115,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,65,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,40,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,97,0,0,0,121,0,0,0,32,0,0,0,111,0,0,0,102,0,0,0,32,0,0,0,74,0,0,0,83,0,0,0,32,0,0,0,83,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,32,0,0,0,99,0,0,0,104,0,0,0,97,0,0,0,114,0,0,0,97,0,0,0,99,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,44,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,110,0,0,0,117,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,115,0,0,0,41,0,0,0,10,0,0,0,45,0,0,0,32,0,0,0,66,0,0,0,117,0,0,0,102,0,0,0,102,0,0,0,101,0,0,0,114,0,0,0,32,0,0,0,40,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,85,0,0,0,84,0,0,0,70,0,0,0,45,0,0,0,56,0,0,0,32,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,105,0,0,0,110,0,0,0,103,0,0,0,44,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,32,0,0,0,101,0,0,0,120,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,115,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,112,0,0,0,111,0,0,0,105,0,0,0,110,0,0,0,116,0,0,0,115,0,0,0,47,0,0,0,98,0,0,0,121,0,0,0,116,0,0,0,101,0,0,0,115,0,0,0,41,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,84,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,96,0,0,0,111,0,0,0,102,0,0,0,109,0,0,0,116,0,0,0,96,0,0,0,32,0,0,0,118,0,0,0,97,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,98,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,99,0,0,0,111,0,0,0,110,0,0,0,116,0,0,0,114,0,0,0,111,0,0,0,108,0,0,0,115,0,0,0,32,0,0,0,96,0,0,0,101,0,0,0,110,0,0,0,99,0,0,0,111,0,0,0,100,0,0,0,101,0,0,0,96,0,0,0,32,0,0,0,111,0,0,0,117,0,0,0,116,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,40,0,0,0,96,0,0,0,115,0,0,0,116,0,0,0,114,0,0,0,96,0,0,0,44,0,0,0,32,0,0,0,96,0,0,0,97,0,0,0,114,0,0,0,114,0,0,0,96,0,0,0,32,0,0,0,114,0,0,0,101,0,0,0,115,0,0,0,112,0,0,0,101,0,0,0,99,0,0,0,116,0,0,0,105,0,0,0,118,0,0,0,101,0,0,0,108,0,0,0,121,0,0,0,41,0,0,0,10,0,0,0,119,0,0,0,104,0,0,0,105,0,0,0,108,0,0,0,101,0,0,0,32,0,0,0,116,0,0,0,104,0,0,0,101,0,0,0,32,0,0,0,105,0,0,0,110,0,0,0,112,0,0,0,117,0,0,0,116,0,0,0,32,0,0,0,102,0,0,0,111,0,0,0,114,0,0,0,109,0,0,0,97,0,0,0,116,0,0,0,32,0,0,0,105,0,0,0,115,0,0,0,32,0,0,0,97,0,0,0,117,0,0,0,116,0,0,0,111,0,0,0,109,0,0,0,97,0,0,0,116,0,0,0,105,0,0,0,99,0,0,0,97,0,0,0,108,0,0,0,108,0,0,0,121,0,0,0,32,0,0,0,100,0,0,0,101,0,0,0,116,0,0,0,101,0,0,0,114,0,0,0,109,0,0,0,105,0,0,0,110,0,0,0,101,0,0,0,100,0,0,0,46,0,0,0,10,0,0,0,10,0,0,0,35,0,0,0,32,0,0,0,78,0,0,0,105,0,0,0,116,0,0,0,116,0,0,0,121,0,0,0,32,0,0,0,71,0,0,0,114,0,0,0,105,0,0,0,116,0,0,0,116,0,0,0,121,0,0,0,10,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,62,0,0,0,46,0,0,0,118,0,0,0,111,0,0,0,99,0,0,0,114,0,0,0,99,0,0,0,10,0,0,0,123,0,0,0,32,0,0,0,34,0,0,0,112,0,0,0,111,0,0,0,115,0,0,0,116,0,0,0,34,0,0,0,58,0,0,0,32,0,0,0,34,0,0,0,109,0,0,0,97,0,0,0,107,0,0,0,101,0,0,0,32,0,0,0,106,0,0,0,115,0,0,0,34,0,0,0,32,0,0,0,125,0,0,0,10,0,0,0,96,0,0,0,96,0,0,0,96,0,0,0,10]}
;
